c MFC c
c MFC c       Written and contributed by:
c MFC c
c MFC c	James J. Vincent
c MFC c	Kenneth M. Merz
c MFC c	Department of Chemistry
c MFC c       Pennsylvania State University           
c MFC c	July, 1994
c MFC c
c MFC c     COPYRIGHT 1994, Pennsylvania State University.
c MFC c                 All rights reserved.  
c MFC c
c MFC c     This software is covered by the AMBER license 
c MFC c     agreement which contains restrictions on its use, 
c MFC c     disclosure, and duplication!
c MFC c
c MFC c     Type the MPI parameters (necessary for implicit none)
c MFC       integer MPI_COMM_WORLD, MPI_SUM, MPI_INTEGER2
c MFC       integer MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION
c MFC       integer MPI_STATUS_SIZE
c MFC 
c MFC c     Coerce MPI constants to PVM type values
c MFC       parameter (MPI_COMM_WORLD=0)
c MFC       parameter (MPI_SUM=0)
c MFC       parameter (MPI_STATUS_SIZE=3)
c MFC 
c MFC c
c MFC C     Values are PVM type values 
c MFC C     Not a very standard way of doing this - need to change these
c MFC C     if fpvm.h values change
c MFC c
c MFC       parameter (MPI_INTEGER2=2)
c MFC       parameter (MPI_INTEGER=3)
c MFC       parameter (MPI_REAL=4)
c MFC       parameter (MPI_DOUBLE_PRECISION=6)
c MFC 
c MFC ifdef T3D
c MFC  ifndef MPI_BARRIER
c MFC   define MPI_BARRIER(_A_,_B_) barrier()
c MFC   define mpi_barrier(_A_,_B_) barrier()
c MFC  endif
c MFC endif





       integer MPI_SUCCESS,MPI_ERR_BUFFER,MPI_ERR_COUNT,MPI_ERR_TYPE,
     $ MPI_ERR_TAG,MPI_ERR_COMM,MPI_ERR_RANK,MPI_ERR_ROOT,MPI_ERR_GROUP,
     $ MPI_ERR_OP,MPI_ERR_TOPOLOGY,MPI_ERR_DIMS,MPI_ERR_ARG,
     $ MPI_ERR_UNKNOWN,MPI_ERR_TRUNCATE,MPI_ERR_OTHER,MPI_ERR_INTERN,
     $ MPI_ERR_IN_STATUS,MPI_ERR_PENDING,MPI_ERR_REQUEST,
     $ MPI_ERR_LASTCODE
       parameter (MPI_SUCCESS=0,MPI_ERR_BUFFER=1,MPI_ERR_COUNT=2,
     $ MPI_ERR_TYPE=3,MPI_ERR_TAG=4,MPI_ERR_COMM=5,MPI_ERR_RANK=6,
     $ MPI_ERR_ROOT=7,MPI_ERR_GROUP=8,MPI_ERR_OP=9,MPI_ERR_TOPOLOGY=10,
     $ MPI_ERR_DIMS=11,MPI_ERR_ARG=12,MPI_ERR_UNKNOWN=13,
     $ MPI_ERR_TRUNCATE=14,MPI_ERR_OTHER=15,MPI_ERR_INTERN=16,
     $ MPI_ERR_IN_STATUS=17,MPI_ERR_PENDING=18,MPI_ERR_REQUEST=19,
     $ MPI_ERR_LASTCODE=4114)
C
       integer MPI_UNDEFINED
       parameter (MPI_UNDEFINED = (-32766))
C
       INTEGER MPI_GRAPH, MPI_CART
       PARAMETER (MPI_GRAPH = 1, MPI_CART = 2)
       INTEGER  MPI_PROC_NULL
       PARAMETER ( MPI_PROC_NULL = (-1) )
C
       INTEGER MPI_BSEND_OVERHEAD
       PARAMETER ( MPI_BSEND_OVERHEAD = 512 )

      INTEGER MPI_SOURCE, MPI_TAG, MPI_ERROR
      PARAMETER(MPI_SOURCE=2, MPI_TAG=3, MPI_ERROR=4)
      INTEGER MPI_STATUS_SIZE
      PARAMETER (MPI_STATUS_SIZE=4)
      INTEGER MPI_MAX_PROCESSOR_NAME, MPI_MAX_ERROR_STRING
      PARAMETER (MPI_MAX_PROCESSOR_NAME=256,
     $           MPI_MAX_ERROR_STRING=256)
C
      INTEGER MPI_COMM_NULL
      PARAMETER (MPI_COMM_NULL=-1)
c
      INTEGER MPI_DATATYPE_NULL
      PARAMETER (MPI_DATATYPE_NULL = -1)
      
      INTEGER MPI_ERRHANDLER_NULL
      PARAMETER (MPI_ERRHANDLER_NULL = -1)
      
      INTEGER MPI_GROUP_NULL
      PARAMETER (MPI_GROUP_NULL = -1)
      
      INTEGER MPI_KEYVAL_INVALID
      PARAMETER (MPI_KEYVAL_INVALID = -1)
      
      INTEGER MPI_REQUEST_NULL
      PARAMETER (MPI_REQUEST_NULL = 0)
C 
      INTEGER MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR, MPI_UNEQUAL
      PARAMETER (MPI_IDENT=0, MPI_CONGRUENT=1, MPI_SIMILAR=2,
     $          MPI_UNEQUAL=3)
C     
C     We handle datatypes by putting the variables that hold them into
C     common.  This way, a Fortran program can directly use the various
C     datatypes and can even give them to C programs.
C
C     MPI_BOTTOM needs to be a known address; here we put it at the
C     beginning of the common block.  The point-to-point and collective
C     routines know about MPI_BOTTOM, but MPI_TYPE_STRUCT as yet does not.
C
C     The types MPI_INTEGER1,2,4 and MPI_REAL4,8 are OPTIONAL.
C     Their values are zero if they are not available.  Note that
C     using these reduces the portability of code (though may enhance
C     portability between Crays and other systems)
C
      integer MPI_TAG_UB, MPI_HOST, MPI_IO

      integer MPI_INTEGER, MPI_REAL, MPI_DOUBLE_PRECISION, 
     $        MPI_COMPLEX, MPI_DOUBLE_COMPLEX,
     $        MPI_LOGICAL, MPI_CHARACTER, MPI_BYTE, 
     $        MPI_INTEGER1, MPI_INTEGER2, MPI_INTEGER4, 
     $        MPI_REAL2, MPI_REAL4, MPI_REAL8,
     $        MPI_UB, MPI_LB, 
     $        MPI_2INTEGER, MPI_2REAL, MPI_2DOUBLE_PRECISION, 
     $        MPI_2COMPLEX, MPI_2DOUBLE_COMPLEX,
     $        MPI_PACKED, MPI_WTIME_IS_GLOBAL
      parameter (MPI_INTEGER = 14)
      parameter (MPI_REAL = 15)
      parameter (MPI_DOUBLE_PRECISION = 16)
      parameter (MPI_COMPLEX = 17)
      parameter (MPI_DOUBLE_COMPLEX = 18)
      parameter (MPI_LOGICAL = 19)
      parameter (MPI_CHARACTER = 20)
      parameter (MPI_BYTE = 21)
      parameter (MPI_PACKED = 22)
      parameter (MPI_INTEGER1 = 23)
      parameter (MPI_INTEGER2 = 24)
      parameter (MPI_INTEGER4 = 25)
      parameter (MPI_REAL2 = 26)
      parameter (MPI_REAL4 = 27)
      parameter (MPI_REAL8 = 28)
      parameter (MPI_UB = 29)
      parameter (MPI_LB = 30)
      parameter (MPI_2REAL = 37)
      parameter (MPI_2DOUBLE_PRECISION = 38)
      parameter (MPI_2INTEGER = 39)
      parameter (MPI_2COMPLEX = 40)
      parameter (MPI_2DOUBLE_COMPLEX = 41)

      integer MPI_COMM_WORLD, MPI_COMM_SELF, MPI_GROUP_EMPTY
      parameter (MPI_COMM_WORLD = 0)
      parameter (MPI_COMM_SELF = 1)
      parameter (MPI_GROUP_EMPTY = 0)

      integer MPI_SUM, MPI_MAX, MPI_MIN, MPI_PROD, MPI_LAND, MPI_BAND,
     $     MPI_LOR, MPI_BOR, MPI_LXOR, MPI_BXOR, MPI_MINLOC, MPI_MAXLOC, 
     $     MPI_OP_NULL

      parameter (MPI_SUM = 2 )
      parameter (MPI_MAX = 0 )
      parameter (MPI_MIN = 1 )
      parameter (MPI_PROD = 3 )
      parameter (MPI_LAND = 9 )
      parameter (MPI_BAND = 6 )
      parameter (MPI_LOR = 10 )
      parameter (MPI_BOR = 7 )
      parameter (MPI_LXOR = 11 )
      parameter (MPI_BXOR = 9 )
      parameter (MPI_MINLOC = 4 )
      parameter (MPI_MAXLOC = 5 )
      parameter (MPI_OP_NULL = -1 )
c      parameter (MPI_ =  )




      integer MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN

      integer MPI_BOTTOM
      common /MPIPRIV/ MPI_BOTTOM
      save /mpipriv/

      integer MPI_ANY_SOURCE,MPI_ANY_TAG
      parameter (MPI_ANY_SOURCE = (-2))
      parameter (MPI_ANY_TAG = (-1))


