#include <stdio.h>
#include <stdlib.h>

/* tec3: a simple wrapper to the globalexit routine.  The Fortran
 * interface unfortunately does not resolve this routine.
 */

   int
GLOBALEXIT(int *ierr)
{
  globalexit( *ierr );
}

/* tec3: FORTRAN on the MPP doesn't resolve the system call,
 * hence the wrapper below is provided...
 */

   void
SYSTEM(char *command)
{
  if (system(NULL) == NULL) {
    printf("No command processor exists\n");
    return;
  }
  system(command);
}
