c-----------------------------------------------------------------------
      SUBROUTINE ATMGET(NAT,IAT,JAT,KAT,LAT,JOIN,ITREE,FINE)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL FINE
C
C     ----- ROUTINE TO GET THE UPWARD TREE CONNECTION FOR IAT -----
C
      DIMENSION IA(4),JOIN(*),ITREE(*)
      DATA IEND,IBRCH/4HE    ,4HB    /
C
      IA(1) = IAT
      DO 100 I = 2,4
      IATJ = IA(I-1)
      DO 120 J = 1,NAT
      IF(JOIN(J).NE.IATJ) GO TO 120
      IF(ITREE(J).EQ.IEND .OR. ITREE(J).EQ.IBRCH) GO TO 120
      IA(I) = J
      GO TO 100
  120 CONTINUE
      IA(I) = JOIN(IATJ)
      IF(IA(I).LE.0) GO TO 140
  100 CONTINUE
      IAT = IA(1)
      JAT = IA(2)
      KAT = IA(3)
      LAT = IA(4)
      GO TO 160
  140 CONTINUE
      FINE = .FALSE.
  160 CONTINUE
      RETURN
      END
