c-----------------------------------------------------------------------
      SUBROUTINE BANGLE(I,J,K,X,Y,Z,VAL,INDEX)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      DIMENSION X(*),Y(*),Z(*)
      DIMENSION XA(3),XB(3)
C
C     ----- COMPUTES ANGLE BETWEEN ATOMS I J K -----
C           INDEX=0 ANGLE RETURNED IN RADIANS
C                =1 ANGLE RETURNED IN DEGREES
C
      DATA CONVV/57.295779E0/
C
      XA(1) = X(I)-X(J)
      XA(2) = Y(I)-Y(J)
      XA(3) = Z(I)-Z(J)
      XB(1) = X(K)-X(J)
      XB(2) = Y(K)-Y(J)
      XB(3) = Z(K)-Z(J)
      DOT=XA(1)*XB(1)+XA(2)*XB(2)+XA(3)*XB(3)
      DUMA = XA(1)**2+XA(2)**2+XA(3)**2
      DUMB = XB(1)**2+XB(2)**2+XB(3)**2
      DOT=DOT/SQRT(DUMA*DUMB)
      IF(DOT.GT.1.0) DOT=1.0
      IF(DOT.LT.-1.0) DOT=-1.0
      VAL=ACOS(DOT)
      IF(INDEX.EQ.0) GO TO 100
      VAL=VAL*CONVV
  100 CONTINUE
      RETURN
      END
