c-----------------------------------------------------------------------
      SUBROUTINE CALDIH
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CALCULATES ARBITRARY INTERNAL COORDINATES -----
C
#include "sizes.h"
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      DIMENSION KB(80)
C
      IONE = 1
      WRITE(IOUT,38)
      DO 10 II = 1,1000
C
      READ(IN,11) KB
      IS = 0
      CALL FINDNI(KB,IS,IAT1)
      IF(IS.EQ.1000) RETURN
C
      IF(IAT1.LE.0) GO TO 13
      CALL FINDNI(KB,IS,IAT2)
      IF(IAT2.LE.0.OR.IS.EQ.1000) GO TO 13
      CALL FINDNI(KB,IS,IAT3)
      IF(IS.NE.1000) GO TO 40
      CALL DIST(IAT1,IAT2,X,Y,Z,STORE)
      WRITE(IOUT,200) IGRAPH(IAT1),IAT1,IGRAPH(IAT2),IAT2,STORE
      GO TO 10
   40 CONTINUE
      IF(IAT3.LE.0) GO TO 13
      CALL FINDNI(KB,IS,IAT4)
      IF(IS.NE.1000) GO TO 41
      CALL BANGLE(IAT1,IAT2,IAT3,X,Y,Z,STORE,IONE)
      WRITE(IOUT,220) IGRAPH(IAT1),IAT1,IGRAPH(IAT2),IAT2,
     $                 IGRAPH(IAT3),IAT3,STORE
      GO TO 10
   41 CONTINUE
      IF(IAT4.LE.0) GO TO 13
      CALL TORS(IAT1,IAT2,IAT3,IAT4,X,Y,Z,ANGLE)
      WRITE(IOUT,35) IGRAPH(IAT1),IAT1,IGRAPH(IAT2),IAT2,
     $                IGRAPH(IAT3),IAT3,IGRAPH(IAT4),IAT4,ANGLE
      GO TO 10
   13 CONTINUE
      WRITE(IOUT,33) KB
   10 CONTINUE
      RETURN
   38 FORMAT(/ / /,20X,'***** INTERNAL COORDINATE CALCULATIONS ****',
     .         / /)
   11 FORMAT(80A1)
  200 FORMAT(5X,'BOND LENGTH',2X,A4,'(',I4,') - ',A4,'(',
     $       I4,')',3X,' = ',F7.3,/)
  220 FORMAT(5X,'ANGLE',2X,A4,'(',I4,') -',A4,'(',
     $       I4,') -',A4,'(',I4,')',3X,' = ',F7.3,/)
   35 FORMAT(5X,'DIHEDRAL',2X,A4,'(',I4,') - '
     $       ,A4,'(',I4,') -',A4,'(',I4,') -',A4,'(',I4,')',2X,
     $       ' = ',F7.3,/)
   33 FORMAT('PROBLEMS WITH CARD -',3X,80A1,/)
      END
