c-----------------------------------------------------------------------
      PROGRAM EDIT
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995 ,1997                **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c
c     AMBER 5 EDIT  
c
c
#include "sizes.h"
c
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     $              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $  cp(maxwat,3)
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
c
      COMMON/CONST/PI,CONV,CONVV
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/OPEDIT/IDBL,IDIREC,IOPTF
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
#include "files.h"
C
      DATA KQUIT /3HQUI /
      DATA IOMIT /4HOMIT/
      DATA IXYZ /3HXYZ/
      DATA IINT /3HINT/
      DATA IXRAY /3HXRA /
      DATA ICION /3HCIO  /
      DATA IFOR /3HFOR /
      DATA IBIN /3HBIN /
      DATA IFREE /3HFRE /
      DATA IALL /3HALL /
      DATA IABC /3HABC /
      DATA IGAUS /3HGAU  /
      DATA IDIH /3HDIH /
      DATA IPUCK /3HPUC /
      DATA ITELL /3HTEL /
      DATA ICHAR /3HCHA /
      DATA KSOL /3HSOL /
      DATA KBOX /3HBOX/
      DATA KOCT /3HOCT/
      DATA KWADD/3HADD /
      DATA Kbox4/3HBX4 /
      data kwater/3hWAT/
      data kflopp/3hFLO/
      data kflob /3hFLB/
      data ktiprp/3hTP4/
      data kgen/3hGEN/
      DATA IBLANK/3H    /
c
C
C     ----- EVALUATE SOME CONSTANTS -----
C
      PI = 4.0*ATAN(1.0)
      CONV = PI/180.0E0
      CONVV = 180.0E0/PI
      IONE = 1
c
c     ----- octahedron box 'off' by default -----
c
      ioct = 0
C
C     ----- INITIALIZE THE IO UNITS -----
C
      IN = 5
      IN2 = 10
      IN3 = 15
      IN4 = 20
      IN5 = 25
C
      IOUT = 6
      IPUNCH = 7
      IOUTB = 12
      IOUTC = 18
      IOUTD = 24
C
C     --- Get file Names ---
C
      call edtfil
c
c     subr amopen(lun,   fname,fstat,fform,facc)
c
c     --- Diagnostics Output ---
c
      if(output.ne.'screen')then
         call amopen(iout, output, owrite,  'F',  'W')
      endif
c
c     --- Input ---
c
      call amopen(in,    input, 'O',  'F',  'R')
c
c     --- binary EDIT topology file ---
c
      call amopen(ioutb,edtbin, owrite,  'U',  'W')
C
C     ----- READ THE CONTROL FILE -----
C
      WRITE(IOUT,9108)
      if (owrite.eq.'U') write(6, '(2x,a)') '[-O]verwriting output'
      READ(IN,9) ITITL
      WRITE(IOUT,200) ITITL
C
C     ----- FLAGS FOR OUTPUT -----
C
C           IWO = 0 PRINT R,THETA,PHI FOR EACH ATOM
C           IWN = 1 PRINT NONBONDED EXCLUSIONS FOR ALL ATOMS
C           IWA = 1 PRINT BOND LENGTH,BOND ANGLE,DIHEDRAL ARRAYS
C
      READ(IN,10) IWO,IWN,IWA,ilink
c
c     --- binary LINK topology file ---
c
      if(ilink.eq.0)then
         call amopen(in2,  lnkbin, 'O',  'U',  'R')
         CALL READIN
         CALL CLOSC(IN2)
      endif
      WRITE(IOUT,204) (ITITL1(I),I = 1,20)
      DO 305 I = 1,20
  305 ITITL(I) = ITITL1(I)
C
C     ----- GRAND LOOP FOR THE EDIT PROGRAM -----
C
      DO 129 LL = 1,1000
C
C       ----- DIMENSION R,THETA,PHI,AND JOIN ARRAYS 3 MORE THAN MAXIMUM
C             OF ATOMS.THESE EXTRA ATOMS ARE USED IN CONVERSION TO
C             INTERNAL AND CARTESIAN COORDINATES -----
C
C             NUMBER OF ATOMS CAN CHANGE WHEN ADDING COUNTERIONS, ETC.
C             SO THE THREE END ATOMS ARE ADDED EACH TIME
C
        IP1 = NTOTAT+1
        IP2 = NTOTAT+2
        IP3 = NTOTAT+3
        IF(ip3.GT.MAXATM) then
           write(iout,2000) 'Atoms', ip3, 'MAXATM', MAXATM
           call mexit(iout, 1)
        endif   
        R(IP1) = 0.
        THETA(IP1) = 0.
        PHI(IP1) = 0.
        R(IP2) = 1.
        THETA(IP2) = 0.
        PHI(IP2) = 0.
        R(IP3) = 1.
        THETA(IP3) = 1.
        PHI(IP3) = 0.
        JOIN(IP3) = IP2
        JOIN(IP2) = IP1
C
C       ----- CHECK WHETHER COORDINATE TRANSFORMATION IS RELATIVE TO
C             FIRST 3 ATOMS OR LAST 3 DUMMY ATOMS -----
C
        CALL DIST(IONE,IP1,R,THETA,PHI,RDIST)
C
C       ----- IF FIRST ATOM IS NOT AT ORIGIN, THEN TRANSFORM RELATIVE
C             TO LAST 3 ATOMS -----
C
        IF(RDIST.GT.0.0001) IDUMPR = 1
        IF(RDIST.GT.0.0001) GO TO 147
C
C       ----- IF FIRST ATOM IS A DUMMY, ASSUME FIRST 3 ATOMS ARE DUMMYS
C             AND THERE WILL BE NO PROBLEM TRANSFORMING RELATIVE TO THESE
C
        IF(ISYMBL(1).EQ.ISYMDU) GO TO 147
        IDUMPR = 1
        IF(ITRES(1).NE.IINT) GO TO 147
C
C       ----- DISTORT COORDINATES SLIGHTLY SO NO PROBLEMS IN
C             TRANSFORMATION -----
C
        R(1) = 0.0001
        THETA(1) = 0.0001
        PHI(1) = 0.0001
        IF(ABS(THETA(2)).LE.0.0001) THETA(2) = 0.0001
  147   CONTINUE
c       IF(IDUMPR.EQ.1) WRITE(IOUT,151)
c       IF(IDUMPR.EQ.0) WRITE(IOUT,152)
C
C       ----- IFORMO  =  XYZ IF CARTESIAN COORDINATES ARE OUTPUT
C                     =  INT IF INTERNAL COORDINATES ARE OUTPUT
C
        READ(IN,16) IFORMO
        IF(IFORMO.EQ.KQUIT) GO TO 130
        IF(IFORMO.EQ.ICHAR) GO TO 620
        IF(IFORMO.EQ.IGAUS) GO TO 530
        IF(IFORMO.EQ.IDIH) GO TO 531
        IF(IFORMO.EQ.IPUCK) GO TO 532
        IF(IFORMO.EQ.ICION) GO TO 121
        IF(IFORMO.EQ.IABC) GO TO 173
        IF(IFORMO.EQ.ITELL) GO TO 533
        IF(IFORMO.EQ.KSOL) GO TO 720
        IF(IFORMO.EQ.KBOX) GO TO 730
        IF(IFORMO.EQ.KOCT) GO TO 731
        IF(IFORMO.EQ.KBOX4) GO TO 732
        IF(IFORMO.EQ.KFLOB) go to 733
        IF(IFORMO.EQ.KWATER) GO TO 760
        IF(IFORMO.EQ.KFLOPP) GO TO 762
        IF(IFORMO.EQ.KTIPRP) GO TO 764
        IF(IFORMO.EQ.KGEN) GO TO 766
        IF(IFORMO.EQ.IINT) WRITE(IOUT,21)
        IF(IFORMO.EQ.IXYZ) WRITE(IOUT,22)
        IF(IFORMO.EQ.IINT .OR. IFORMO.EQ.IXYZ) GO TO 60
        IF(IFORMO.EQ.IXRAY) GO TO 940
        IF(IFORMO.EQ.KWADD) GO TO 740
        write(6, '(1x,a,a)') 
     .           ' *** EXTRA NEWLINE OR UNKNOWN KEYWORD: ', iformo
        call mexit(6,1)
  940   CONTINUE
          write(iout,'(/,5x,a,/)') 'XRAY:'
C
C         ----- XRAY OPTION WILL BE DONE HERE. EITHER THE COORDNATES
C               WILL BE READ OR OUTPUT -----
C
C             IOPT = 0 READ IN NEW COORDINATES FROM FILE IN3
C                  = 1 OUTPUT COORDINATES ON FILE IOUTC WITH FORMAT
C                      OF FILE IN3
C                  = 2 OUTPUT ALL COORD. OF MOLECULE MOLNU ON FILE IOUTC
C            MOLNU =   MOLECULE WORKING WITH
C                      IF MOLNU .LE. 0 THEN ALL MOLECULES ARE USED
C
          READ(IN,61) IOPT,IOPTF,MOLNU,IDBL
          IF(IOPT.EQ.0) WRITE(IOUT,99) MOLNU,IN3
          IF(IOPT.EQ.1) WRITE(IOUT,78) MOLNU,IOUTC,IN3
          IF(IOPT.EQ.2) WRITE(IOUT,79) MOLNU,IOUTC
          IF(MOLNU.LE.0) WRITE(IOUT,236)
C
          IF (MOLNU.le.0) then
            NFIRST = 1
            NLAST = NTOTRS
          else
            NFIRST = NFRESM(MOLNU)
            NLAST = NFRESM(MOLNU+1)-1
          endif
c
c         Rev A mods: (G. Seibel)
c     --- Because of brain damage in addxry(), if user selects iopt=1,
c         we call addxry twice; first with iopt=0 then with iopt=2 ---
c        - This is a new feature of Rev A designed to match what
c          the documentation has claimed we do for years...
c        - Also note that IOPTS is now Gone.  The "new" pdb matching
c          code never worked right and has been trashed.
c
          if(iopt.eq.0) then
            CALL CONCOR(IINT,NFIRST,NLAST)
            CALL ADDXRY(NFIRST,NLAST,IOPT)
          elseif(iopt .eq. 1) then
            CALL CONCOR(IINT,NFIRST,NLAST)
            CALL ADDXRY(NFIRST,NLAST,0)
            DO 429 I = NFIRST,NLAST
                ITRES(I) = IXYZ
  429       CONTINUE
            CALL CONCOR(IXYZ,NFIRST,NLAST)
            CALL ADDXRY(NFIRST,NLAST,2)
          elseif(iopt .eq.2) then
            CALL CONCOR(IXYZ,NFIRST,NLAST)
            CALL ADDXRY(NFIRST,NLAST,IOPT)
          else
            write(iout,*)
     .          'EDIT/XRAY FATAL: IOPT must be 0, 1, or 2.'
            call mexit(iout, 1)
          endif
          DO 430 I = NFIRST,NLAST
            ITRES(I) = IXYZ
  430     CONTINUE
          GO TO 129
  173   CONTINUE
C
C         ----- ABC OPTION WILL BE DONE HERE -----
C
          write(iout,'(/,5x,a,/)') 'ABC:'
  174     continue
            READ(IN,195) MOLNU,IPART,IDIREC
            IF(IPART.EQ.KQUIT) GO TO 129
C
C           ----- IDIREC = 0 DEFAULT DIRECTION IS UP TREE TOWARD END
C                        = -1 DEFAULT DIRECTION IS DOWN TREE TOWARD 
C                             BEGINNING
C
            IF(IDIREC.EQ.0) WRITE(IOUT,148)
            IF(IDIREC.EQ.-1) WRITE(IOUT,149)
            IF(MOLNU.EQ.0) MOLNU = 1
            NFIRST = NFRESM(MOLNU)
            NF = IPRES(NFIRST)-1
            NLAST = NFRESM(MOLNU+1)-1
            IF(MOLNU.EQ.1) NLAST = NTOTRS
            CALL CONCOR(IXYZ,NFIRST,NLAST)
            CALL RCOOR1(NF)
          GO TO 174
C
C     ----- MISCELLANEOUS OPTIONS (OMIT ETC )
C
   60 CONTINUE
      write(iout,'(/,5x,a3,a1,/)') iformo,':'
C
C     ----- OMIT THIS OPTION IF INTERNAL COORDINATES ARE WANTED -----
C
      READ(IN,15) IOM
      IF(IOM.EQ.IOMIT) WRITE(IOUT,203)
      IF(IFORMO.EQ.IINT.AND.IOM.EQ.IOMIT) GO TO 920
      CALL CONCOR(IFORMO,IONE,NTOTRS)
      IF(IOM.EQ.IOMIT) CALL EDITDU
      GO TO 129
C
C     ----- CION OPTION WILL BE DONE HERE -----
C
  121 CONTINUE
      write(iout,'(/,5x,a,/)') 'CION:'
      CALL CONCOR(IXYZ,IONE,NTOTRS)
      CALL PCI
      GO TO 129
C
C     ----- GAUSSIAN OPTION WILL BE DONE HERE -----
C
  530 CONTINUE
      write(iout,'(/,5x,a,/)') 'GAUSS:'
c
c     --- g80 format zmatrix ---
c
      call amopen(ipunch, zmat, owrite,  'F',  'W')
      CALL EGAUSS(IPUNCH,NTOTAT)
      CALL CLOSC(IPUNCH)
      GO TO 129
C
C     ----- DIHEDRAL OPTION WILL BE DONE HERE -----
C
  531 CONTINUE
      write(iout,'(/,5x,a,/)') 'DIHED:'
      CALL CONCOR(IXYZ,IONE,NTOTRS)
      CALL CALDIH
      GO TO 129
C
C     ----- PUCK OPTION WILL BE DONE HERE -----
C
  532 CONTINUE
      write(iout,'(/,5x,a,/)') 'PUCKER:'
      CALL NEWPUC
      GO TO 129
C
C     ----- CHARGE OPTION WILL BE DONE HERE -----
C
  620 CONTINUE
      write(iout,'(/,5x,a,/)') 'CHARGE:'
      CALL RCHAR
      GO TO 129
C
C     ----- SOLVATION OF THE SOLUTE WILL BE DONE HERE -----
C
  720 CONTINUE
      write(iout,'(/,5x,a,/)') 'SOL:'
      CALL WSOL
      GO TO 129
C
C     ----- THE SOLUTE WILL BE IMMERSED IN A BOX OF SOLVENT -----
C
  730 CONTINUE
      write(iout,'(/,5x,a,/)') 'BOX:'
      CALL BSOL
      GO TO 129
  731 CONTINUE
      write(iout,'(/,8X,"******************************************")')
      write(iout,'(8X,"ENSUING BOX WILL BE A TRUNCATED OCTAHEDRON")')
      write(iout,'(8X,"******************************************")')
      ioct = 1
      GO TO 129
  732 CONTINUE
      write(iout,'(/,5x,a,/)') 'BOX4:'
      CALL BSOL4
      GO TO 129
  733 CONTINUE
      write(iout,'(/,5x,a,/)') 'FLB:'
      call BFLB
      GO TO 129
C
C     ----- ADDITION OF ARBITRARY NUMBER OF WATER MOLECULES WILL
C           BE DONE HERE -----
C
  740 CONTINUE
      write(iout,'(/,5x,a,/)') 'ADD:'
      CALL ADDHOH
      GO TO 129
  760 continue
      write(iout,'(/,5x,a,/)') 'WAT:'
      call wat
      go to 129
  762 continue
      write(iout,'(/,5x,a,/)') 'FLOPPY:'
      call floppy
      go to 129
  764 continue
      write(iout,'(/,5x,a,/)') 'TIP4P:'
      call tip4p
      go to 129
  766 continue
      write(iout,'(/,5x,a,/)') 'GEN:'
      call gensol 
      go to 129
C
C
C     ----- TELL OPTION WILL BE DONE HERE -----
C
  533 CONTINUE
      write(iout,'(/,5x,a,/)') 'TELL:'
C
C     ----- IOPTB = 1 PRINT BOND VALUES
C           IOPTA = 1 PRINT ANGLE VALUES
C           IOPTD = 1 PRINT DIHEDRAL VALUES
C
      READ(IN,10) IOPTB,IOPTA,IOPTD
      CALL CONCOR(IXYZ,IONE,NTOTRS)
      CALL STELL(IOPTB,IOPTA,IOPTD)
  129 CONTINUE
C
C     ----- END OF GRAND LOOP OF EDIT PROGRAM -----
C
  130 CONTINUE
      CALL PRTALL
C
C     ----- CHECK FOR ARRAY BOUNDS -----
C
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
      IF(nmolp.GT.MAXMOL) then
           write(iout,2000) 'Molecules', nmolp, 'MAXMOL', MAXMOL
           call mexit(iout, 1)
      endif   
      IF(NRESP.GT.MAXRES) then
           write(iout,2000) 'Residues', nresp, 'MAXRES', MAXRES
           call mexit(iout, 1)
      endif   
      IF(NTOTAT.GT.MAXATM) then
           write(iout,2000) 'Atoms', ntotat, 'MAXATM', MAXATM
           call mexit(iout, 1)
      endif   
      IF(NBOND.GT.MAXBND) then
           write(iout,2000) 'Bonds', nbond, 'MAXBND', MAXBND
           call mexit(iout, 1)
      endif   
      IF(NTHETA.GT.MAXANG) then
           write(iout,2000) 'Angles', ntheta, 'MAXANG', MAXANG
           call mexit(iout, 1)
      endif   
      IF(NPHI.GT.MAXDIH) then
           write(iout,2000) 'Dihedrals', nphi, 'MAXDIH', MAXDIH
           call mexit(iout, 1)
      endif   
      IF(NEXT.GT.MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(iout, 1)
      endif   
      IF(ncross.GT.MAXCRS) then
           write(iout,2000) 'Crosslinks', ncross, 'MAXCRS', MAXCRS
           call mexit(iout, 1)
      endif
c
c     --- Rev A:  Check for common errors ---
c
*     subroutine bonerr(nbond,ibond,jbond,x,y,z,name,lun)
      call bonerr(nbond,ib,jb,r,theta,phi,igraph,iout)
C
C     ----- ALL DONE ... OUTPUT THE EDIT BINARY DATA -----
C
      CALL WRITEO
      call mexit(0, 0)
  920 WRITE(IOUT,322)
      call mexit(iout, 1)
    9 FORMAT(20A4)
   10 FORMAT(10I5)
   15 FORMAT(A4)
   16 FORMAT(A3)
   21 FORMAT(5X,'DATA IS OUTPUT AS INTERNAL COORDINATES',/)
   22 FORMAT(5X,'DATA IS OUTPUT AS CARTESIAN COORDINATES',/)
   61 FORMAT(5I5)
   78 FORMAT(5X,'GEOMETRY FOR MOLECULE',I4,2X,
     $       'WILL BE OUTPUT ON FILE',I3,2X,A40,/,20X,
     $       'IN PLACE OF COORDINATES READ FROM FILE',I3,2X,A40,/)
   79 FORMAT(5X,'GEOMETRY FOR MOLECULE',I4,2X,
     $       'WILL BE OUTPUT ON FILE',I3,2X,A40,/)
   99 FORMAT(5X,'GEOMETRY FOR MOLECULE',I5,2X,
     $       'IS INPUT ON FILE',I5,2X,A40,/)
  148 FORMAT(5X,'DEFAULT DIRECTION IS UP TREE',/)
  149 FORMAT(5X,'DEFAULT DIRECTION IS DOWN TREE',/)
c 151 FORMAT(5X,'TRANSFORMATIONS ARE RELATIVE TO LAST 3 ATOMS',/)
c 152 FORMAT(5X,'TRANSFORMATIONS ARE RELATIVE TO FIRST 3 ATOMS',/)
  195 FORMAT(I5,A3,2X,I5)
  200 FORMAT(5x,'Edit Input Title: ',20A4)
  204 FORMAT(5X,'Link Topology Title: ',20A4)
  203 FORMAT(5X,'DUMMY ATOMS WILL BE OMITTED FROM MOLECULE',/)
  236 FORMAT(5X,'ALL MOLECULES IN SYSTEM WILL BE USED',/)
  322 FORMAT(2x,'FATAL:  Cannot omit dummy atoms with INT output')
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
 9108 FORMAT(/,10X,'------------------------------------------'
     $      ,/,10X,'Amber 5  :  EDIT Module          UCSF 1997'
     $      ,/,10X,'Amber 5  :  mod: 10-MAR-1997          jwc'
     $      ,/,10X,'------------------------------------------',/)
      END       
