c-----------------------------------------------------------------------
      SUBROUTINE FINDBA(NAT,NATX,NATBND,NAB)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- COMPUTES ALL ATOMS BONDED TO ATOM NAT (EXCLUDING ATOM NATX)
C
c     Rev 3-May-89 change args of findrs call to match library routine.
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
C
      DIMENSION NAB(*)
C
      MCROSF = IBOND(NMOL+1)-1
      NATBND = 0
      CALL FINDRS(NAT,IRES,ntotrs,ipres)
      NS = IBRES(IRES)
      NLIM = IBRES(IRES+1)-1
C
C     ----- THIS CAN OCCUR WHEN THERE ARE NO BONDS IN A RESIDUE -----
C
      IF(NLIM.LT.NS) GO TO 60
C
      DO 30 I = NS,NLIM
      II = IB(I)
      JJ = JB(I)
      IF(II.EQ.-50) RETURN
      IF(II.GT.NAT) GO TO 60
      IF(II.NE.NAT.AND.JJ.NE.NAT) GO TO 30
      LL = II
      IF(LL.EQ.NAT) LL = JJ
      IF(LL.EQ.NATX) GO TO 30
      NATBND = NATBND+1
      NAB(NATBND) = LL
   30 CONTINUE
   60 CONTINUE
C
C     ----- ONLY THE FIRST BOND OF EACH RESIDUE (THE LINKING BOND) MUST
C           BE CHECKED -----
C
      IF(IRES.EQ.NTOTRS) GO TO 61
      IP = IRES+1
      DO 40 I = IP,NTOTRS
      ICK = IBRES(I)
      II = IB(ICK)
      JJ = JB(ICK)
      IF(II.NE.NAT.AND.JJ.NE.NAT) GO TO 40
      LL = II
      IF(LL.EQ.NAT) LL = JJ
      IF(LL.EQ.NATX) GO TO 40
      NATBND = NATBND+1
      NAB(NATBND) = LL
   40 CONTINUE
C
C     ----- CHECK CROSSLINK BONDS -----
C
   61 IF(MCROSF.EQ.0) RETURN
      IBONDC = MCROSF+1
      IF(IBONDC.GT.NBOND) RETURN
      DO 70 I = IBONDC,NBOND
      IF(IB(I).NE.NAT.AND.JB(I).NE.NAT) GO TO 70
      LL = IB(I)
      IF(LL.EQ.NAT) LL = JB(I)
      IF(LL.EQ.NATX) GO TO 70
      NATBND = NATBND+1
      NAB(NATBND) = LL
   70 CONTINUE
      RETURN
      END
