c-----------------------------------------------------------------------
      SUBROUTINE FIXM(M1,M2,NMOL,IERR)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- FIXES UP RANGE OF MOLECULES -----
C
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      IERR = 0
      IF(M1.GT.0) GO TO 100
      IERR = 1
      WRITE(IOUT,400)
      RETURN
  100 CONTINUE
      IF(M2.LE.0) M2 = M1
      IF(M2.GT.NMOL) M2 = NMOL
      IF(.NOT.(M2.LT.M1)) GO TO 120
      WRITE(IOUT,500) M1,M2
      IERR = 1
  120 CONTINUE
      RETURN
  400 FORMAT(t2,'EDIT-W-BLANK, blank mol range card ')
  500 FORMAT(t2,'EDIT-W-BADRANGE, molecule ',i5, ' lt ',
     +           i5,' in mol range')
      END
