c-----------------------------------------------------------------------
      SUBROUTINE RCOOR1(NATPRE)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- READ IN NEW INTERNAL COORDINATES OF ATOMS WITHOUT AFFECTING
C           REST OF MOLECULE
C           COORDINATES MUST BE CONVERTED TO CARTESIAN COORDINATES
C           BEFORE CALLING THIS ROUTINE -----
C
#include "sizes.h"
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/OPEDIT/IDBL,IDIREC,IOPTF
C
      DIMENSION KB(80)
C
      DATA MAIN /1HM /
C
c  mega primitive pseudo free format read driver.
c  findni: read next integer from "kb"
c  findnr: read next real from "kb"
c
      DO 10 II = 1,1000
      READ(IN,11) KB
   11 FORMAT(80A1)
      IS = 0
      CALL FINDNI(KB,IS,IATOM)
      IF(IS.EQ.1000) RETURN
C
      IATOM = IATOM+NATPRE
      IBTOM = 0
c bond length
      CALL FINDNR(KB,IS,R1)
c bond angle 
      CALL FINDNR(KB,IS,R2)
c dihedral 
      CALL FINDNR(KB,IS,R3)
c atom "A"
      CALL FINDNI(KB,IS,IBTOM)
C
C     ----- IBTOM.LT.0 TO GO TOWARDS DECREASING ATOM NUMBER DOWN TREE
C
      IF(IBTOM.LT.0) GO TO 15
c atom "B"
      CALL FINDNI(KB,IS,ICTOM)
c atom "C"
      CALL FINDNI(KB,IS,IDTOM)
      IBTOM = IBTOM+NATPRE
      ICTOM = ICTOM+NATPRE
      IDTOM = IDTOM+NATPRE
      IF(IS.LT.1000) GO TO 14
      IF(IDIREC.EQ.-1) GO TO 15
C
C     ----- BACKTRACK TO MAIN CHAIN AND THEN GO TOWARD INCREASING ATOM
C           ATOM NUMBER ALONG MAIN CHAIN -----
C
      IF(ITREE(IATOM).NE.MAIN) IBTOM = JOIN(IATOM)
      IF(ITREE(IATOM).EQ.MAIN) CALL SEEKM(IATOM,IBTOM,MAIN,ITREE)
      IF(ITREE(IBTOM).NE.MAIN) ICTOM = JOIN(IBTOM)
      IF(ITREE(IBTOM).EQ.MAIN) CALL SEEKM(IBTOM,ICTOM,MAIN,ITREE)
      IF(ITREE(ICTOM).NE.MAIN) IDTOM = JOIN(ICTOM)
      IF(ITREE(ICTOM).EQ.MAIN) CALL SEEKM(ICTOM,IDTOM,MAIN,ITREE)
      GO TO 14
C
C     ----- GO DOWN TREE -----
C
   15 CALL GTJOIN(IATOM,IBTOM,ICTOM,IDTOM,JOIN)
   14 CONTINUE
      P3 = 360.-R3
      CALL COORD(IDUM,IDTOM,ICTOM,IBTOM,IATOM,X,Y,Z,R1,R2,P3)
      WRITE(IOUT,25) IATOM,IBTOM,ICTOM,IDTOM,R1,R2,R3
   10 CONTINUE
      RETURN
   25 FORMAT(' ATOM',I5,1X,'ATTACHED TO',3I5,
     $       ' INTERNALS',3F8.3,/)
      END
