c-----------------------------------------------------------------------
      SUBROUTINE REMFIX(NF,NAT,IATSUB,X,Y,Z,IOUT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL FINE,IATSUB
C
C     ----- ROUTINE TO FIX THE COORDINATES OF THOSE ATOMS NOT
C           FIXED BY ADDXRY ROUTINE -----
C
      DIMENSION IATSUB(*),X(*),Y(*),Z(*)
C
      DO 100 I = 1,NAT
      READ(NF) FINE,IAT,JAT,KAT,LAT,DIS,ANG,DIH
      IF(IATSUB(I)) GO TO 100
C
C     ----- FIX THE COORDINATES IF IT IS FINE -----
C
      IF(.NOT.FINE) GO TO 200
C
      DIH = 360.0-DIH
      CALL COORD(NAT,LAT,KAT,JAT,IAT,X,Y,Z,DIS,ANG,DIH)
  100 CONTINUE
      RETURN
  200 CONTINUE
      WRITE(IOUT,9008) IAT
 9008 FORMAT(t2,'EDIT-F-NOFIX, error in fixing the',
     +       ' coordinate for atom' ,i5)
      call mexit(iout, 1)
      END
