c-----------------------------------------------------------------------
      SUBROUTINE STOINT(NF,NAT,X,Y,Z,JOIN,ITREE)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL FINE
C
C     ----- ROUTINE TO OUTPUT THE ZMATRIX FOR FIXING THE ATOMS
C           NOT READ BY ADDXRY -----
C
      DIMENSION X(*),Y(*),Z(*),JOIN(*),ITREE(*)
C
      DO 100 I = 1,NAT
C
      IAT = I
      FINE = .TRUE.
      JAT = JOIN(IAT)
C
C     ----- IF JAT.LE.0 .OR. KAT.LE.0 .OR. LAT.LE.0 THEN TAKE THE
C           ATOMS UPWARD . IF UNSUCCESSFUL SKIP THE ATOM AND FLAG
C           IT AS UNDEFINED . ITS COORDINATE SHOULD BE READ BY ADDXRY
C           OTHERWISE IT WILL BOMB OUT -----
C
      IF(JAT.LE.0) GO TO 120
      KAT = JOIN(JAT)
      IF(KAT.LE.0) GO TO 120
      LAT = JOIN(KAT)
      IF(LAT.LE.0) GO TO 120
      GO TO 140
C
C     ----- UPWARD SEARCH FOR THE ATOM -----
C
  120 CONTINUE
      CALL ATMGET(NAT,IAT,JAT,KAT,LAT,JOIN,ITREE,FINE)
      IF(.NOT.FINE) GO TO 220
  140 CONTINUE
      CALL DIST(IAT,JAT,X,Y,Z,DIS)
      CALL BANGLE(IAT,JAT,KAT,X,Y,Z,ANG,1)
      CALL TORS(IAT,JAT,KAT,LAT,X,Y,Z,DIH)
  220 CONTINUE
      WRITE(NF) FINE,IAT,JAT,KAT,LAT,DIS,ANG,DIH
  100 CONTINUE
      RETURN
      END
