c-----------------------------------------------------------------------
      SUBROUTINE APPEND(LBMOL,NAMRES)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- PREPPENDS RESNAME WITH LBMOL IF DNA OR RNA -----
C
c     rewritten in ANSI Fortran 77 by G. Seibel
c     all VMS gunk removed.
c
      character resnam*4, newres*4
      DATA IDNA,IRNA,IHB,IHE/4HD   ,4HR   ,4HHB  ,4HHE  /
C
      IF(LBMOL.NE.IDNA .AND. LBMOL.NE.IRNA) RETURN
      IF(NAMRES.EQ.IHB .OR. NAMRES.EQ.IHE) RETURN
c
c     --- make first char of newres D or R according to lbmol ---
c
      if (lbmol .eq. idna) then
           newres = 'D'
      elseif (lbmol .eq. irna) then
           newres = 'R'
      endif
C
c     --- internal write namres (holerith) to resnam (char) ---
c
      write(resnam,'(a4)') namres
c
c     --- transfer first three char of resnam to last three of newres ---
c
      newres(2:4) = resnam
c
c     --- convert back to hollerith via internal read ---
c
      read (newres,'(a4)') namres
      RETURN
      END
