c-----------------------------------------------------------------------
      SUBROUTINE BLDIT(NATRES,NC,RTP,ITYP,MB,MT,MP,MUMEX,MATEX,
     $                 CHG,IROT,JPLOT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      CHARACTER*1 NLINK,ICONNR
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/CONNR/NLINK,ICONNR(MAXRES)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION NC(*),CHG(*),JPLOT(2,*)
      DIMENSION RTP(3,*),ITYP(3,*),MB(2,*),MT(3,*),MP(4,*)
      DIMENSION MUMEX(*),MATEX(*),IROT(*),IHH(5)
      DIMENSION CGCOR1(5),CGCOR2(5)
C
      DATA CGCOR1,CGCOR2/-0.425,-0.404,3*0.0,-0.514,-0.508,3*0.0/
      DATA IHH   /2HH    ,4HHN    ,4HOH  ,2HNT  ,2HH2  /
      DATA MAIN  /1HM/
      DATA IHE   /4HHE  /
      DATA IHBE  /4HHB  /
      DATA IOHE  /4HOHE /
*     DATA IDOHE /4HDOHE/
      DATA JOHT  /2HOH/
      DATA IINT  /3HINT/
C
      if (ntotat+natoms+natres .gt. MAXATM) then
           write(iout,'(/,5x,a,i6,a)') 'MAXATM =',MAXATM, ' exceeded.'
           call mexit(iout, 1)
      endif
      ITRY = NBUILD
C
C     ----- IF ICONN = 0, THIS RESIDUE IS NOT ATTACHED TO PREVIOUS ONE
C
      IF(ICONNR(NTOTRS).EQ.NLINK) ICONN = 0
C
C     ------ CORRECTIONS MUST BE CHANGED IF DATA STRUCTURE CHANGES
C            USE ARBITRARY INTERNAL COORDINATES WHEN 2 MOLECULES ARE
C            LINKED -----
C            ASSUMES 1ST RESIDUE OF LINKING MOLECULE HAS AT LEAST
C            3 ATOMS
C
      IF(NMOL.EQ.1) GO TO 1001
      IF(NTOTRS.NE.NFRESM(NMOL)) GO TO 1001
      IF(ITYPCO.NE.IINT) GO TO 1001
      IF(ICONN.NE.0) RTP(1,1) = 1.5
      IF(ICONN.EQ.0) RTP(1,1) = 15.
      RTP(2,1) = 90.
      RTP(3,1) = 180.
      RTP(2,2) = 90.
      RTP(3,2) = 180.
      RTP(3,3) = 180.
 1001 CONTINUE
C
C     ----- CORRECTIONS FOR NUCLEOTIDE -----
C
      IF(MOLTYP(NMOL).GT.2) GO TO 258
      IF(LABRES(NTOTRS).EQ.IHE) GO TO 202
      NMINUS = NTOTRS-1
      IF(NMINUS.LE.0) GO TO 200
      IF(LABRES(NMINUS).NE.IHBE) GO TO 200
      ITYPF = IFRES(NMINUS)
C
C      ----- IF THE FIRST RESIDUE IS BONDED TO A HYDROGEN THEN THE
C            R VALUE MUST BE CHANGED. THE VALUE IN THE DATA STATEMENT
C            IS FOR PP -----
C
      RTP(1,1) = 0.96
      CHG(1) = CGCOR1(ITYPF)
      ITYP(2,1) = IHH(3)
      GO TO 200
  202 CONTINUE
C
C     ----- CORRECTION FOR CHARGE -----
C
      ITYPF = IFRES(NTOTRS)
      CHRG(NBUILD) = CGCOR2(ITYPF)
      ISYMBL(NBUILD) = JOHT
      MPV = JOIN(NBUILD)
      GO TO 200
C
C     ----- CORRECTIONS FOR PROTEIN -----
C
  258 CONTINUE
      IF(MOLTYP(NMOL).NE.3) GO TO 200
      ICK = LABRES(NTOTRS)
*     IF(ICK.EQ.IDOHE) GO TO 203
*     IF(ICK.EQ.IOME) GO TO 204
      NMINUS = NTOTRS-1
      IF(NMINUS.LE.0) GO TO 200
      IF(LABRES(NMINUS).EQ.IHBE) GO TO 242
      GO TO 200
  242 CONTINUE
      CHGH = CHG(2)*0.5
      CHRG(NBUILD) = CHGH
      II4 = IHH(5)
      ISYMBL(NBUILD) = II4
      IGRAPH(NBUILD) = IHH(2)
      CHG(2) = CHGH
      ITYP(2,1) = IHH(4)
      ITYP(2,2) = IHH(5)
      GO TO 200
* 203 CHG(1) = 0.38
*     CHG(2) =  -0.38
*     RTP(1,1) = 1.36
*     RTP(2,1) = 113.
*     RTP(3,1) = 180.
*     RTP(2,2) = 107.
*     GO TO 200
* 204 CONTINUE
*     ISYMBL(NBUILD) = IO2
*     CHRG(NBUILD) = -.5425
*     MPV = JOIN(NBUILD)
*     CHRG(MPV) = 0.252
*     NRESPR = ITRES(NTOTRS-1)
*     IF(NRESPR.NE.IINT) GO TO 205
*     R(NBUILD) = 1.26
*     THETA(NBUILD) = 117.2
* 205 CONTINUE
C
C     ----- END OF CORRECTIONS -----
C
  200 CONTINUE
      NRESI = NTOTRS-NFRESM(NMOL)+1
C
      IF (IWI.NE.1) GO TO 1200
      WRITE(IOUT,165) NMOL,NRESI
      WRITE(IOUT,104) NATOMS,NATRES,NAMRES
      WRITE(IOUT,300)
 1200 CONTINUE
      NND = NBUILD
      ITRES(NTOTRS) = ITYPCO
      IFIND = 0
      MLAST = 0
      MFIRST = 0
      DO 10 NUM = 1,NATRES
      NND = NND+1
      NCNU = NC(NUM)
      NNC = NCNU+NBUILD
      IF(NCNU.EQ.0) NNC = NA0
      IF(NCNU.EQ.0) NA1 = NND
      IF(NCNU.LT.0) then
           WRITE(IOUT,723) NND
           call mexit(iout, 1)
      endif
      IROTAT(NND) = IROT(NUM)+NBUILD
      R(NND) = RTP(1,NUM)
      THETA(NND) = RTP(2,NUM)
      PHI(NND) = RTP(3,NUM)
C
C     ----- COULD MAKE THIS - TO IDENTIFY SPACER SECTION -----
C
      JOIN(NND) = NNC
      CHRG(NND) = CHG(NUM)
      ITREE(NND) = ITYP(1,NUM)
      ISYMBL(NND) = ITYP(2,NUM)
      IGRAPH(NND) = ITYP(3,NUM)
C
C     ----- FIND FIRST AND LAST REAL ATOMS -----
C
      IF(ISYMBL(NND).EQ.ISYMDU) GO TO 10
      IF(IFIND.EQ.1) GO TO 400
      IF(ITREE(NND).NE.MAIN) GO TO 400
      MFIRST = NND
      IFIND = 1
  400 CONTINUE
      IF(ITREE(NND).EQ.MAIN) MLAST = NND
   10 CONTINUE
      IF(IWI.NE.1) GO TO 390
      DO 5 II = 1,NATRES
      NAX = 0
      NBX = 0
      NDX = II
      NCX = JOIN(NDX+NBUILD)-NBUILD
      IF(NCX+NBUILD.LE.0) GO TO 60
      NBX = JOIN(NCX+NBUILD)-NBUILD
      IF(NBX+NBUILD.LE.0) GO TO 60
      NAX = JOIN(NBX+NBUILD)-NBUILD
   60 CONTINUE
      WRITE(IOUT,4) NAX,NBX,NCX,NDX,RTP(1,II),RTP(2,II),RTP(3,II),
     +    CHG(II),ITYP(1,II),ITYP(2,II),ITYP(3,II)
    5 CONTINUE
  390 CONTINUE
      IF(ICONN.EQ.0) GO TO 401
      IF(ISYMBL(NA1).EQ.ISYMDU)  WRITE(IOUT,736) NA1,NTOTRS,MFIRST
      IF(ISYMBL(NA1).EQ.ISYMDU)  NA1 = MFIRST
C
C     ----- THIS BOND MAY NOT BE IN CORRECT ORDER IN IB AND JB ARRAYS
C
      NBOND = NBOND+1
      IB(NBOND) = NA0
      JB(NBOND) = NA1
  401 CONTINUE
      IK = 1
      K = NBOND
   20 CONTINUE
      K = K+1
      MTRY = MB(1,IK)+MB(2,IK)
      IF(MTRY.LT.-90) GO TO 21
      if (k .gt. MAXBND) then
           write(iout,'(/,5x,a,i6,a)') 'MAXBND =',MAXBND,' exceeded.'
           call mexit(iout, 1)
      endif
      IB(K) = MB(1,IK)+NBUILD
      JB(K) = MB(2,IK)+NBUILD
      IK = IK+1
      GO TO 20
C
   21 CONTINUE
      IK = IK-1
      NBDNUC = IK
      IF(NBDNUC.EQ.0) GO TO 113
      IF(IWI.NE.1) GO TO 411
      WRITE(IOUT,300)
      WRITE(IOUT,106)
      WRITE(IOUT,2) (MB(1,I),MB(2,I),I = 1,NBDNUC)
  411 CONTINUE
      NBOND = NBOND+NBDNUC
  113 CONTINUE
C
C     ----- IT IS ASSUMED NO MORE BONDS WILL BE ADDED FOR THIS RESIDUE
C
      if (ntotrs+1 .gt. MAXRES) then
           write(iout,2000) 'Residues', ntotrs+1, 'MAXRES', MAXRES
           call mexit(iout, 1)
      endif
      IBRES(NTOTRS+1) = NBOND+1
      IF(ICONN.NE.0) CALL JOINT
      IK = 1
      K = NTHETA
   30 CONTINUE
      K = K+1
      MTRY = MT(1,IK)+MT(2,IK)
      IF(MTRY.LT.-90) GO TO 31
      if (k .gt. MAXANG) then
           write(iout,2000) 'Angles', k, 'MAXANG', MAXANG
           call mexit(iout, 1)
      endif
      IT(K) = MT(1,IK)+NBUILD
      JT(K) = MT(2,IK)+NBUILD
      KT(K) = MT(3,IK)+NBUILD
      IK = IK+1
      GO TO 30
C
   31 CONTINUE
      IK = IK-1
      NTHNUC = IK
      IF(NTHNUC.EQ.0) GO TO 130
      IF(IWI.NE.1) GO TO 402
      WRITE(IOUT,107)
      WRITE(IOUT,1) (MT(1,I),MT(2,I),MT(3,I),I = 1,NTHNUC)
  402 CONTINUE
      NTHETA = NTHETA+NTHNUC
  130 CONTINUE
      IK = 1
      K = NPHI
   40 CONTINUE
      K = K+1
      MTRY = MP(1,IK)+MP(2,IK)
      IF(MTRY.LT.-90) GO TO 41
      if (k .gt. MAXDIH) then
           write(iout,2000) 'Dihedrals', k, 'MAXDIH', MAXDIH
           call mexit(iout, 1)
      endif
      IP(K) = MP(1,IK)+NBUILD
      JP(K) = MP(2,IK)+NBUILD
      ID3 = MP(3,IK)
      ID4 = MP(4,IK)
      KP(K) = IABS(ID3)+NBUILD
      LP(K) = IABS(ID4)+NBUILD
      IF(ID3.LT.0) KP(K) = -KP(K)
      IF(ID4.LT.0) LP(K) = -LP(K)
C
C     ----- IF 4TH FIELD IS '-', THEN THIS IS AN IMPROPER TORSION AND A
C           CHECK IS MADE FOR THE SYMBOL FOR '-M' (-1 ) -----
C
      IF(ID4.GE.0) GO TO 501
C
C     ----- IF VALUE OF MP(I,IK)  =  -1 , THIS IS A FLAG TO MAKE
C           ATOM  =  LAST M ATOM OF PREVIOUS RESIDUE
C           IF ICONN = 0, THIS VALUE WILL BE REMOVED LATER ON IN THE
C           DIHEDRAL CHECK, AS LONG AS MP IS .LE. 0 -----
C
      IF(ICONN.EQ.0) GO TO 501
      IF(MP(1,IK).EQ.-1) IP(K) = NA0
      IF(MP(2,IK).EQ.-1) JP(K) = NA0
      IF(ID3.EQ.-1) KP(K) = NA0
C
C     ----- THERE IS NO WAY ID4 CAN BE THE PREVIOUS M ATOM, BECAUSE
C           OF THE SORTING OF THE DIHEDRALS IN PREP -----
C
  501 CONTINUE
      IK = IK+1
      GO TO 40
C
   41 CONTINUE
      IK = IK-1
      NPHNUC = IK
      IF(NPHNUC.EQ.0) GO TO 140
      IF(IWI.NE.1) GO TO 403
      WRITE(IOUT,108)
      WRITE(IOUT,100) (MP(1,I),MP(2,I),MP(3,I),MP(4,I),
     +                I = 1,NPHNUC)
  140 CONTINUE
      IF (IWI.EQ.1) CALL EXCLW(1,NATRES,MUMEX,MATEX)
  403 CONTINUE
      II = 1
      LL = 0
      JSTAR = NATOMS+1+NTOTAT
      JFIN = NATOMS+NATRES+NTOTAT
      DO 50 JJ = JSTAR,JFIN
      KKP = MUMEX(II)
      NUMEX(JJ) = KKP
      DO 37 KK = 1,KKP
      LL = LL+1
      NEXT = NEXT+1
      if (next .gt. MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(iout, 1)
      endif
      NATEX(NEXT) = MATEX(LL)+NBUILD
      IF(MATEX(LL).EQ.0) NATEX(NEXT) = 0
   37 CONTINUE
      II = II+1
   50 CONTINUE
      NPHI = NPHI+NPHNUC
      NATOMS = NATOMS+NATRES
      NBUILD = NBUILD+NATRES
C     IBRES(NTOTRS+1) = NBOND+1
      IPRES(NTOTRS+1) = NBUILD+1
      RETURN
  104 FORMAT( 9X,' NUMBER OF ATOMS BEFORE THIS RESIDUE = ',I10,/,10X,
     +'NUMBER OF ATOMS IN THIS RESIDUE = ',I10,/,10X,'NAME = ',2X,A4)
  300 FORMAT(/ /)
  723 FORMAT(t2,'LINK-F-NEGJOIN, atom',i6,' has a negative ',
     +          'ijoin value',/)
    4 FORMAT(4I5,4F15.4,5X,3A4)
  736 FORMAT(5X,'ATOM',I5,3X,'IN RESIDUE',I5,'  IS A DUMMY ATOM,',
     +       /,5x,'AND A COVALENT BOND WILL BE MADE WITH ATOM',I5,/)
  106 FORMAT(10X,'BONDS')
    2 FORMAT(6(10X,2I4))
  107 FORMAT(10X,'ANGLES')
  165 FORMAT(9X,'MOLECULE  = ',I5,5X,'RESIDUE  = ',I5)
    1 FORMAT(5(8X,3I4))
  108 FORMAT(10X,'DIHEDRAL ANGLES')
  100 FORMAT(4(8X,4I4))
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
