c-----------------------------------------------------------------------
      SUBROUTINE PRTALL
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
#include "sizes.h"
C
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     +              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
C     ----- PRINT OUT THE INFORMATION -----
C
      ISTART = 1
      IEND = NATML(1)
      JF = 1
      IRP = 1
      WRITE(IOUT,1) NMOL
C
      DO 100 I = 1,NMOL
      IF(I.GT.1) WRITE(IOUT,101)
      IR = 0
      IRES = NFRESM(I+1)-NFRESM(I)
      WRITE(IOUT,2) I,IRES
      JEND = JF+IRES-1
      WRITE(IOUT,3) (LABRES(J),J = JF,JEND)
      JF = JEND+1
      WRITE(IOUT,102) IBOND(I),ITHETA(I),IPHI(I),NFRESM(I),NATML(I),
     +           MOLTYP(I)
      IF(I.EQ.1) GO TO 7
      ISTART = NATML(I-1)+1
      IEND = NATML(I)
    7 CONTINUE
      TCHG = 0.0
      WRITE(IOUT,199)
      DO 4 J = ISTART,IEND
      TCHG = TCHG+CHRG(J)
      IF(IWO.NE.0) GO TO 300
      IF(J.NE.IPRES(IRP)) GO TO 400
      IR = IR+1
      WRITE(IOUT,110) IR,LABRES(IRP),ITRES(IRP),IRP
      WRITE(IOUT,111) IBRES(IRP),IPRES(IRP)
      IRP = IRP+1
  400 CONTINUE
      WRITE(IOUT,200) J,JOIN(J),IGRAPH(J),ISYMBL(J),ITREE(J),R(J),
     +               THETA(J),PHI(J),CHRG(J),IROTAT(J)
  300 CONTINUE
    4 CONTINUE
      IF(IWA.NE.1) GO TO 401
      IBS = IBOND(I)
      IBF = IBOND(I+1)-1
      WRITE(IOUT,310)
      WRITE(IOUT,303) (L,IB(L),JB(L),L = IBS,IBF)
      IAS = ITHETA(I)
      IAF = ITHETA(I+1)-1
      WRITE(IOUT,301)
      WRITE(IOUT,304) (L,IT(L),JT(L),KT(L),L = IAS,IAF)
      IDS = IPHI(I)
      IDF = IPHI(I+1)-1
      WRITE(IOUT,302)
      WRITE(IOUT,305) (L,IP(L),JP(L),KP(L),LP(L),L = IDS,IDF)
  401 CONTINUE
      IF(IWN.EQ.1) CALL EXCLW(ISTART,IEND,NUMEX,NATEX)
      WRITE(IOUT,199)
      WRITE(IOUT,5) TCHG
  100 CONTINUE
      IF(IWA.NE.1) GO TO 690
      IF(NCROSS.EQ.0) GO TO 690
      WRITE(IOUT,671)
      IBS = IBOND(NMOL+1)
      WRITE(IOUT,310)
      WRITE(IOUT,303) (L,IB(L),JB(L),L = IBS,NBOND)
      IAS = ITHETA(NMOL+1)
      WRITE(IOUT,301)
      WRITE(IOUT,304) (L,IT(L),JT(L),KT(L),L = IAS,NTHETA)
      IDS = IPHI(NMOL+1)
      WRITE(IOUT,302)
      WRITE(IOUT,305) (L,IP(L),JP(L),KP(L),LP(L),L = IDS,NPHI)
  690 CONTINUE
      WRITE(IOUT,103) NMOL,NTOTRS,NTOTAT,NBOND,NTHETA,NPHI,NEXT
      RETURN
C
  103 FORMAT(/6X,'NMOL =',I5,3X,'NTOTRS =',I5,3X,'NTOTAT =',I5,3X,
     +  'NBOND =',I5,/6X,'NTHETA =',I5,3X,'NPHI =',I5,3X,'NEXT =',I5,/)
    1 FORMAT(/ / /,20X,'THIS CALCULATION CONTAINS',I3,2X,'MOLECULES',
     +   / /)
  101 FORMAT(/ / /)
    2 FORMAT(/ /, 6X,'MOLECULE',I5,2X,'CONTAINS',I5,2X,'RESIDUES',/)
    3 FORMAT(5X,20A4,/)
  102 FORMAT(5X,'FIRST BOND =',I5,5X,'FIRST THETA =',I5,5X,
     +       'FIRST PHI =',I5,/,5X,'FIRST RESIDUE =',I5,5X,
     +       'LAST ATOM =',I5,5X,'TYPE OF MOLECULE =',I5,/)
  110 FORMAT(/,5X,'RESIDUE',I4,1X,'=',2X,A4,3X,A4,5X,
     +       'RESIDUE TOTAL =',I5,/)
  111 FORMAT(/6X,'BOND ARRAY BEGINS WITH ',I5,4X,
     +     '1ST ATOM IN RESIDUE =',I5,/)
  199 FORMAT(/ /)
  200 FORMAT(1x,2I5,2X,A4,2X,A4,2X,A4,3F10.3,F8.4,I5)
  310 FORMAT(/ /,5X,'BONDS',/)
  303 FORMAT(7(1X,I6,1H.,2I5))
  301 FORMAT(/ /,5X,'BOND ANGLES',/)
  304 FORMAT(5(1X,I6,1H.,3I5))
  302 FORMAT(/ /,5X,'DIHEDRAL ANGLES ',/)
  305 FORMAT(4(1X,I6,1H.,4I5))
    5 FORMAT(5X,'THE TOTAL CHARGE ON THE MOLECULE =',F10.5)
  671 FORMAT(5X,
     +     'ADDITIONAL BONDS,ANGLES,AND DIHEDRALS DUE TO CROSSLINKS',/)
      END
