c-----------------------------------------------------------------------
      SUBROUTINE DIHSEP(NT,NH,NA,IH,JH,KH,LH,ICH,IA,JA,KA,LA,ICA,
     +                  ISYMB,IND)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Rev A mod:  removed machine dependent gunk, made ANSI f77 - G. Seibel
      character*4 bufa,bufb
      LOGICAL SKIP
C
C     ----- ROUTINE TO SEPARATE DIHEDRALS INVOLVING HYDROGEN ATOMS -----
C
C           IND = 0 ONLY THE NUMBER OF SEPARATED BONDS EVALUATED
C               = 1 TOTAL SEPARATION
C
      DIMENSION IH(*),JH(*),KH(*),LH(*),ICH(*)
      DIMENSION IA(*),JA(*),KA(*),LA(*),ICA(*),ISYMB(*)
C
      NH = 0
      NA = 0
      SKIP = IND.LE.0
C
      DO 100 I = 1,NT
      IPT = IABS(IA(I))/3+1
      LPT = IABS(LA(I))/3+1
      write(bufa,'(a4)') isymb(ipt)
      write(bufb,'(a4)') isymb(lpt)
      if(bufa(1:1) .eq. 'H' .or. bufb(1:1) .eq. 'H') go to 120
      NA = NA+1
      IF(SKIP) GO TO 100
      IA(NA) = IA(I)
      JA(NA) = JA(I)
      KA(NA) = KA(I)
      LA(NA) = LA(I)
      ICA(NA) = ICA(I)
      GO TO 100
  120 CONTINUE
      NH = NH+1
      IF(SKIP) GO TO 100
      IH(NH) = IA(I)
      JH(NH) = JA(I)
      KH(NH) = KA(I)
      LH(NH) = LA(I)
      ICH(NH) = ICA(I)
  100 CONTINUE
      RETURN
      END
