c-----------------------------------------------------------------------
      PROGRAM PARM5
c
c     Amber 5 PARM  
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c
#include "sizes.h"
#include "pertrb.h"
c
      logical pertur,binary,newfrc,pol
      common /files/ input, output, edtbin, topol, prmcrd, frcfld,
     $               frcmod, owrite
      character*80   input, output, edtbin, topol, prmcrd, frcfld,
     $               frcmod
      character owrite
      common/infom/natoms,nres,nbond,ntheta,nphi,nbuild
      common/fixp/mbond,mtheta,mphi,mumbnd,mumang,mptra,nptra
      common/miscl/lstdrw,ntotrs,iconn,na0,na1,itypco,mlast,isymdu
      common/crossl/ircrss,ncross,ncrosf,iacrss(maxcrs),jacrss(maxcrs),
     $              icros(maxcrs),jcros(maxcrs)
      common/genl/ntotat,nmol,nummol,namres,ibond(maxmol),
     $            itheta(maxmol),iphi(maxmol),natml(maxmol),
     $            moltyp(maxmol),nfresm(maxmol)
      common/infor/labres(maxres),itres(maxres),ibres(maxres),
     $             ipres(maxres)
      common/zmat/r(maxatm),theta(maxatm),phi(maxatm)
      common/infoa/chrg(maxatm),igraph(maxatm),isymbl(maxatm),
     $             itree(maxatm),join(maxatm),irotat(maxatm),
     $             iac(maxatm),amass(maxatm),ATPOL(maxatm)
      common/bond/ib(maxbnd),jb(maxbnd)
      common/angl/it(maxang),jt(maxang),kt(maxang)
      common/dihed/ip(maxdih),jp(maxdih),kp(maxdih),lp(maxdih)
      common/nonbon/next,numex(maxatm),natex(maxexc)
      common/parms/rk(maxbpt),req(maxbpt),tk(maxapt),teq(maxapt),
     $             pk(maxdpt),pn(maxdpt),phase(maxdpt),cn1(maxljp),
     $             cn2(maxljp),solty(maxtyp)
      common/hbpar/asol(maxhbp),bsol(maxhbp),ag(maxhbp),bg(maxhbp),
     $             hbcut(maxhbp)
      common/paspar/numbnd,numang,numphi,numphn,iz3,ibt(maxbpt),
     $              jbt(maxbpt),itt(maxapt),jtt(maxapt),ktt(maxapt),
     $              ipt(maxdpt),jpt(maxdpt),kpt(maxdpt),lpt(maxdpt),
     $              iipt(maxipt),jjpt(maxipt),kkpt(maxipt),
     $              llpt(maxipt),ipntr(maxdpt),no(maxnbt,maxnbt)
      common/typat/natyp,ntypes,kndsym(maxtyp),iredef(maxtyp),
     $             jredef(maxtyp),iatuse(maxtyp),wtb(maxtyp),
     $             atpb(maxtyp)
      common/pashnb/namnb,nhb,iz2,kht1(maxhbp),kht2(maxhbp),
     $              nht1(maxhbp),nht2(maxhbp)
      common/iofile/in,iout,ioutb,iwi,iwn,iwa,iwo,inpo,iwp
      common/ioparm/in2,in3,in4,ioutc,ioutd,iparml,iohb,ionb
      common/worka/icb(maxbnd),ict(maxang),icp(maxdih),iwork(maxwrk)
      common/perlis/nbper,ngper,ndper,mbper,mgper,mdper,ibper(maxpvt),
     $              jbper(maxpvt),icbper(maxppt),itper(maxpvt),
     $              jtper(maxpvt),ktper(maxpvt),ictper(maxppt),
     $              ipper(maxpvt),jpper(maxpvt),kpper(maxpvt),
     $              lpper(maxpvt),icpper(maxppt)
      common/polar/pol
C
      common/runhed/ititl(20),ititl1(20)
c
      double precision tchrg,tcgper
C
      data ibin /3HBIN /
      data ifor /3HFOR /
      data jfcon/4HCONS/
      data kpert/4HPERT/
      data kpola/4HPOLA/
      data iblnk4/4H    /
C
C     ----- initialize the io units -----
C
      in = 5
      in2 = 10
      in3 = 15
      in4 = 16
c
      iout = 6
      ioutb = 12
      ioutc = 18
c
c     --- get file names ---
c
      call prmfil
C
C     --- open input, output, and force field parameter files ---
C
c     subr amopen(lun,   fname,fstat,fform,facc)
      call amopen(iout, output, owrite,  'F',  'W')
      call amopen(in,    input, 'O',  'F',  'R')
      call amopen(in2,  frcfld, 'O',  'F',  'R')
C
C     ----- READ THE CONTROL DATA -----
C
      WRITE(IOUT,9108)
      if (owrite.eq.'U') write(iout, '(2x,a)') '[-O]verwriting output'
      READ(IN,9) ITITL
      WRITE(IOUT,200) ITITL
C
      READ(IN,9) JFORI,KFORM,NAMNB,IFCON,IPERT,ipol
      write(iout,8013) JFORI,KFORM,NAMNB,IFCON,IPERT,ipol
 8013 format(t2,'JFORI',2x,a4,'KFORM',2x,a4,'NAMNB',2x,a4,
     $      /t2,'IFCON',2x,a4,'IPERT',2x,a4,'IPOL ',2x,a4)
c
c     -- check input
c
c     IF(JFORI.EQ.IFOR) then
c          write(iout,'(/2x,a)') 'JFORI = FORM not supported. Use BIN'
c          call mexit(iout, 1)
c     endif
c     if (jfori.ne.ibin) then
c         write(iout,*) ' *** JFORI: expected BIN'
c         call mexit(iout,1)
c     endif
c     if (kform.ne.ibin .and. kform.ne.iblnk4 .and. kform.ne.IFOR) then
c         write(iout,*) ' *** KFORM: expected BIN, FOR or blanks'
c         call mexit(iout,1)
c     endif
c     if (ifcon.ne.jfcon .and. ifcon.ne.iblnk4) then
c         write(iout,*) ' *** format problem: expected CONS or blanks'
c         call mexit(iout,1)
c     endif
c     if (ipert.ne.kpert .and. ipert.ne.iblnk4) then
c         write(iout,*) ' *** format problem: expected PERT or blanks'
c         call mexit(iout,1)
c     endif
c     if (ipol.ne.kpola .and. ipol.ne.iblnk4) then
c         write(iout,*) ' *** format problem: expected POLA or blanks'
c         call mexit(iout,1)
c     endif
c
      BINARY = KFORM.EQ.IBIN
      PERTUR = IPERT.EQ.KPERT
      pol = ipol.eq.kpola
      WRITE(IOUT,235) NAMNB
      IF(IFCON.EQ.JFCON) WRITE(IOUT,9118)
      IF(PERTUR) WRITE(IOUT,9218)
      if (pol) write(iout,9318)
 9318 format('%PARM-I-SETUP, Polarization setup run')
      IF(BINARY) WRITE(IOUT,9128)
      IF(.NOT.BINARY) WRITE(IOUT,9138)
C
C      ----- READ THE DUMPING INFOFMATION -----
C
C            ILBP = 1 LABEL ALL BONDS WITH PARAMETER NUMBER
C            ILTP = 1 LABEL ALL ANGLES WITH PARAMETER NUMBER
C            ILPP = 1 LABEL ALL DIHEDRALS WITH PARAMETER NUMBER
C
      READ(IN,400) ILBP,ILTP,ILPP
C
C            IPARML = 1 LIST ALL modified PARAMETERS
c                   = 2 list all parameters
C            IOHB   = 1 LIST ALL HB PAIR TYPES
C            IONB   = 1 LIST ALL NB PAIR TYPES
C
      READ(IN,400) IPARML,IOHB,IONB
C
C     ----- READ THE EDIT BINARY MOLECULAR TOPOLOGY FILE -----
C
      call amopen(in3,edtbin, 'O',  'U',  'R')
      CALL READIN(JFORI)
      close(unit=in3)
      NAT = NTOTAT
C
C     ----- IF PERTURBATION IS INVOKED READ THE MAPPING -----
C
      IF(PERTUR) CALL GETPER
      IF(PERTUR) CALL PERSEP
C
C     ----- READ THE PARAMETERS. THESE ARE READ THROUGH UNIT IN2 -----
C
      nogo = 0
c
c  --- modifications will be read in through the file frcmod:
c
#ifdef VMS
      open(unit=16, status='OLD', iostat=ios)
      if (ios.eq.0) then
        newfrc = .true.
        close(16)
      else
        newfrc = .false.
      endif
  313 continue
#else
      inquire(file=frcmod,exist=newfrc)
#endif
      if (newfrc) then
         call amopen(in4,  frcmod, 'O',  'F',  'R')
      else if (frcmod .ne. 'frcmod') then
         write(6, *) 'frcmod file: ', frcmod, ' does not exist'
         call mexit(6, 1)
      endif
      CALL PARMR(NOGO,PERTUR,newfrc)
C
C     ----- LOAD THE CONSTRAINED PARAMETERS AND PUT THEM AFTER ALL
C           THE REGULAR PARAMETERS -----
C
      MBOND = NBOND
      MTHETA = NTHETA
      MPHI = NPHI
      MUMBND = NUMBND
      MUMANG = NUMANG
      MPTRA  = NPTRA
      IF(IFCON.EQ.JFCON) CALL RCONST(NOGO)
      close(unit=in2)
C
C     ----- NOW GENERATE THE PARAMETERS AND THE POINTERS -----
C
C     ----- THE BOND PARAMETER POINTER -----
C
      CALL POINTB(IB,JB,ICB,ISYMBL,NBOND,NOGO)
C
C     ----- IF PERTURBATION IS ON GENERATE THE DUAL POINTER FOR
C           THE PERTURBED BONDS -----
C
      IF(PERTUR) CALL PERTB(IBPER,JBPER,ICBPER,ISYMBL,1,
     +                      NBPER,NOGO)
      IF(PERTUR) CALL PERTB(IBPER,JBPER,ICBPER,ISMPER,2,
     +                      NBPER,NOGO)
C
      IF(MBOND.EQ.NBOND) GO TO 220
      NPL = NBOND+1
      MPL = NUMBND
      DO 221 I = NPL,MBOND
      MPL = MPL+1
      ICB(I) = MPL
  221 CONTINUE
  220 CONTINUE
C
C     ----- DUMP THE BOND INFORMATION IF NECESSARY -----
C
      IF(ILBP.NE.1) GO TO 1001
      write(iout,'(/ /5x,a,/)') 'All Bonds in System:'
      DO 35 I = 1,NBOND
      I1 = (IB(I)+3)/3
      J1 = (JB(I)+3)/3
      WRITE(IOUT,45) I,I1,J1,ISYMBL(I1),ISYMBL(J1),ICB(I)
   35 CONTINUE
 1001 CONTINUE
C
C     ----- GENERATE THE POINTER FOR ANGLE PARAMETER -----
C
      CALL POINTT(IT,JT,KT,ICT,ISYMBL,NTHETA,NOGO)
C
C     ----- GENERATE THE POINTER FOR PERTURBED LIST -----
C
      IF(PERTUR) CALL PERTG(ITPER,JTPER,KTPER,ICTPER,ISYMBL,1,
     +                      NGPER,NOGO)
      IF(PERTUR) CALL PERTG(ITPER,JTPER,KTPER,ICTPER,ISMPER,2,
     +                      NGPER,NOGO)
C
      IF(MTHETA.EQ.NTHETA) GO TO 222
      NPL = NTHETA+1
      MPL = NUMANG
      DO 223 I = NPL,MTHETA
      MPL = MPL+1
      ICT(I) = MPL
  223 CONTINUE
  222 CONTINUE
C
C     ----- DUMP IF NECESSARY -----
C
      IF(ILTP.NE.1) GO TO 1002
      write(iout,'(/ /5x,a,/)') 'All Angles in System:'
      DO 36 I = 1,NTHETA
      I1 = (IT(I)+3)/3
      J1 = (JT(I)+3)/3
      K1 = (KT(I)+3)/3
      WRITE(IOUT,46) I,I1,J1,K1,ISYMBL(I1),ISYMBL(J1),ISYMBL(K1),ICT(I)
   36 CONTINUE
 1002 CONTINUE
C
C     ----- GENERATE THE POINTER FOR THE DIHEDRAL PARAMETER -----
C
      CALL POINTP(IP,JP,KP,LP,ICP,ISYMBL,IGRAPH,NPHI,NOGO)
C
C     ----- GENERATE THE POINTER FOR PERTURBED ATOMS -----
C
      IF(PERTUR) CALL PERTD(IPPER,JPPER,KPPER,LPPER,ICPPER,ISYMBL,
     +                      IGRAPH,1,NDPER,NOGO)
      IF(PERTUR) CALL PERTD(IPPER,JPPER,KPPER,LPPER,ICPPER,ISMPER,
     +                      IGRPER,2,NDPER,NOGO)
C
      IF(MPHI.EQ.NPHI) GO TO 224
      NPL = NPHI+1
      MPL = NPTRA
      DO 225 I = NPL,MPHI
      MPL = MPL+1
      ICP(I) = MPL
  225 CONTINUE
  224 CONTINUE
C
C     ----- DUMP IF NECESSARY -----
C
      IF(ILPP.NE.1) GO TO 1003
      write(iout,'(/ /5x,a,/)') 'All Dihedrals in System:'
      WRITE(IOUT,'(9x,''I     I1    J1    K1     L1             ICP'')')
      DO 37 I = 1,NPHI
      KPP = abs(KP(I))
      LPP = abs(LP(I))
      I1 = (IP(I)+3)/3
      J1 = (JP(I)+3)/3
      K1 = (KPP+3)/3
      k1a = k1
      if (kp(i).lt.0) k1a = -k1
      L1 = (LPP+3)/3
      l1a = l1
      if (lp(i).lt.0) l1a = -l1
      WRITE(IOUT,47) I,I1,J1,K1a,L1a,ISYMBL(I1),ISYMBL(J1),ISYMBL(K1),
     +     ISYMBL(L1),ICP(I)
   37 CONTINUE
 1003 CONTINUE
      do 58 i = 1,ntotat
         if(iaper(i).eq.0) then
            polper(i) = atpol(i)
         endif
   58 continue
C
C     ----- CONVERT THE CHARGES TO KCAL SCALE (18.2223 = sqrt(332)  -----
C
      DO 60 I = 1,NTOTAT
           tchrg = chrg(i)
           tcgper = cgper(i)
           chrg(i) = tchrg * 18.2223d0
           cgper(i) = tcgper * 18.2223d0
   60 CONTINUE
C
C     ----- OUTPUT THE COORDINATES IN BINARY FORM -----
C
      IF (BINARY) then
           call amopen(ioutc,prmcrd, owrite,  'U',  'W')
           call amopen(ioutb,topol,  owrite,  'U',  'W')
      else
           call amopen(ioutc,prmcrd, owrite,  'F',  'W')
           call amopen(ioutb,topol,  owrite,  'F',  'W')
      endif
      CALL PUTMDX(IOUTC,NTOTRS,NTOTAT,IGRAPH,R,THETA,PHI,LABRES,IPRES,
     +            BINARY)
      close(unit=ioutc)
C
C     ----- NOW ALL THE DATA ARE AVAILABLE AND GENERATE THE MOLECULAR
C           TOPOLOGY FILE FOR DYNAMICS -----
C
#ifdef VMS
      if (newfrc) write(iout, '(4x,a)') '** USED FRCMOD FILE UNIT 16'
#else
      if (newfrc) write(iout, '(a,4x,a,2x,a)') '|',
     .               '** USED FRCMOD FILE ', frcmod
#endif
      IF (NOGO .gt. 0) then
           close(unit=ioutb,status='delete')
           WRITE(IOUT,450)
           call mexit(iout, 1)
      endif
      CALL MDPARM(IOUTB,BINARY,PERTUR,NOGO)
      close(unit=ioutb)
      WRITE(IOUT,1450)
C
      call mexit(iout, 0)
c
    9 FORMAT(20A4)                                                      
   45 FORMAT(4X,I5,'.',2X,2I5,3X,A2,'-',A2,I4)
   46 FORMAT(4X,I5,'.',2X,3I5,3X,A2,'-',A2,'-',A2,3X,I4)
   47 FORMAT(4X,I5,'.',2X,4I5,3X,A2,'-',A2,'-',A2,'-',A2,3X,I4)
  200 FORMAT(4X,19A4)
  235 FORMAT(4X,'NONBONDED PARAMETER SET = ',A4,/)
  400 FORMAT(10I5)
 9108 FORMAT(/10X,54(1H-),/10X,
     +       'Amber 5          PARM                       UCSF 1997',
     +       /10X,54(1H-),/)
 9118 FORMAT(4X,'INTERNAL CONSTRAINTS ARE PRESENT',/)
 9128 FORMAT(4X,'TOPOLOGY FILE WILL BE BINARY',/)
 9138 FORMAT(4X,'TOPOLOGY FILE WILL BE FORMATTED',/)
 9218 FORMAT(4X,'THIS IS A PERTURBATION RUN',/)
c
  450 FORMAT(/4X,'PARM-F-UHOSED, try again.')
 1450 FORMAT(4X,'PARM-I-NOPROB, successful completion of parm program')
      END
