c-----------------------------------------------------------------------
      SUBROUTINE POINTB(IB,JB,ICB,ISYMBL,NBOND,NOGO)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE BOND PARAMTER POINTER -----
C
#include "sizes.h"
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION IB(*),JB(*),ICB(*),ISYMBL(*)
C
      DO 1 I = 1,NBOND
      IB1 = IB(I)
      JB1 = JB(I)
      IB(I) = 3*IB1-3
      JB(I) = 3*JB1-3
      IS1 = ISYMBL(IB1)
      JS1 = ISYMBL(JB1)
      DO 3 J = 1,NUMBND
      IF(IS1.EQ.IBT(J).AND.JS1.EQ.JBT(J)) GO TO 31
      IF(JS1.EQ.IBT(J).AND.IS1.EQ.JBT(J)) GO TO 31
    3 CONTINUE
      WRITE(IOUT,95) IS1,JS1,IB1,JB1
      NOGO = NOGO+1
   31 ICB(I) = J
    1 CONTINUE
      RETURN
   95 FORMAT(4x,'Missing bond parameter: ',a2,'-',a2,5x,
     +       '(atoms ', i5,'-',i5,')')
      END
