c-----------------------------------------------------------------------
      SUBROUTINE POINTT(IT,JT,KT,ICT,ISYMBL,NTHETA,NOGO)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE BOND PARAMTER POINTER -----
C
#include "sizes.h"
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION IT(*),JT(*),KT(*),ICT(*),ISYMBL(*)
C
      DATA ITYPX /2HX  /
C
      DO 1 I = 1,NTHETA
      IT1 = IT(I)
      JT1 = JT(I)
      KT1 = KT(I)
      IT(I) = 3*IT1-3
      JT(I) = 3*JT1-3
      KT(I) = 3*KT1-3
      IS1 = ISYMBL(IT1)
      JS1 = ISYMBL(JT1)
      KS1 = ISYMBL(KT1)
C
C     ----- FIRST FIND GENERAL ATOM TYPE -----
C
      MTEMP = 0
      DO 10 JJ = 1,NUMANG
      IF(ITT(JJ).NE.ITYPX) GO TO 12
      IF(JS1.EQ.JTT(JJ)) GO TO 11
   10 CONTINUE
      WRITE(IOUT,100) IS1,JS1,KS1,IT1,JT1,KT1
      NOGO = NOGO+1
      GO TO 4
   11 MTEMP = JJ
   12 CONTINUE
      DO 2 J = JJ,NUMANG
      IF(JS1.NE.JTT(J)) GO TO 2
      IF(IS1.EQ.ITT(J).AND.KS1.EQ.KTT(J)) GO TO 3
      IF(KS1.EQ.ITT(J).AND.IS1.EQ.KTT(J)) GO TO 3
    2 CONTINUE
      IF(MTEMP.GT.0) GO TO 4
      WRITE(IOUT,100) IS1,JS1,KS1,IT1,JT1,KT1
      NOGO = NOGO+1
    3 MTEMP = J
    4 ICT(I) = MTEMP
    1 CONTINUE
      RETURN
  100 FORMAT(4X,'Missing angle parameter: ',A2,'-',A2,'-',A2,
     +       ' (atoms ',I5,'-',I5,'-',I5,')')
      END
