c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      SUBROUTINE PUTMDX(NF,NRES,NAT,IGRAPH,X,Y,Z,LBRES,IPRES,BINARY)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL BINARY
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
C     ----- OUTPUT THE COORDINATES FOR DYNAMICS -----
C
      DIMENSION X(*),Y(*),Z(*),IGRAPH(*),LBRES(*),IPRES(*)
C
      IF(.NOT.BINARY) GO TO 200
C
      WRITE(NF) ITITL
      WRITE(NF) NAT
      WRITE(NF) (X(I),Y(I),Z(I),I = 1,NAT)
      GO TO 300
C
C     ----- FORMATTED OUTPUT -----
C
  200 CONTINUE
      WRITE(NF,9008) ITITL
      WRITE(NF,9018) NAT
      WRITE(NF,9038) (X(I),Y(I),Z(I),I=1,NAT)
  300 CONTINUE
c
 9008 FORMAT(20A4)
 9018 FORMAT(10I5)
*9028 FORMAT('ATOM',2X,I5,1X,A4,1X,A3,2X,I4,4X,3F8.3)
 9038 FORMAT(6F12.7)
c
      RETURN
      END
