c-----------------------------------------------------------------------
      SUBROUTINE SETEQV(NATYP,NHB,NXCHG,KNDSYM,IREDEF,IXCHG,JXCHG,
     +                  KHTA,KHTB)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO READ EQUIVALENT ATOMS AND GIVE THE SAME
C           ATOM TYPES FOR THE SAME GROUP -----
C
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/IOPARM/IN2,IN3,in4,IOUTC,IOUTD,IPARML,IOHB,IONB
      DIMENSION KNDSYM(*),IREDEF(*),IXCHG(*),JXCHG(*),KHTA(*),KHTB(*)
      DIMENSION IEQV(20)
      EQUIVALENCE (IORG,IEQV(1))
C
      DATA IBLNK/4H    /
C
      NXCHG = 0
  100 CONTINUE
      READ(IN2,9008) (IEQV(I),I=1,20)
      IF(IORG.EQ.IBLNK) GO TO 500
C
      WRITE(IOUT,9108) (IEQV(I),I=1,20)
C
C     ----- REMOVE THE HB TYPE ATOMS FROM THE EQV SET -----
C
      DO 300 I = 1,20
      JORG = IEQV(I)
      IF(JORG.EQ.IBLNK) GO TO 300
      DO 320 J = 1,NHB
      IF(JORG.EQ.KHTA(J) .OR. JORG.EQ.KHTB(J)) GO TO 340
  320 CONTINUE
      GO TO 300
  340 CONTINUE
      WRITE(IOUT,9168) JORG
      IEQV(I) = IBLNK
  300 CONTINUE
      J = 0
      DO 360 I = 1,20
      IF(IEQV(I).EQ.IBLNK) GO TO 360
      J = J+1
      IEQV(J) = IEQV(I)
  360 CONTINUE
      IF(J.GE.20) GO TO 400
      DO 380 I = J+1,20
      IEQV(I) = IBLNK
  380 CONTINUE
  400 CONTINUE
C
C     ----- CHECK IF IORG IS IN THE ATOM TYPES LOADED. OTHERWISE
C           EXCHANGE IT -----
C
      DO 120 I = 1,NATYP
      IF(IORG.EQ.KNDSYM(I)) GO TO 200
  120 CONTINUE
      DO 140 J = 2,20
      JORG = IEQV(J)
      DO 160 I = 1,NATYP
      IF(JORG.EQ.KNDSYM(I)) GO TO 180
  160 CONTINUE
  140 CONTINUE
*     WRITE(IOUT,9118)
      GO TO 100
  180 CONTINUE
      NXCHG = NXCHG+1
      IXCHG(NXCHG) = IORG
      JXCHG(NXCHG) = JORG
      IEQV(J) = IORG
      WRITE(IOUT,9148) IORG,JORG
      IORG = JORG
C
  200 CONTINUE
      NUMTYP = I
      DO 220 J = 2,20
      JEQV = IEQV(J)
      IF(JEQV.EQ.IBLNK) GO TO 100
      DO 240 I = 1,NATYP
      IF(JEQV.EQ.KNDSYM(I)) GO TO 280
  240 CONTINUE
*     WRITE(IOUT,9128) JEQV
      GO TO 220
  280 CONTINUE
C
C     ----- CHECK FOR EQUIVALENCING OF ITS OWN -----
C
      IF(JEQV.NE.IORG) GO TO 230
      WRITE(IOUT,9248) JEQV,IORG
      GO TO 220
  230 CONTINUE
      IREDEF(I) = NUMTYP
  220 CONTINUE
C
      GO TO 100
  500 CONTINUE
      WRITE(IOUT,9158) NXCHG
      RETURN
c
 9008 FORMAT(20A4)
 9108 FORMAT(4X,'ATOM TYPE ',2X,A4,'IS EQUIVALENT TO',2X,20A4,/)
*9118 FORMAT(4X,'THE WHOLE EQUIVALENCE GROUP IS NOT USED',/)
*9128 FORMAT(4X,'ATOM TYPE ',2X,A4,'IS NOT USED IN THE SYSTEM',/)
 9148 FORMAT(4X,'ATOM TYPE ',2X,A4,'IS EXCHANGED FOR',2X,A4,/)
 9158 FORMAT(4X,'TOTAL NUMBER OF EXCHANGED ATOM TYPES =',I5,/)
 9248 FORMAT(4X,'ATOM TYPE ',A4,'  IS EQUIVALENT TO ITS OWN ',A4,/)
 9168 FORMAT(4X,'Equivalence Disallowed: ',a4,' is Hbonding type',/)
      END
