c-----------------------------------------------------------------------
      SUBROUTINE ANGPAR
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE BOND LIST -----
C
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/PARLIS/NTYPES,NBPAR,NGPAR,NDPAR,ISMPAR(2,1000),
     +              IBPAR(2,1000),JBPAR(2,1000),ITPAR(2,1000),
     +              JTPAR(2,1000), KTPAR(2,1000),IDPAR(2,1000),
     +       JDPAR(2,1000),KDPAR(2,1000),LDPAR(2,1000),ISMAT(2,1000)
C
      NGPAR = 0
      DO 200 I = 1,NTHETA
      IAT = IT(I)
      JAT = JT(I)
      KAT = KT(I)
      IF(IAT.LE.0 .OR. JAT.LE.0 .OR. KAT.LE.0) GO TO 200
C     IATY = ISMAT(1,IAT)
C     JATY = ISMAT(1,JAT)
C     KATY = ISMAT(1,KAT)
C     IF(IATY.EQ.0 .AND. JATY.EQ.0 .AND. KATY.EQ.0) GO TO 200
      IATY = MIN0(ISMAT(2,IAT),ISMAT(2,KAT))
      KATY = MAX0(ISMAT(2,KAT),ISMAT(2,IAT))
      JATY = ISMAT(2,JAT)
      NGPAR = NGPAR+1
      ITPAR(1,NGPAR) = ISMPAR(1,IATY)
      JTPAR(1,NGPAR) = ISMPAR(1,JATY)
      KTPAR(1,NGPAR) = ISMPAR(1,KATY)
      ITPAR(2,NGPAR) = IAT
      JTPAR(2,NGPAR) = JAT
      KTPAR(2,NGPAR) = KAT
  200 CONTINUE
      MGPAR = 0
      DO 220 I = 1,NGPAR
      LABA = ITPAR(1,I)
      LABB = JTPAR(1,I)
      LABC = KTPAR(1,I)
      IF(LABA.EQ.0) GO TO 220
      DO 240 J = I+1,NGPAR
      IF(ITPAR(1,J).NE.LABA .OR. KTPAR(1,J).NE.LABC .OR.
     +   JTPAR(1,J).NE.LABB) GO TO 240
      ITPAR(1,J) = 0
  240 CONTINUE
  220 CONTINUE
      DO 260 I = 1,NGPAR
      IF(ITPAR(1,I).EQ.0) GO TO 260
      MGPAR = MGPAR+1
      ITPAR(1,MGPAR) = ITPAR(1,I)
      JTPAR(1,MGPAR) = JTPAR(1,I)
      KTPAR(1,MGPAR) = KTPAR(1,I)
      ITPAR(2,MGPAR) = ITPAR(2,I)
      JTPAR(2,MGPAR) = JTPAR(2,I)
      KTPAR(2,MGPAR) = KTPAR(2,I)
  260 CONTINUE
      NGPAR = MGPAR
      RETURN
      END
