c-----------------------------------------------------------------------
      SUBROUTINE ANGPIK
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,ITT(2000),JTT(2000),KTT(2000)
      COMMON/DIHED/NPHI,IT(2500),JT(2500),KT(2500),LPP(2500)
      COMMON/INFOP/NEXT,IIP(2500),JJP(2500),KKP(2500),LLP(2500),
     +             IPB(2500)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      IP = 0
      IF = NBOND-1
      DO 10 I = 1,IF
      I1 = IB(I)
      J1 = JB(I)
      JS = I
   11 JS = JS+1
      IF(JS.GT.NBOND) GO TO 10
      K1 = IB(JS)
      IF(K1.NE.I1) GO TO 12
      IP = IP+1
      IT(IP) = J1
      JT(IP) = I1
      KT(IP) = JB(JS)
      GO TO 11
   12 CONTINUE
      DO 40 J = JS,NBOND
      K1 = IB(J)
      L1 = JB(J)
      IF(K1.GT.J1) GO TO 42
      IF(J1.EQ.K1) GO TO 41
      IF(J1.NE.L1) GO TO 40
      IP = IP+1
      IT(IP) = I1
      JT(IP) = J1
      KT(IP) = K1
      GO TO 40
   41 CONTINUE
      IP = IP+1
      IT(IP) = I1
      JT(IP) = J1
      KT(IP) = L1
   40 CONTINUE
   42 CONTINUE
   10 CONTINUE
      NTHETA = IP
      IF(NTHETA.EQ.0) RETURN
C
      DO 43 I = 1,NTHETA
   43 IPB(I) = I
      CALL SORTS(IT,KT,IPB,NTHETA)
      DO 44 I = 1,NTHETA
      J = IPB(I)
      ITT(I) = IT(J)
      JTT(I) = JT(J)
   44 KTT(I) = KT(J)
      WRITE(IOUT,100)
      DO 50 I = 1,NTHETA
      WRITE(IOUT,101) I,ITT(I),JTT(I),KTT(I)
   50 CONTINUE
      RETURN
  100 FORMAT(1H ,/ /,10X,'BOND ANGLES ',/)
  101 FORMAT(1H ,5X,4I6)
      END
