c-----------------------------------------------------------------------
      SUBROUTINE DIHPIK
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/DIHED/NPHI,IPP(2500),JPP(2500),KPP(2500),LPP(2500)
      COMMON/INFOP/NEXT,IP(2500),JP(2500),KP(2500),LP(2500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      NPHII =  NPHI
    1 DO 37 I = 1,NBOND
        I1 = IB(I)
        J1 = JB(I)
        DO 38 J = 1,NBOND
          IF(J.EQ.I) GO TO 38
          I2 = IB(J)
          J2 = JB(J)
          IF(I2.GT.I1) GO TO 37
          K1 = 0
          IF(I2.EQ.I1) K1 = J2
          IF(J2.EQ.I1) K1 = I2
          IF(K1.EQ.0) GO TO 38
          DO 39 K = 1,NBOND
            IF(K.EQ.I) GO TO 39
            I3 = IB(K)
            J3 = JB(K)
            IF(I3.GT.J1) GO TO 38
            L1 = 0
            IF(I3.EQ.J1) L1 = J3
            IF(J3.EQ.J1) L1 = I3
            IF(L1.EQ.0) GO TO 39
            NPHI = NPHI+1
            IF (L1.gt.K1) then
              IP(NPHI) = K1
              JP(NPHI) = I1
              KP(NPHI) = J1
              LP(NPHI) = L1
            else
              IP(NPHI) = L1
              JP(NPHI) = J1
              KP(NPHI) = I1
              LP(NPHI) = K1
          endif
   39     CONTINUE
   38   CONTINUE
   37 CONTINUE
      IF(NPHI.EQ.0) RETURN
C
      DO 41 I = 1,NPHI
   41 IPB(I) = I
      CALL SORTS(IP,LP,IPB,NPHI)
      IPRE = -999
      NP = 1
      NBB = 1
      NNPHI = NPHI
      I = 0
      DO 42 ICNT = 1,NNPHI
      K = IPB(ICNT)
C
C     ----- MARK IMPROPER TORSIONS WITH A '-' IN COLUMN 4 -----
C
      IF(K.GT.NPHII) GO TO 200
      I = I+1
      IPP(I) = IP(K)
      JPP(I) = JP(K)
      KPP(I) = KP(K)
      LPP(I) = -LP(K)
      GO TO 42
  200 CONTINUE
      II = IP(K)
      LL = LP(K)
C
C     ----- REMOVE DIHEDRAL ANGLES WITH SAME END ATOM
C           THIS CAN RESULT FROM 3 MEMBERED RINGS -----
C
      IF(II.EQ.LL) NPHI = NPHI-1
      IF(II.EQ.LL) GO TO 42
      I = I+1
      IPP(I) = II
      JPP(I) = JP(K)
      KPP(I) = KP(K)
      LPP(I) = LL
C
C     ----- REMOVE UNWANTED NONBONDED CONTRIBUTIONS FROM 5 MEMBERED
C           RINGS, ETC -----
C
      IF(II.LT.1) GO TO 75
      IF(LL.GT.NATOM) GO TO 75
      IF(ISYMBL(II).EQ.ISYMDU) GO TO 75
      IF(ISYMBL(LL).EQ.ISYMDU) GO TO 75
      GO TO 76
   75 CONTINUE
      NPHI = NPHI-1
      I = I-1
      WRITE(IOUT,119) II,JP(K),KP(K),LL
      GO TO 42
   76 CONTINUE
C
C     ----- THIS SECTION IS NECESSARY FOR 4 MEMBERED RINGS -----
C
      DO 160 J = NBB,NBOND
      IF(IB(J).GT.II) GO TO 161
      IF(IB(J).LT.II) GO TO 160
      IF(JB(J).GT.LL) GO TO 161
      IF(JB(J).LT.LL) GO TO 160
      KPP(I) = -IABS(KPP(I))
  160 CONTINUE
      J = NBOND
  161 NBB = J
C
C     ----- THIS SECTION NECESSARY FOR 5 MEMBERED RINGS -----
C
      DO 60 J = NP,NTHETA
      IF(IT(J).GT.II) GO TO 61
      IF(IT(J).LT.II) GO TO 60
      IF(KT(J).GT.LL) GO TO 61
      IF(KT(J).LT.LL) GO TO 60
      KPP(I) = -IABS(KPP(I))
   60 CONTINUE
      J = NTHETA
C
C     ----- IT(J).LT.II AND NO IPB SEARCHING BELOW THIS NUMBER -----
C
   61 NP = J
      IF(LL.NE.IPRE) GO TO 43
      IF(II.NE.JPRE) GO TO 43
C
C     ----- IDENTIFY DIHEDRALS WITH SAME END ATOMS -----
C
      KPP(I) = -IABS(KPP(I))
   43 IPRE = LL
      JPRE = II
   42 CONTINUE
      WRITE(IOUT,101)
      DO 50 I = 1,NPHI
      WRITE(IOUT,102) I,IPP(I),JPP(I),KPP(I),LPP(I)
   50 CONTINUE
      RETURN
  101 FORMAT(1H ,/ /,10X,'DIHEDRAL ANGLES ',/)
  102 FORMAT(1H ,5X,5I6)
c
  119 FORMAT(t2,'PREP-WARNING: Torsion angle ',4I4,3X,
     +        'has atoms outside residue range',/)
      END
