c-----------------------------------------------------------------------
      SUBROUTINE FINDN(NATOM,NAME,NUM,IGRAPH)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- LOCATES THE ATOM THAT HAS THE GRAPH NAME 'NAME' -----
C
C           +M  DESIGNATES THE NEXT MAIN ATOM - WHICH WILL BE NAT+1
C           -M  DESIGNATES THE LAST MAIN ATOM IN THE PREVIOUS RESIDUE
C               THIS NUMBER CANT BE CALCULATED UNTIL LINK, AND IS
C               FLAGGED WITH A -1
C               THIS PRECLUDES ANY OTHER NUMBERS BEING READ IN, BUT
C               THESE CAN ALWAYS BE ADDED AS CONSTRAINTS IN THE PARM
C               PROGRAM. AN ALTERNATIVE SOLUTION IS TO READ IN THE
C               NUMBERS AND CONVERT THEM. NOT EASY UNLESS NUMBERS ARE
C               READ IN 1 CHARACTER AT A TIME.
C
      DIMENSION IGRAPH(*)
C
      DATA MPLUS /4H+M   /
      DATA MMINUS /4H-M  /
C
      NUM = -99
      IF(NAME.EQ.MPLUS) NUM = NATOM+1
      IF(NAME.EQ.MMINUS) NUM = -1
      if (num.ne.-99) return

      DO 10 I = 1,NATOM
        IF(IGRAPH(I).EQ.NAME) then
          NUM = I
          RETURN
        endif
   10 CONTINUE
      RETURN
      END
