c-----------------------------------------------------------------------
      SUBROUTINE GENLIS
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      COMMON/PARLIS/NTYPES,NBPAR,NGPAR,NDPAR,ISMPAR(2,1000),
     +              IBPAR(2,1000),JBPAR(2,1000),ITPAR(2,1000),
     +              JTPAR(2,1000), KTPAR(2,1000),IDPAR(2,1000),
     +       JDPAR(2,1000),KDPAR(2,1000),LDPAR(2,1000),ISMAT(2,1000)
C
      DATA IDX/4HX    /
C
C     ----- GENERATE THE UNIQUE POINTERS -----
C
      NTYPES = 0
      NBPAR = 0
      NGPAR = 0
      NDPAR = 0
      ZERO = 0.0E0
      IZER = 0
C
      CALL GENTYP
      CALL BONPAR
      CALL ANGPAR
      CALL PARDIH(NATOM)
C
C     ----- PRINT THE PARAMETER SET FOR THE RESIDUE -----
C
      WRITE(IOUT,9008) NAMRES
      WRITE(3,9008) NAMRES
      WRITE(IOUT,9118) (ISMPAR(1,I),I=1,NTYPES)
      WRITE(3,9118) (ISMPAR(1,I),I=1,NTYPES)
      WRITE(IOUT,9308)
      DO 100 I = 1,NBPAR
      IAT = IBPAR(2,I)
      JAT = JBPAR(2,I)
      CALL DIST(IAT,JAT,X(1,1),X(1,2),X(1,3),VAL)
      WRITE(IOUT,9218) IBPAR(1,I),JBPAR(1,I),ZERO,VAL
      WRITE(3,9018) IBPAR(1,I),JBPAR(1,I),ZERO,VAL
  100 CONTINUE
      WRITE(3,9108)
      WRITE(IOUT,9318)
      DO 120 I = 1,NGPAR
      IAT = ITPAR(2,I)
      JAT = JTPAR(2,I)
      KAT = KTPAR(2,I)
      CALL BANGLE(IAT,JAT,KAT,X(1,1),X(1,2),X(1,3),VAL,1)
      WRITE(IOUT,9228) ITPAR(1,I),JTPAR(1,I),KTPAR(1,I),ZERO,VAL
      WRITE(3,9028) ITPAR(1,I),JTPAR(1,I),KTPAR(1,I),ZERO,VAL
  120 CONTINUE
      WRITE(IOUT,9328)
      WRITE(3,9108)
      DO 140 I = 1,NDPAR
      IAT = IDPAR(2,I)
      JAT = JDPAR(2,I)
      KAT = KDPAR(2,I)
      LAT = LDPAR(2,I)
      CALL TORS(IAT,JAT,KAT,LAT,X(1,1),X(1,2),X(1,3),VAL)
      WRITE(IOUT,9238) IDX,JDPAR(1,I),KDPAR(1,I),IDX,
     +                 IZER,ZERO,VAL,ZERO
      WRITE(3,9038) IDX,JDPAR(1,I),KDPAR(1,I),IDX,
     +              IZER,ZERO,VAL,ZERO
  140 CONTINUE
      RETURN
C
 9008 FORMAT(/10X,'UNIQUE PARAMETER LIST FOR RESIDUE =',A4,/)
 9108 FORMAT(/ /)
 9118 FORMAT(5X,16A4)
 9018 FORMAT(A4,1H-,A4,F12.3,F12.5)
 9028 FORMAT(A4,1H-,A4,1H-,A4,2X,2F12.3)
 9038 FORMAT(A4,1H-,A4,1H-,A4,1H-,A4,I5,3F12.3)
 9218 FORMAT(5X,A4,1H-,A4,F12.3,F12.5)
 9228 FORMAT(5X,A4,1H-,A4,1H-,A4,2X,2F12.3)
 9238 FORMAT(5X,A4,1H-,A4,1H-,A4,1H-,A4,I5,3F12.3)
 9308 FORMAT(/10X,'BOND TYPES FOR THE RESIDUE')
 9318 FORMAT(/10X,'ANGLE TYPES FOR THE RESIDUE')
 9328 FORMAT(/10X,'DIHEDRAL TYPES FOR THE RESIDUE')
      END
