c-----------------------------------------------------------------------
      SUBROUTINE GENTYP
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO GENERATE THE UNIQUE PARAMETER LIST -----
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/PARLIS/NTYPES,NBPAR,NGPAR,NDPAR,ISMPAR(2,1000),
     +              IBPAR(2,1000),JBPAR(2,1000),ITPAR(2,1000),
     +              JTPAR(2,1000), KTPAR(2,1000),IDPAR(2,1000),
     +       JDPAR(2,1000),KDPAR(2,1000),LDPAR(2,1000),ISMAT(2,1000)
C
C     ----- FIRST GENERATE THE ATOM TYPE LIST -----
C
      NTYPES = 1
      ISMPAR(1,1) = ISYMBL(1)
      ISMPAR(2,1) = 1
      ISMAT(1,1) = 1
      ISMAT(2,1) = 1
      DO 100 I = 2,NATOM
      LABEL = ISYMBL(I)
      ISMAT(1,I) = 0
      DO 120 J = 1,NTYPES
      IF(LABEL.EQ.ISMPAR(1,J)) GO TO 140
  120 CONTINUE
      NTYPES = NTYPES+1
      ISMPAR(1,NTYPES) = LABEL
      ISMPAR(2,NTYPES) = I
      ISMAT(1,I) = NTYPES
      ISMAT(2,I) = NTYPES
      GO TO 100
  140 CONTINUE
      ISMAT(2,I) = J
  100 CONTINUE
      RETURN
      END
