c-----------------------------------------------------------------------
      SUBROUTINE LOOPC(CUT,ISYMDU)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      NBONDO = NBOND
      NPL = NBOND+1
      IM = NATOM-1
      DO 10 I = 1,IM
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 10
      JS = I+1
      DO 11 J = JS,NATOM
      IF(ISYMBL(J).EQ.ISYMDU) GO TO 11
      DX = X(I,1)-X(J,1)
      DY = X(I,2)-X(J,2)
      DZ = X(I,3)-X(J,3)
      DIST = DX*DX+DY*DY+DZ*DZ
      IF(DIST.GT.CUT) GO TO 11
      DO 12 K = 1,NBONDO
      IF(IT(K).EQ.I.AND.JT(K).EQ.J) GO TO 11
   12 CONTINUE
      NBOND = NBOND+1
      IT(NBOND) = I
      JT(NBOND) = J
      IF(NBOND.EQ.NPL) WRITE(IOUT,100)
      ADIS = SQRT(DIST)
      NM = NBOND-NBONDO
      WRITE(IOUT,101) NM,I,J,ADIS
   11 CONTINUE
   10 CONTINUE
      RETURN
  100 FORMAT(1H ,/ /,10X,'BONDS ADDED BY LOOP CLOSING ROUTINE ',/)
  101 FORMAT(1H ,5X,3I6,5X,F10.3)
      END
