c-----------------------------------------------------------------------
      SUBROUTINE PARDIH(NATOM)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE DIHED LIST -----
C
c     RevA mod: 27-Feb-88 fix to avoid printing garbage characters
c               when improper dih pointers extend beyond the residue's
c               true atom count - G. Seibel
      COMMON/DIHED/NPHI,IP(2500),JP(2500),KP(2500),LP(2500)
      COMMON/PARLIS/NTYPES,NBPAR,NGPAR,NDPAR,ISMPAR(2,1000),
     +              IBPAR(2,1000),JBPAR(2,1000),ITPAR(2,1000),
     +              JTPAR(2,1000), KTPAR(2,1000),IDPAR(2,1000),
     +       JDPAR(2,1000),KDPAR(2,1000),LDPAR(2,1000),ISMAT(2,1000)
C
      NDPAR = 0
      DO 200 I = 1,NPHI
      IAT = IP(I)
      JAT = JP(I)
      KAT = IABS(KP(I))
      LAT = IABS(LP(I))
      IF(IAT.LE.0 .OR. JAT.LE.0 .OR. KAT.LE.0) GO TO 200
      IF(LAT.LE.0 .OR. LAT.GT.NATOM) GO TO 200
c     --- avoid printing garbage types if improper points off res ---
      if(jat.gt.natom .or. kat.gt.natom) go to 200
C     IATY = ISMAT(1,IAT)
C     JATY = ISMAT(1,JAT)
C     KATY = ISMAT(1,KAT)
C     LATY = ISMAT(1,LAT)
C     IF(IATY.EQ.0 .AND. JATY.EQ.0 .AND. KATY.EQ.0 .AND.
C    +   LATY.EQ.0) GO TO 200
      IATY = ISMAT(2,IAT)
      JATY = ISMAT(2,JAT)
      KATY = ISMAT(2,KAT)
      LATY = ISMAT(2,LAT)
      IF(JATY.GT.KATY) THEN
      IDUM = JATY
      JATY = KATY
      KATY = IDUM
      IDUM = IATY
      IATY = LATY
      LATY = IDUM
      END IF
      NDPAR = NDPAR+1
      IDPAR(1,NDPAR) = ISMPAR(1,IATY)
      JDPAR(1,NDPAR) = ISMPAR(1,JATY)
      KDPAR(1,NDPAR) = ISMPAR(1,KATY)
      LDPAR(1,NDPAR) = ISMPAR(1,LATY)
      IDPAR(2,NDPAR) = IAT
      JDPAR(2,NDPAR) = JAT
      KDPAR(2,NDPAR) = KAT
      LDPAR(2,NDPAR) = LAT
  200 CONTINUE
      MDPAR = 0
      DO 220 I = 1,NDPAR
      LABB = JDPAR(1,I)
      LABC = KDPAR(1,I)
      IF(LABB.EQ.0) GO TO 220
      DO 240 J = I+1,NDPAR
      IF(JDPAR(1,J).NE.LABB .OR. KDPAR(1,J).NE.LABC) GO TO 240
      JDPAR(1,J) = 0
      KDPAR(1,J) = 0
  240 CONTINUE
  220 CONTINUE
      DO 260 I = 1,NDPAR
      IF(JDPAR(1,I).EQ.0) GO TO 260
      MDPAR = MDPAR+1
      IDPAR(1,MDPAR) = IDPAR(1,I)
      JDPAR(1,MDPAR) = JDPAR(1,I)
      KDPAR(1,MDPAR) = KDPAR(1,I)
      LDPAR(1,MDPAR) = LDPAR(1,I)
      IDPAR(2,MDPAR) = IDPAR(2,I)
      JDPAR(2,MDPAR) = JDPAR(2,I)
      KDPAR(2,MDPAR) = KDPAR(2,I)
      LDPAR(2,MDPAR) = LDPAR(2,I)
  260 CONTINUE
      NDPAR = MDPAR
      RETURN
      END
