c-----------------------------------------------------------------------
      SUBROUTINE PGETCOR(MAXATM,NAT,IGRAPH,ISYMBL,ITREE,R,THETA,PHI,
     +                  CHG,SKIP)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     21-Feb-89: added MAXATM to arg list; G. Seibel
      LOGICAL SKIP
C
C     ----- ROUTINE TO GET THE CORRECT TOPOLOGY -----
C
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DIMENSION IGRAPH(*),ISYMBL(*),ITREE(*),R(*),THETA(*),PHI(*)
      DIMENSION CHG(*)
      DIMENSION IFLD(80),IHOL(10),IVAR(10),FVAR(10)
C
      EQUIVALENCE (IVAR(1),IDUM),(IVAR(2),NNC),(IVAR(3),NNB),
     +            (NNA,IVAR(4)),(IHOL(1),I1),(IHOL(2),I2),(IHOL(3),I3),
     +            (FVAR(1),R1),(FVAR(2),T1),(FVAR(3),P1),(FVAR(4),CHRG)
C
      DATA IFLD/1*2, 3*1, 3*2, 4*3, 69*0/
C
      DATA KOMIT,KBEG/4HOMIT,3HBEG/
C
      IF(IOMIT.EQ.KOMIT.AND.IPOS.NE.KBEG) GO TO 200
C
      I = 0
  140 CONTINUE
      I = I+1
      if (i .gt. MAXATM) then
           write(iout,'(/5x,a,i6,a)') 'MAXATM =',MAXATM,' exceeded.'
           call mexit(iout, 1)
      endif
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      IGRAPH(I) = I1
      ISYMBL(I) = I2
      ITREE(I) = I3
      R(I) = R1
      THETA(I) = T1
      PHI(I) = P1
      CHG(I) = CHRG
      IF(IDUM.EQ.0) GO TO 180
      GO TO 140
  180 CONTINUE
      NAT = I-1
      GO TO 100
  200 CONTINUE
        WRITE(IOUT,9008) IPOS
        SKIP =.TRUE.
  100 CONTINUE
      RETURN
 9008 FORMAT(t2,'PREP-F-BADOPT, illegal value for ipos ,IPOS  = ',A4,/)
*9108 FORMAT(I5,1X,A4,3X,A4,4X,A4,3I5,4F10.5)
      END
