c-----------------------------------------------------------------------
      SUBROUTINE WRITEO
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/ZMAT/R(1000),THETA(1000),PHI(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/DIHED/NPHI,IP(2500),JP(2500),KP(2500),LP(2500)
      COMMON/INFOP/NEXT,NUMEX(2500),NATEX(7500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/DRAWP/IC,ICODE(2,2000)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DATA IXYZ / 3HXYZ/
C
      ISTOP = -50
      NBOND = NBOND+1
      NTHETA = NTHETA+1
      NPHI = NPHI+1
      IB(NBOND) = ISTOP
      JB(NBOND) = ISTOP
      IT(NTHETA) = ISTOP
      JT(NTHETA) = ISTOP
      KT(NTHETA) = ISTOP
      IP(NPHI) = ISTOP
      JP(NPHI) = ISTOP
      KP(NPHI) = ISTOP
      LP(NPHI) = ISTOP
C
C     ----- IF KFORM .GT. 0 OUTPUT IN BINARY FORMAT -----
C
      IF(KFORM.GT.0) GO TO 200
C
      WRITE(IOUTB,100) NAMRES,INTX,NATOM,NBOND,NTHETA,NPHI,IC,NEXT
*     WRITE(IOUTB,101) ((ITREE(I),ISYMBL(I),IGRAPH(I)),I = 1,NATOM)
      WRITE(IOUTB,101) (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NATOM)
      WRITE(IOUTB,102) (IB(I),JB(I),I = 1,NBOND)
      WRITE(IOUTB,102) (IT(I),JT(I),KT(I),I = 1,NTHETA)
      WRITE(IOUTB,102) (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      WRITE(IOUTB,102) (IROTAT(I),I = 1,NATOM)
      WRITE(IOUTB,102) (NC(I),I = 1,NATOM)
      WRITE(IOUTB,102) ((ICODE(I,J),I = 1,2),J = 1,IC)
      WRITE(IOUTB,102) (NUMEX(I),I = 1,NATOM)
      WRITE(IOUTB,102) (NATEX(I),I = 1,NEXT)
      WRITE(IOUTB,103) (CHG(I),I = 1,NATOM)
      IF(INTX.EQ.IXYZ) GO TO 10
      WRITE(IOUTB,104) (R(I),THETA(I),PHI(I),I = 1,NATOM)
      GO TO 120
   10 CONTINUE
      WRITE(IOUTB,104) (X(I,1),X(I,2),X(I,3),I = 1,NATOM)
      GO TO 120
C
C     ----- BINARY OUTPUT -----
C
  200 CONTINUE
      WRITE(IOUTB) NAMRES,INTX,NATOM,NBOND,NTHETA,NPHI,IC,NEXT
*     WRITE(IOUTB) ((ITREE(I),ISYMBL(I),IGRAPH(I)),I = 1,NATOM)
      WRITE(IOUTB) (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NATOM)
      WRITE(IOUTB) (IB(I),JB(I),I = 1,NBOND)
      WRITE(IOUTB) (IT(I),JT(I),KT(I),I = 1,NTHETA)
      WRITE(IOUTB) (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      WRITE(IOUTB) (IROTAT(I),I = 1,NATOM)
      WRITE(IOUTB) (NC(I),I = 1,NATOM)
      WRITE(IOUTB) ((ICODE(I,J),I = 1,2),J = 1,IC)
      WRITE(IOUTB) (NUMEX(I),I = 1,NATOM)
      WRITE(IOUTB) (NATEX(I),I = 1,NEXT)
      WRITE(IOUTB) (CHG(I),I = 1,NATOM)
      IF(INTX.EQ.IXYZ) GO TO 20
      WRITE(IOUTB) (R(I),THETA(I),PHI(I),I = 1,NATOM)
      GO TO 120
   20 CONTINUE
      WRITE(IOUTB) (X(I,1),X(I,2),X(I,3),I = 1,NATOM)
  120 CONTINUE
      RETURN
  100 FORMAT(A4,A4,6I6)
  101 FORMAT(20A4)
  102 FORMAT(20I4)
  103 FORMAT(F8.4,9F8.4)
  104 FORMAT(F10.5,7F10.5)
      END
