#include <math.h>

extern double erfc();
/*
 *  C imports for fortran - naming conventions for 
 *	most common fortran linking.
 */

/* single precision version */

void 
erfcfun_(x, erf)
float *x, *erf;
{
  *erf = erfc(*x);
}

/* double precision version */

void 
derfcfun_(x, erf)
double *x, *erf;
{
  *erf = erfc(*x);
}
