#include <stdio.h>
#include <time.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/times.h>
 
int access_( char *path, char *mode )
{
   int ierr, imode;
   int i_r, i_w, i_x, i_e;
 
   i_r = i_w = i_x = i_e = 0;
 
   if ( strstr(mode,"r") != NULL ) i_r = R_OK;
   if ( strstr(mode,"w") != NULL ) i_w = W_OK;
   if ( strstr(mode,"x") != NULL ) i_x = X_OK;
   if ( strstr(mode," ") != NULL ) i_e = F_OK;
 
   imode = i_r | i_w | i_x | i_e ;
   ierr = access(path,imode);
   return ierr;
}
#include <math.h>

extern double erfc();
/*
 *  C imports for fortran - naming conventions for 
 *	most common fortran linking.
 */

/* single precision version */

void 
erfcfun_(x, erf)
float *x, *erf;
{
  *erf = erfc(*x);
}

/* double precision version */

void 
derfcfun_(x, erf)
double *x, *erf;
{
  *erf = erfc(*x);
}
