#include <math.h>

double erfc();

/*
 *  C imports for fortran - naming convention for 
 *	IBM fortran compiler.
 */

/* single precision version */

void 
erfcfun(x, erf)
float	*x, *erf;
{
  *erf = erfc(*x);
}

/* double precision version */

void 
derfcfun(x, erf)
double	*x, *erf;
{
  *erf = erfc(*x);
}
