C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################
c
c
      subroutine amdate
      character*8 dte
      call date(dte)
      write(6,1) dte
    1 format('|',57x,'Run on ',a8)
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c     --- most Unix (BSD, Convex, Sun, Stellar, SGI, but not Unicos) ---
c
      call flush(lun)
      return
      end
c-----------------------------------------------------------------------
      integer function i1mach(i)
c
c --- return number of characters stored in integer variable
c
      if (i.eq.6) then
        i1mach = 8
      else
        write(6,*) 'error in i1mach'
        call mexit(6, 1)
      end if
      return
      end
c-----------------------------------------------------------------------
      subroutine second(tim)
c     JV Wrapper for T3D timer
#ifdef DPREC
      double precision tim
#endif
      real timestart
      save timestart
      logical first 
      data first /.true./
      save first
      
c        ... returned current value of real clock (wall time)
      if(first)then
         timestart = secondr()
         first = .false.
      endif
      tim = secondr()-timestart
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(itim)
      integer itim
c
      itim = int(secondr())
      return
      end
c-----------------------------------------------------------------------
      INTEGER FUNCTION GETARG(I,C)

      CHARACTER *(*) C
      INTEGER I,ILEN,IERROR

      CALL PXFGETARG(I, C, ILEN, IERROR)
      IF(IERROR.NE.0) THEN
         WRITE(6,*)' Error in GETARG '
         STOP
      ENDIF

      GETARG=ILEN
      RETURN
      END
c-----------------------------------------------------------------------
#ifdef MPI
c     Emulated routines necessary for the MPI/AMBER interface...
#include "t3e.f"
#endif


