c-----------------------------------------------------------------------
      SUBROUTINE ACROSB(A,B,C)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- C = A X B - C RETURNED NORMALIZED -----
C
      DIMENSION A(3),B(3),C(3)
C
      X = A(2)*B(3)-B(2)*A(3)
      Y = B(1)*A(3)-A(1)*B(3)
      Z = A(1)*B(2)-B(1)*A(2)
      S = 1./SQRT(X**2+Y**2+Z**2)
      C(1) = X*S
      C(2) = Y*S
      C(3) = Z*S
      RETURN
      END
