c-----------------------------------------------------------------------
      SUBROUTINE CALPO(CO,NOR,IWAT,IPRINT,RSQ,XC,X0)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/CONST/PI,CONV,CONVV
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      DIMENSION RSQ(*),XC(*),X0(*)
      DIMENSION CO(3,3),EPOT(4),XQ(3),A(3),B(3),C(3),D(3)
      DATA ESQ,RCD,ANG/332.17752,0.9572,52.26/
C
      THBCD = ANG*CONV
      ROM = RCD*COS(THBCD)
      RHM = RCD*SIN(THBCD)
      PIH = PI/2.0
      POT = 0.0
      DO 1 I = 1,NOR
      DIS = SQRT(RSQ(I))
      POT = POT+CHRG(I)*ESQ/DIS
    1 CONTINUE
      X = CO(1,1)
      Y = CO(1,2)
      Z = CO(1,3)
      NO = NOR+(IWAT-1)*3
      IF (NO.EQ.NOR) GO TO 6
      MO = NOR+1
      DO 7 I = MO,NO
      DIS = SQRT((R(I)-X)**2+(THETA(I)-Y)**2+(PHI(I)-Z)**2)
    7 POT = POT+CHRG(I)*ESQ/DIS
    6 EPOT(4) = POT
      X = CO(1,1)+0.1
      DO 3 I = 1,3
      POT = 0.0
      DO 2 J = 1,NO
      RR = SQRT((R(J)-X)**2+(THETA(J)-Y)**2+(PHI(J)-Z)**2)
    2 POT = POT+CHRG(J)*ESQ/RR
      EPOT(I) = POT
      IF (I.GE.2) GO TO 4
      X = CO(1,1)
      Y = CO(1,2)+0.1
      GO TO 3
    4 Y = CO(1,2)
      Z = CO(1,3)+0.1
    3 CONTINUE
      EX = -(EPOT(1)-EPOT(4))/0.1
      EY = -(EPOT(2)-EPOT(4))/0.1
      EZ = -(EPOT(3)-EPOT(4))/0.1
      IF (IPRINT .NE. 0) WRITE(IOUT,5) IWAT,EX,EY,EZ,(CO(1,JC),JC = 1,3)
      XNORM = SQRT(EX*EX+EY*EY+EZ*EZ)
      XQ(1) = (EX/XNORM)*ROM+CO(1,1)
      XQ(2) = (EY/XNORM)*ROM+CO(1,2)
      XQ(3) = (EZ/XNORM)*ROM+CO(1,3)
      DO 42 J = 1,3
      A(J) = XC(J)+X0(J)
      B(J) = CO(1,J)
   42 C(J) = XQ(J)
      CALL GENATM(A,B,C,D,RHM,PIH,PIH)
      DO 17 J = 1,3
   17 CO(2,J) = D(J)
      DO 18 J = 1,3
   18 A(J) = CO(2,J)
      CALL GENATM(B,A,C,D,RHM,PI,0.0)
      DO 19 J = 1,3
   19 CO(3,J) = D(J)
      RETURN
    5 FORMAT(4X,' ELECTRIC FIELD COMPONENTS ON MOL. NO.',I4,6F10.4)
      END
