c-----------------------------------------------------------------------
      SUBROUTINE EGAUSS(NF,NAT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO OUTPUT THE ZMATRIX FOR GAUSSIAN 80 -----
C
c     Rev A mods:  Made portable ANSI fortran, but note that this is
c                  on pretty shakey ground - it assumes that atom
c                  symbol starts with single character element symbol,
c                  and only treats the elements listed in elemnt()
#include "sizes.h"
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
C
      DIMENSION NUM(10)
C
      character*1 elemnt(8)
      character*4 buf
      data elemnt/'H','C','N','O','F','S','P',' '/
      DATA NUM  /  1,  6,  7,  8,  9, 16, 15,3*99 /
C
      JAT = 0
      KAT = 0
      LAT = 0
      DIS = 0.0E0
      ANG = 0.0E0
      DIH = 0.0E0
      IDUM = 0
C
      DO 100 I = 1,NAT
           write(buf,'(a4)') isymbl(i)
           DO 120 K = 1,8
                if (buf(1:1) .eq. elemnt(k)) then
                     ian = num(k)
                     go to 140
                endif
  120      CONTINUE
      IAN = 99
  140 CONTINUE
C
      IF(I.GT.3) GO TO 200
      IF(I.GT.1) GO TO 160
      GO TO 220
C
  160 IF(I.GT.2) GO TO 180
      IAT = I
      JAT = JOIN(IAT)
      CALL DIST(IAT,JAT,X,Y,Z,DIS)
      GO TO 220
C
  180 CONTINUE
      IAT = I
      JAT = JOIN(IAT)
      KAT = JOIN(JAT)
      CALL DIST(IAT,JAT,X,Y,Z,DIS)
      CALL BANGLE(IAT,JAT,KAT,X,Y,Z,ANG,1)
      GO TO 220
C
  200 CONTINUE
      IAT = I
      JAT = JOIN(IAT)
      KAT = JOIN(JAT)
      LAT = JOIN(KAT)
      CALL DIST(IAT,JAT,X,Y,Z,DIS)
      CALL BANGLE(IAT,JAT,KAT,X,Y,Z,ANG,1)
      CALL TORS(IAT,JAT,KAT,LAT,X,Y,Z,DIH)
  220 CONTINUE
      WRITE(NF,9008) IAN,JAT,DIS,KAT,ANG,LAT,DIH,IDUM,IGRAPH(I)
  100 CONTINUE
      RETURN
 9008 FORMAT(I5,3(I5,F10.4),I5,2X,A4)
      END
