c-----------------------------------------------------------------------
      SUBROUTINE FINDNR(KC,IS,RNUM)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- RETURNS A REAL NUMBER FROM A FREE FORMAT
C           ZERO VALUE RETURNED FOR VARIABLE IF ONLY KBLANKS ARE FOUND
C           AND IS = 1000 IS RETURNED -----
C
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      DIMENSION KC(*),KB(80)
C
      DATA KBLANK /1H /
      DATA KPER /1H./
C
      RNUM = 0.
      MSIGN = 1
    1 IS = IS+1
      IF(IS.GT.80) GO TO 80
      IF(KC(IS).EQ.KBLANK) GO TO 1
      IP = 0
      DO 101 II = IS,80
      IC = KC(II)
      IF(IC.EQ.KBLANK) GO TO 102
      IF(IC.EQ.KPER) GO TO 200
      IP = IP+1
  101 KB(IP) = IC
  102 CONTINUE
      WRITE(IOUT,500) (KC(II),II = 1,80)
  500 FORMAT(t2,'EDIT-F-BADDATA, integer in real format',80a1)
      call mexit(iout, 1)
  200 CONTINUE
      IF(IP.EQ.0) GO TO 109
      CALL DIGITS(KB,IP,IFOUR,MSIGN)
      RNUM = FLOAT(IFOUR)
  109 IS = II+1
      IF(IS.GT.80) RETURN
      IP = 0
      DO 110 I = IS,80
      IC = KC(I)
      IF(IC.EQ.KBLANK) GO TO 111
      IP = IP+1
      KB(IP) = IC
  110 CONTINUE
      I = 80
  111 IS = I
      IF(IP.EQ.0) RETURN
      M3 = MSIGN
      CALL DIGITS(KB,IP,IFOUR,MSIGN)
      RNUM = RNUM+(FLOAT(IFOUR)/(10.**IP))*M3
      RETURN
   80 IS = 1000
      RETURN
      END
