c-----------------------------------------------------------------------
      SUBROUTINE FIXR(KR1,KR2,MOLN,IERR)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- FIXES UP RANGE OF RESIDUES -----
C
#include "sizes.h"
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      IERR = 0
      IF(KR1.GT.0) GO TO 100
      IERR = 1
      WRITE(IOUT,400)
      RETURN
C
  100 CONTINUE
      IF(KR2.LE.0) KR2 = KR1
      IF = NFRESM(MOLN)
      IE = NFRESM(MOLN+1)-1
      MAXR = IE-IF+1
      IF(KR2.GT.MAXR) KR2 = MAXR
C
      IF(.NOT.(KR2.LT.KR1)) GO TO 120
      WRITE(IOUT,500) KR1,KR2
      IERR = 1
      RETURN
  120 CONTINUE
C
C     ----- CONVERT RELATIVE NUMBERING INTO ABSOLUTE NUMBERING -----
C
      KR1 = NFRESM(MOLN)-1+KR1
      KR2 = NFRESM(MOLN)-1+KR2
      RETURN
  400 FORMAT(t2,'EDIT-W-BLANK, blank res range card ') 
  500 FORMAT(t2,'EDIT-W-BADNUM, res ',i5, ' lt ',
     +           i5,' in res range')
      END
