c-----------------------------------------------------------------------
      SUBROUTINE READIN
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     $              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      READ(IN2)     (ITITL1(I),I = 1,20)
      READ(IN2)      NTOTAT,NEXT,NMOL,NTOTRS,NBOND,NTHETA,NPHI,INDX,
     $               ISYMDU,IRCRSS,IRCRSS,NCROSS
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
C
C     ----- CHECK FOR POSSIBLE ARRAY OVERFLOWS -----
C
      IF(nmolp.GT.MAXMOL) then
           write(iout,2000) 'Molecules', nmolp, 'MAXMOL', MAXMOL
           call mexit(iout, 1)
      endif
      IF(NRESP.GT.MAXRES) then
           write(iout,2000) 'Residues', nresp, 'MAXRES', MAXRES
           call mexit(iout, 1)
      endif
      IF(NTOTAT.GT.MAXATM) then
           write(iout,2000) 'Atoms', ntotat, 'MAXATM', MAXATM
           call mexit(iout, 1)
      endif
      IF(NBOND.GT.MAXBND) then
           write(iout,2000) 'Bonds', nbond, 'MAXBND', MAXBND
           call mexit(iout, 1)
      endif
      IF(NTHETA.GT.MAXANG) then
           write(iout,2000) 'Angles', ntheta, 'MAXANG', MAXANG
           call mexit(iout, 1)
      endif
      IF(NPHI.GT.MAXDIH) then
           write(iout,2000) 'Dihedrals', nphi, 'MAXDIH', MAXDIH
           call mexit(iout, 1)
      endif
      IF(NEXT.GT.MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(iout, 1)
      endif
      IF(ncross.GT.MAXCRS) then
           write(iout,2000) 'Crosslinks', ncross, 'MAXCRS', MAXCRS
           call mexit(iout, 1)
      endif
C
      IF(NCROSS.GT.0)
     $READ(IN2)     (ICROS(I),JCROS(I),I = 1,NCROSS)
      READ(IN2)     (IBOND(I),ITHETA(I),IPHI(I),NFRESM(I),NATML(I),
     $               MOLTYP(I),I = 1,NMOLP)
      READ(IN2)     (LABRES(I),ITRES(I),I = 1,NTOTRS)
      READ(IN2)     (IBRES(I),IPRES(I),I = 1,NRESP)
      READ(IN2)     (IB(I),JB(I),I = 1,NBOND)
      READ(IN2)     (IT(I),JT(I),KT(I),I = 1,NTHETA)
      READ(IN2)     (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      READ(IN2)     (IROTAT(I),JOIN(I),NUMEX(I),I = 1,NTOTAT)
      READ(IN2)     (NATEX(I),I = 1,NEXT)
      READ(IN2)     (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NTOTAT)
      READ(IN2)     (CHRG(I),I = 1,NTOTAT)
      READ(IN2)     (R(I),THETA(I),PHI(I),I = 1,NTOTAT)
      RETURN
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
