c-------------------------------------------------------------------------------
      subroutine reorient(n,r,s)
      dimension s(3,*),r(3,*),t(3,3)

      pi = 3.14159
      call amrand(r1)
      call amrand(r2)
      call amrand(r3)
c     print *,'r1,r2,r3',r1,r2,r3

c find angles

      theta =(r1*360.0-180.0)
      phi =  (r2*360.0-180.0)
      psi =  (r3*360.0-180.0)
c     print *,'theta,phi,psi',theta,phi,psi

c convert to radians

      theta = theta * (pi/180.)
      phi   = phi   * (pi/180.)
      psi   = psi   * (pi/180.)

      cos_theta = cos(theta)
      cos_phi   = cos(phi)
      cos_psi   = cos(psi)
      sin_theta = sin(theta)
      sin_phi   = sin(phi)
      sin_psi   = sin(psi)


      t(1,1) =  cos_psi   * cos_phi   - cos_theta * sin_phi * sin_psi
      t(2,1) = -sin_psi   * cos_phi   - cos_theta * sin_phi * cos_psi
      t(3,1) =  sin_theta * sin_phi

      t(1,2) =  cos_psi   * sin_phi   + cos_theta * cos_phi * sin_psi 
      t(2,2) = -sin_psi   * sin_phi   + cos_theta * cos_phi * cos_psi
      t(3,2) = -sin_theta * cos_phi

      t(1,3) =  sin_psi   * sin_theta
      t(2,3) =  cos_psi   * sin_theta
      t(3,3) =  cos_theta

      do i = 1,n
         x1 = t(1,1)*r(1,i) + t(1,2)*r(2,i) + t(1,3)*r(3,i)
         x2 = t(2,1)*r(1,i) + t(2,2)*r(2,i) + t(2,3)*r(3,i)
         x3 = t(3,1)*r(1,i) + t(3,2)*r(2,i) + t(3,3)*r(3,i)

         s(1,i) = x1
         s(2,i) = x2
         s(3,i) = x3

      enddo

      return
      end
