c-----------------------------------------------------------------------
      SUBROUTINE STELL(IOPTB,IOPTA,IOPTD)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     $              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      IONE = 1
C
C     ----- LOOP UNTIL ENCOUNTER A BLANK CARD -----
C
    1 CONTINUE
C
C     ----- INTERNAL COORDINATES OF ALL MOLECULES FROM MOL1 TO MOL2
C           WILL BE PRINTED -----
C
      READ(IN,200) MOL1,MOL2
C
C     ----- RETURN IF ZERO -----
C
      IF(MOL1.LE.0) GO TO 500
C
      IF(MOL1.GT.NMOL) MOL1 = NMOL+1
      IF(MOL1.GT.NMOL.AND.NCROSS.EQ.0) MOL1 = NMOL
      IF(MOL2.LT.MOL1) MOL2 = MOL1
C
C     ----- IF MOL2.GT.NMOL THEN CROSSLINKS ARE GIVEN -----
C
      IF(MOL2.GT.NMOL) MOL2 = NMOL+1
      IF(MOL2.GT.NMOL.AND.NCROSS.EQ.0) MOL2 = NMOL
      WRITE(IOUT,403) MOL1,MOL2
      NB1 = IBOND(MOL1)
      NB2 = NBOND
      IF(MOL2.LE.NMOL) NB2 = IBOND(MOL2+1)-1
      NA1 = ITHETA(MOL1)
      NA2 = NTHETA
      IF(MOL2.LE.NMOL) NA2 = ITHETA(MOL2+1)-1
      ND1 = IPHI(MOL1)
      ND2 = NPHI
      IF(MOL2.LE.NMOL) ND2 = IPHI(MOL2+1)-1
      IF(IOPTB.NE.1) GO TO 20
      WRITE(IOUT,404)
      NLIM = (NB2-NB1+1)/2
      IC = NB1-1
      DO 10 I = 1,NLIM
      IC = IC+1
      I1 = IB(IC)
      I2 = JB(IC)
      CALL DIST(I1,I2,X,Y,Z,STOREI)
      JC = IC+1
      J1 = IB(JC)
      J2 = JB(JC)
      CALL DIST(J1,J2,X,Y,Z,STOREJ)
      WRITE(IOUT,100) IC,IGRAPH(I1),I1,IGRAPH(I2),I2,STOREI,
     $                 JC,IGRAPH(J1),J1,IGRAPH(J2),J2,STOREJ
      IC = IC+1
   10 CONTINUE
      IF(IC.EQ.NB2) GO TO 20
      I1 = IB(NB2)
      I2 = JB(NB2)
      CALL DIST(I1,I2,X,Y,Z,STOREI)
      WRITE(IOUT,100) NB2,IGRAPH(I1),I1,IGRAPH(I2),I2,STOREI
   20 CONTINUE
      IF(IOPTA.NE.1) GO TO 30
      WRITE(IOUT,405)
      NLIM = (NA2-NA1+1)/2
      IC = NA1-1
      DO 21 I = 1,NLIM
      IC = IC+1
      I1 = IT(IC)
      I2 = JT(IC)
      I3 = KT(IC)
      CALL BANGLE(I1,I2,I3,X,Y,Z,TH1,IONE)
      JC = IC+1
      J1 = IT(JC)
      J2 = JT(JC)
      J3 = KT(JC)
      CALL BANGLE(J1,J2,J3,X,Y,Z,TH2,IONE)
      WRITE(IOUT,101) IC,IGRAPH(I1),I1,IGRAPH(I2),I2,IGRAPH(I3),I3,
     $             TH1,JC,IGRAPH(J1),J1,IGRAPH(J2),J2,IGRAPH(J3),J3,
     $                 TH2
      IC = IC+1
   21 CONTINUE
      IF(IC.EQ.NA2) GO TO 30
      I1 = IT(NA2)
      I2 = JT(NA2)
      I3 = KT(NA2)
      CALL BANGLE(I1,I2,I3,X,Y,Z,TH1,IONE)
      WRITE(IOUT,101) NA2,IGRAPH(I1),I1,IGRAPH(I2),I2,IGRAPH(I3),I3,
     $                  TH1
   30 CONTINUE
C
      IF(IOPTD.NE.1) GO TO 1
C
      WRITE(IOUT,406)
      NLIM = (ND2-ND1+1)/2
      IC = ND1-1
      DO 31 I = 1,NLIM
      IC = IC+1
      I1 = IP(IC)
      I2 = JP(IC)
      I3 = KP(IC)
      I3 = IABS(I3)
      I4 = LP(IC)
      I4 = IABS(I4)
      CALL TORS(I1,I2,I3,I4,X,Y,Z,TH1)
      JC = IC+1
      J1 = IP(JC)
      J2 = JP(JC)
      J3 = KP(JC)
      J3 = IABS(J3)
      J4 = LP(JC)
      J4 = IABS(J4)
      CALL TORS(J1,J2,J3,J4,X,Y,Z,TH2)
      WRITE(IOUT,103) IC,IGRAPH(I1),I1,IGRAPH(I2),I2,IGRAPH(I3),I3,
     $      IGRAPH(I4),I4,TH1,JC,IGRAPH(J1),J1,IGRAPH(J2),J2,
     $      IGRAPH(J3),J3,IGRAPH(J4),J4,TH2
      IC = IC+1
   31 CONTINUE
      IF(IC.EQ.ND2) GO TO 1
      I1 = IP(ND2)
      I2 = JP(ND2)
      I3 = KP(ND2)
      I3 = IABS(I3)
      I4 = LP(ND2)
      I4 = IABS(I4)
      CALL TORS(I1,I2,I3,I4,X,Y,Z,TH1)
      WRITE(IOUT,103) ND2,IGRAPH(I1),I1,IGRAPH(I2),I2,IGRAPH(I3),I3,
     $                 IGRAPH(I4),I4,TH1
      GO TO 1
C
C     ----- END OF LOOP -----
C
  500 CONTINUE
      RETURN
  200 FORMAT(2I5)
  403 FORMAT(/ / /,1H ,5X,'INTERNAL COORDINATES FOR MOLECULES',I5,2X,
     $        '-',I5,/)
  404 FORMAT(/ /,1H ,10X,'BOND LENGTHS',/)
  100 FORMAT(2(4X,I5,'.',2X,A4,'(',I4,') - ',A4,'(',I4,')',2X,
     $         ' = ',F6.2))
  405 FORMAT(/ /,1H ,10X,'BOND ANGLES',/)
  101 FORMAT(2(4X,I5,'.',2X,A4,'(',I4,') -',A4,'(',I4,') -',A4,'(',
     $         I4,')',2X,' = ',F7.1))
  406 FORMAT(/ /,1H ,10X,'DIHEDRAL ANGLES',/)
  103 FORMAT(2(I5,'.',1X,A4,'(',I4,') -',A4,'(',I4,') -',A4,'(',I4,
     $        ') -',A4,'(',I4,')',1X,' = ',F7.1))
      END
