c-----------------------------------------------------------------------
      SUBROUTINE WRITEO
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     $              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/WATCAP/IFCAP,NATCAP,CUTCAP,XCAP,YCAP,ZCAP
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      indx = 0
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
      NATML(NMOLP) = 0
      MOLTYP(NMOLP) = 0
C
      WRITE(IOUTB)     (ITITL(I),I = 1,20)
      WRITE(IOUTB)      NTOTAT,NEXT,NMOL,NTOTRS,NBOND,NTHETA,NPHI,INDX,
     $                  ISYMDU,IRCRSS,IFBOX,NCROSS,IFCAP
      IF(NCROSS.GT.0)
     $WRITE(IOUTB)     (ICROS(I),JCROS(I),I = 1,NCROSS)
      WRITE(IOUTB)     (IBOND(I),ITHETA(I),IPHI(I),NFRESM(I),NATML(I),
     $                  MOLTYP(I),I = 1,NMOLP)
      WRITE(IOUTB)     (LABRES(I),ITRES(I),I = 1,NTOTRS)
      WRITE(IOUTB)     (IBRES(I),IPRES(I),I = 1,
     $                  NRESP)
      WRITE(IOUTB)     (IB(I),JB(I),I = 1,NBOND)
      WRITE(IOUTB)     (IT(I),JT(I),KT(I),I = 1,NTHETA)
      WRITE(IOUTB)     (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      WRITE(IOUTB)     (IROTAT(I),JOIN(I),NUMEX(I),I = 1,NTOTAT)
      WRITE(IOUTB)     (NATEX(I),I = 1,NEXT)
      WRITE(IOUTB)     (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NTOTAT)
      WRITE(IOUTB)     (CHRG(I),I = 1,NTOTAT)
      WRITE(IOUTB)     (R(I),THETA(I),PHI(I),I = 1,NTOTAT)
      IF(IFBOX.LE.0) GO TO 200
      WRITE(IOUTB)      IPTRES,NSPM,NSPSOL
      WRITE(IOUTB)      (NSP(I),I=1,NSPM)
      WRITE(IOUTB)      BETA,(BOX(I),I=1,3)
  200 CONTINUE
      IF(IFCAP.LE.0) GO TO 240
      WRITE(IOUTB)      NATCAP,CUTCAP,XCAP,YCAP,ZCAP
  240 CONTINUE
      RETURN
      END
