c-----------------------------------------------------------------------
      SUBROUTINE FINDRS(NUMA,IRES)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
c     Rev A mods: parametrized, added common/iofile/ to get uninitialized
c                 iout - G. Seibel, 3/10/89
#include "sizes.h"
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      IF(NUMA.LE.0) GO TO 11
      IF(NUMA.GE.IPRES(NTOTRS)) IRES = NTOTRS
      IF(NUMA.GE.IPRES(NTOTRS)) RETURN
      IM = NTOTRS-1
      DO 10 I = 1,IM
      IF(NUMA.GE.IPRES(I).AND.NUMA.LT.IPRES(I+1)) GO TO 12
   10 CONTINUE
   11 WRITE(IOUT,100) NUMA
      call mexit(iout, 1)
   12 IRES = I
      RETURN
  100 FORMAT(2x,'findrs: problems finding residue of atom ',I5)
      END
