c-----------------------------------------------------------------------
      SUBROUTINE ISEXC(NATO,NATE,ISKIP)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CHECKS IF ATOM NATE IS IN EXCLUDED LIST FOR ATOM NATO -----
C
#include "sizes.h"
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
C
      IF(NUMEX(NATO).LE.0) GO TO 30
      ISKIP = 1
C
C     ----- FIRST POSITION POINTER AT START OF EXCLUDED ATOMS -----
C
      I1 = NATO-1
      IP = 0
      IF(I1.LE.0) GO TO 100
      DO 10 I = 1,I1
   10 IP = IP+NUMEX(I)
  100 CONTINUE
C
C     ----- NOW CHECK NEW ATOM AGAINST EXCLUDED ONES -----
C
      ISTART = IP+1
      IFINAL = NUMEX(NATO)+IP
      DO 20 I = ISTART,IFINAL
      IF(NATEX(I).EQ.NATE) RETURN
   20 CONTINUE
   30 ISKIP = 0
      RETURN
      END
