c-----------------------------------------------------------------------
      SUBROUTINE ATTYP(NTOTAT,ISYMBL,ISMPER,IAC,IACPER,PERTUR,nogo)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL PERTUR
C
C     ----- CHECK THE THE USAGE OF ATOM TYPES -----
C
#include "sizes.h"
      COMMON/TYPAT/NATYP,NTYPES,KNDSYM(MAXTYP),IREDEF(MAXTYP),
     +             JREDEF(MAXTYP),IATUSE(MAXTYP),WTB(MAXTYP),
     +             atpb(MAXTYP)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION ISYMBL(*),IAC(*),ISMPER(*),IACPER(*)
C
      DO 10 I = 1,NATYP
   10 IATUSE(I) = 1
C
      DO 11 I = 1,NTOTAT
           ISY = ISYMBL(I)
C
           IAC(I) = 0
           DO 12 J = 1,NATYP
                IF(ISY.EQ.KNDSYM(J)) GO TO 13
   12      CONTINUE
           nogo = nogo + 1
           WRITE(IOUT,9108) I,ISY
           if (nogo .gt. 50) then
                write(iout,'(/5x,a)') 'Too many errors to continue'
                call mexit(6, 1)
           endif
   13      CONTINUE
           IAC(I) = J
   11 CONTINUE
C
C     ----- ALLOCATE THE ATOM TYPES THE PERTURBED ATOMS -----
C
      IF(.NOT.PERTUR) GO TO 300
      DO 100 I = 1,NTOTAT
         ISY = ISMPER(I)
         IACPER(I) = 0
         DO 120 J = 1,NATYP
            IF(ISY.EQ.KNDSYM(J)) GO TO 140
  120    CONTINUE
         nogo = nogo + 1
         WRITE(IOUT,9108) I,ISY
         if (nogo .gt. 50) then
              write(iout,'(/5x,a)') 'Too many errors to continue'
              call mexit(6, 1)
         endif
  140    CONTINUE
         IACPER(I) = J
  100 CONTINUE
  300 CONTINUE
      RETURN
C
 9108 FORMAT(4X,'Missing mass parameter:  Atom number',i5,' type ',a2)
      end
