c-----------------------------------------------------------------------
      SUBROUTINE MDPARM(NF,BINARY,PERTUR,NOGO)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL BINARY,PERTUR,polz
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/FIXP/MBOND,MTHETA,MPHI,MUMBND,MUMANG,MPTRA,NPTRA
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),
     +             IAC(MAXATM),AMASS(MAXATM),atpol(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/PARMS/RK(MAXBPT),REQ(MAXBPT),TK(MAXAPT),TEQ(MAXAPT),
     +             PK(MAXDPT),PN(MAXDPT),PHASE(MAXDPT),CN1(MAXLJP),
     +             CN2(MAXLJP),SOLTY(MAXTYP)
#ifdef CHARMM
      real kub
      common/p14/ cn114(MAXLJP),cn214(MAXLJP)
      common/ub/kub(MAXAPT),rub(MAXAPT)
#endif
      common/polar/ polz
      COMMON/HBPAR/ASOL(MAXHBP),BSOL(MAXHBP),AG(MAXHBP),BG(MAXHBP),
     +             HBCUT(MAXHBP)
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/TYPAT/NATYP,NTYPES,KNDSYM(MAXTYP),IREDEF(MAXTYP),
     +             JREDEF(MAXTYP),IATUSE(MAXTYP),WTB(MAXTYP),
     +             atpb(MAXTYP)
      COMMON/PASHNB/NAMNB,NHB,IZ2,KHT1(MAXHBP),KHT2(MAXHBP),
     +              NHT1(MAXHBP),NHT2(MAXHBP)
      COMMON/WORKA/ICB(MAXBND),ICT(MAXANG),ICP(MAXDIH),IWORK(MAXWRK)
      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/WATCAP/IFCAP,NATCAP,CUTCAP,XCAP,YCAP,ZCAP
#include "pertrb.h"
      COMMON/PERLIS/NBPER,NGPER,NDPER,MBPER,MGPER,MDPER,IBPER(MAXPVT),
     +              JBPER(MAXPVT),ICBPER(MAXPPT),ITPER(MAXPVT),
     +              JTPER(MAXPVT),KTPER(MAXPVT),ICTPER(MAXPPT),
     +              IPPER(MAXPVT),JPPER(MAXPVT),KPPER(MAXPVT),
     +              LPPER(MAXPVT),ICPPER(MAXPPT)
C
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      DIMENSION NNO(MAXWRK)
      DIMENSION IBH(MAXDIH),JBH(MAXDIH),ICBH(MAXDIH)
      DIMENSION ITH(MAXDIH),JTH(MAXDIH),KTH(MAXDIH),ICTH(MAXDIH)
      DIMENSION IPH(MAXDIH),JPH(MAXDIH),KPH(MAXDIH),LPH(MAXDIH)
      DIMENSION ICPH(MAXDIH)
C
C     ----- EQUIVALENCE THE H ATOM ARRAYS SUITABLY -----
C
      EQUIVALENCE (IBH(1),iph(1)),(JBH(1),jph(1)),(ICBH(1),kph(1))
      EQUIVALENCE (ITH(1),iph(1)),(JTH(1),jph(1)),(KTH(1),kph(1))
      EQUIVALENCE (ICTH(1),lph(1))
C
      EQUIVALENCE (NNO(1),IWORK(1))
C
      jparm = 0
      jhparm = 0
      IFPERT = 0
      IF(PERTUR) IFPERT = 1
C
C     ----- linearize the no array -----
C
      DO 100 I = 1,NTYPES
      ISTART = NTYPES*(I-1)
      DO 120 J = 1,NTYPES
      IPOINT = ISTART + J
      NNO(IPOINT) = NO(I,J)
  120 CONTINUE
  100 CONTINUE
C
C     ----- GET THE NUMBER OF ATOM IN A LARGEST RESIDUE. THIS IS
C           NEEDED FOR VECTOR PAIR LIST GENERATION ROUTINE -----
C
      NMXRS = 0
        DO 130 I = 1,NTOTRS
        LMXRS = IPRES(I+1)-IPRES(I)
        IF(LMXRS.GT.NMXRS) NMXRS = LMXRS
  130 CONTINUE
C
C     ----- CHECK FOR INTERNAL COORDINATE CONSTRAINTS -----
C
      KBOND = MBOND-NBOND
      KTHET = MTHETA-NTHETA
      KPHI  = MPHI-NPHI
C
C     ----- NOW SEPARATE THE HYDROGEN ATOM STUFF. IN THIS PASS
C           ONLY THE NUMBERS ARE CALCULATED -----
C
      INDEX = 0
      CALL BONSEP(NBOND,NBONH,NBONA,IBH,JBH,ICBH,IB,JB,ICB,ISYMBL,INDEX)
      CALL ANGSEP(NTHETA,NTHETH,NTHETS,ITH,JTH,KTH,ICTH,IT,JT,KT,ICT,
     +            ISYMBL,INDEX)
      CALL DIHSEP(NPHI,NPHIH,NPHIA,IPH,JPH,KPH,LPH,ICPH,IP,JP,KP,LP,ICP,
     +            ISYMBL,INDEX)
c
c     --- error check before actual access of scratch ---
c
      if (nbonh .gt. MAXDIH) then
           write(iout,9200) nbonh,'MAXDIH',MAXDIH
           call mexit(6, 1)
      endif
c
      if (ntheth .gt. MAXDIH) then
           write(iout,9200) ntheth,'MAXDIH',MAXDIH
           call mexit(6, 1)
      endif
C
      WRITE(IOUT,9048) NBONH,NBONA,NTHETH,NTHETS,NPHIH,NPHIA,KBOND,
     +                 KTHET,KPHI,MUMBND,MUMANG,MPTRA,NATYP,NHB,
     +                 NBPER,NGPER,NDPER,IFPERT,IFBOX,NMXRS,IFCAP
C
C     ----- GENERATE THE BINARY DATA FOR DYNAMICS -----
C
      NTYPE = NTYPES*NTYPES
      MBONA = NBONA+KBOND
      MTHETS = NTHETS+KTHET
      MPHIA = NPHIA+KPHI
C
C     ----- GENERATE THE MOLECULAR TOPOLOGY FILE EITHER IN BINARY
C           OR FORMATTED FORM -----
C
      IF(.NOT.BINARY) THEN
C
         WRITE(NF,9108) ITITL
         WRITE(NF,9118) NTOTAT,NTYPES,NBONH,NBONA,NTHETH,NTHETS,NPHIH,
     +          NPHIA,JHPARM,JPARM,NEXT,NTOTRS,MBONA,MTHETS,MPHIA,
     +          MUMBND,MUMANG,MPTRA,NATYP,NHB,IFPERT,NBPER,NGPER,
     +          NDPER,MBPER,MGPER,MDPER,IFBOX,NMXRS,IFCAP
         WRITE(NF,9108) (IGRAPH(I),I = 1,NTOTAT)
         WRITE(NF,9128) (CHRG(I),  I = 1,NTOTAT)
         WRITE(NF,9128) (AMASS(I), I = 1,NTOTAT)
         WRITE(NF,9118) (IAC(I),   I = 1,NTOTAT)
         WRITE(NF,9118) (NUMEX(I), I = 1,NTOTAT)
         WRITE(NF,9118) (NNO(I),   I = 1,NTYPE)
         WRITE(NF,9108) (LABRES(I),I = 1,NTOTRS)
         WRITE(NF,9118) (IPRES(I), I = 1,NTOTRS)
         WRITE(NF,9128) (RK(I),    I = 1,MUMBND)
         WRITE(NF,9128) (REQ(I),   I = 1,MUMBND)
         WRITE(NF,9128) (TK(I),    I = 1,MUMANG)
         WRITE(NF,9128) (TEQ(I),   I = 1,MUMANG)
         WRITE(NF,9128) (PK(I),    I = 1,MPTRA)
         WRITE(NF,9128) (PN(I),    I = 1,MPTRA)
         WRITE(NF,9128) (PHASE(I), I = 1,MPTRA)
         WRITE(NF,9128) (SOLTY(I), I = 1,NATYP)
         NTTYP = (NTYPES*(NTYPES+1))/2
         WRITE(NF,9128) (CN1(I),   I = 1,NTTYP)
         WRITE(NF,9128) (CN2(I),   I = 1,NTTYP)
      ELSE
c
C     ----- BINARY OUTPUT -----
C
         WRITE(NF) ITITL
         WRITE(NF) NTOTAT,NTYPES,NBONH,NBONA,NTHETH,NTHETS,NPHIH,NPHIA,
     +          JHPARM,JPARM,NEXT,NTOTRS,MBONA,MTHETS,MPHIA,MUMBND,
     +          MUMANG,MPTRA,NATYP,NHB,IFPERT,NBPER,NGPER,NDPER,
     +          MBPER,MGPER,MDPER,IFBOX,NMXRS,IFCAP
         WRITE(NF) (IGRAPH(I),I = 1,NTOTAT)
         WRITE(NF) (CHRG(I),  I = 1,NTOTAT)
         WRITE(NF) (AMASS(I), I = 1,NTOTAT)
         WRITE(NF) (IAC(I),   I = 1,NTOTAT)
         WRITE(NF) (NUMEX(I), I = 1,NTOTAT)
         WRITE(NF) (NNO(I),   I = 1,NTYPE)
         WRITE(NF) (LABRES(I),I = 1,NTOTRS)
         WRITE(NF) (IPRES(I), I = 1,NTOTRS)
         WRITE(NF) (RK(I),    I = 1,MUMBND)
         WRITE(NF) (REQ(I),   I = 1,MUMBND)
         WRITE(NF) (TK(I),    I = 1,MUMANG)
         WRITE(NF) (TEQ(I),   I = 1,MUMANG)
         WRITE(NF) (PK(I),    I = 1,MPTRA)
         WRITE(NF) (PN(I),    I = 1,MPTRA)
         WRITE(NF) (PHASE(I), I = 1,MPTRA)
         WRITE(NF) (SOLTY(I), I = 1,NATYP)
         NTTYP = NTYPES*(NTYPES+1)/2
         WRITE(NF) (CN1(I),   I = 1,NTTYP)
         WRITE(NF) (CN2(I),   I = 1,NTTYP)
      END IF
C
C     ----- NOW GET THE H-ATOM SEPARATED BONDS -----
C
      INDEX = 1
      CALL BONSEP(NBOND,IDUM,JDUM,IBH,JBH,ICBH,IB,JB,ICB,ISYMBL,INDEX)
      IF(IDUM.NE.NBONH .OR. JDUM.NE.NBONA) GO TO 300
C
C     ----- ADD THE CONSTRAINT BONDS TO BONA -----
C
      IF(KBOND.EQ.0) GO TO 140
      DO 160 K = 1,KBOND
         IB(NBONA+K) = IB(NBOND+K)
         JB(NBONA+K) = JB(NBOND+K)
         ICB(NBONA+K) = ICB(NBOND+K)
  160 CONTINUE
  140 CONTINUE
C
      IF(.NOT. BINARY) THEN
         WRITE(NF,9118) (IBH(I),JBH(I),ICBH(I),I = 1,NBONH)
         WRITE(NF,9118) (IB(I),JB(I),ICB(I),   I = 1,MBONA)
      ELSE
         WRITE(NF) (IBH(I),JBH(I),ICBH(I),I = 1,NBONH)
         WRITE(NF) (IB(I),JB(I),ICB(I),   I = 1,MBONA)
      END IF
C
C     ----- GET THE H-ATOM SEPARATED ANGLES -----
C
      INDEX = 1
      CALL ANGSEP(NTHETA,IDUM,JDUM,ITH,JTH,KTH,ICTH,IT,JT,KT,ICT,
     +            ISYMBL,INDEX)
      IF(IDUM.NE.NTHETH .OR. JDUM.NE.NTHETS) GO TO 320
C
C     ----- ADD THE ANGLE CONSTRAINTS TO ANGLA -----
C
      IF(KTHET.LE.0) GO TO 180
      DO 200 K = 1,KTHET
         IT(NTHETS+K) = IT(NTHETA+K)
         JT(NTHETS+K) = JT(NTHETA+K)
         KT(NTHETS+K) = KT(NTHETA+K)
         ICT(NTHETS+K) = ICT(NTHETA+K)
  200 CONTINUE
  180 CONTINUE
C
      IF(.NOT.BINARY) THEN
         WRITE(NF,9118) (ITH(I),JTH(I),KTH(I),ICTH(I),I = 1,NTHETH)
         WRITE(NF,9118) (IT(I),JT(I),KT(I),ICT(I),    I = 1,MTHETS)
      ELSE
C       
         WRITE(NF) (ITH(I),JTH(I),KTH(I),ICTH(I),I = 1,NTHETH)
         WRITE(NF) (IT(I),JT(I),KT(I),ICT(I),    I = 1,MTHETS)
      END IF
C
C     ----- GET THE H-ATOM SEPARATED DIHEDRALS -----
C
      INDEX = 1
      CALL DIHSEP(NPHI,IDUM,JDUM,IPH,JPH,KPH,LPH,ICPH,IP,JP,KP,LP,ICP,
     +            ISYMBL,INDEX)
      IF(IDUM.NE.NPHIH .OR. JDUM.NE.NPHIA) GO TO 340
C
C     ----- ADD THE DIHEDRAL CONSTRAINTS TO DIHEDA -----
C
      IF(KPHI.LE.0) GO TO 220
      DO 240 K = 1,KPHI
         IP(NPHIA+K) = IP(NPHI+K)
         JP(NPHIA+K) = JP(NPHI+K)
         KP(NPHIA+K) = KP(NPHI+K)
         LP(NPHIA+K) = LP(NPHI+K)
         ICP(NPHIA+K) = ICP(NPHI+K)
  240 CONTINUE
  220 CONTINUE
C
      IF(.NOT.BINARY) THEN
         WRITE(NF,9118) (IPH(I),JPH(I),KPH(I),LPH(I),ICPH(I),
     +                   I = 1,NPHIH)
         WRITE(NF,9118) (IP(I),JP(I),KP(I),LP(I),ICP(I),I = 1,MPHIA)
C        
         WRITE(NF,9118) (NATEX(I), I = 1,NEXT)
         WRITE(NF,9128) (AG(I),    I = 1,NHB)
         WRITE(NF,9128) (BG(I),    I = 1,NHB)
         WRITE(NF,9128) (HBCUT(I), I = 1,NHB)
      ELSE
         WRITE(NF) (IPH(I),JPH(I),KPH(I),LPH(I),ICPH(I),I = 1,NPHIH)
         WRITE(NF) (IP(I),JP(I),KP(I),LP(I),ICP(I),     I = 1,MPHIA)
         WRITE(NF) (NATEX(I), I = 1,NEXT)
         WRITE(NF) (AG(I),    I = 1,NHB)
         WRITE(NF) (BG(I),    I = 1,NHB)
         WRITE(NF) (HBCUT(I), I = 1,NHB)
      END IF
C
C     ----- PASS THE JOIN,TREE AND ROTATION INFORMATION -----
C
      IF(.NOT.BINARY) THEN
         WRITE(NF,9108) (ISYMBL(I), I=1,NTOTAT)
         WRITE(NF,9108) (ITREE(I),  I=1,NTOTAT)
         WRITE(NF,9118) (JOIN(I),   I=1,NTOTAT)
         WRITE(NF,9118) (IROTAT(I), I=1,NTOTAT)
      ELSE
         WRITE(NF) (ISYMBL(I), I=1,NTOTAT)
         WRITE(NF) (ITREE(I),  I=1,NTOTAT)
         WRITE(NF) (JOIN(I),   I=1,NTOTAT)
         WRITE(NF) (IROTAT(I), I=1,NTOTAT)
      END IF
C
C     ----- EXTRA OUTPUT FOR PARAMETER OPTIMISATION -----
C
C     IF(BINARY) GO TO 700
C     WRITE(NF,9118) (NHT1(I),I=1,NHB)
C     WRITE(NF,9118) (NHT2(I),I=1,NHB)
C     WRITE(NF,9118) (JREDEF(I),I=1,NATYP)
C     WRITE(NF,9108) (KNDSYM(I),I=1,NATYP)
      GO TO 720
C
C 700 CONTINUE
C     WRITE(NF) (NHT1(I),I=1,NHB)
C     WRITE(NF) (NHT2(I),I=1,NHB)
C     WRITE(NF) (JREDEF(I),I=1,NATYP)
C     WRITE(NF) (KNDSYM(I),I=1,NATYP)
  720 CONTINUE
C
C     ----- EXTRA OUTPUT FOR BOUNDARY CONDITION -----
C
      IF(IFBOX.GT.0) THEN
         IF(BINARY) THEN
            WRITE(NF) IPTRES,NSPM,NSPSOL
            WRITE(NF) (NSP(I),I=1,NSPM)
            WRITE(NF) BETA,(BOX(I),I=1,3)
         ELSE
            WRITE(NF,9118) IPTRES,NSPM,NSPSOL
            WRITE(NF,9118) (NSP(I),I=1,NSPM)
            WRITE(NF,9128) BETA,(BOX(I),I=1,3)
         END IF
      END IF
C
C     ----- EXTRA OUTPUT FOR CAP BOUNARY INFORMATION -----
C
      IF(IFCAP.GT.0) THEN
         IF(BINARY) THEN
            WRITE(NF) NATCAP,CUTCAP,XCAP,YCAP,ZCAP
         ELSE
            WRITE(NF,9118) NATCAP
            WRITE(NF,9128) CUTCAP,XCAP,YCAP,ZCAP
         END IF
      END IF
C
C     ----- EXTRA OUTPUT FOR PERTURBATION CALCULATION -----
C
      IF(PERTUR) THEN
         IF(.NOT.BINARY) THEN
             WRITE(NF,9118) (IBPER(I),JBPER(I), I = 1,NBPER)
             WRITE(NF,9118) (ICBPER(I),I=1,2*NBPER)
             WRITE(NF,9118) (ITPER(I),JTPER(I),KTPER(I), I=1,NGPER)
             WRITE(NF,9118) (ICTPER(I),I=1,2*NGPER)
             WRITE(NF,9118) (IPPER(I),JPPER(I),KPPER(I),LPPER(I),
     +                       I=1,NDPER)
             WRITE(NF,9118) (ICPPER(I),I=1,2*NDPER)
C
             WRITE(NF,9108) (LABPER(I),I=1,NTOTRS)
             WRITE(NF,9108) (IGRPER(I),I=1,NTOTAT)
             WRITE(NF,9108) (ISMPER(I),I=1,NTOTAT)
             WRITE(NF,9128) (ALMPER(I),I=1,NTOTAT)
             WRITE(NF,9118) (IAPER(I),I=1,NTOTAT)
             WRITE(NF,9118) (IACPER(I),I=1,NTOTAT)
             WRITE(NF,9128) (CGPER(I),I=1,NTOTAT)
         ELSE
C
C     ----- BINARY OUTPUT -----
C
            WRITE(NF) (IBPER(I),JBPER(I), I = 1,NBPER)
            WRITE(NF) (ICBPER(I),I=1,2*NBPER)
            WRITE(NF) (ITPER(I),JTPER(I),KTPER(I), I=1,NGPER)
            WRITE(NF) (ICTPER(I),I=1,2*NGPER)
            WRITE(NF) (IPPER(I),JPPER(I),KPPER(I),LPPER(I),I=1,NDPER)
            WRITE(NF) (ICPPER(I),I=1,2*NDPER)
C           
            WRITE(NF) (LABPER(I),I=1,NTOTRS)
            WRITE(NF) (IGRPER(I),I=1,NTOTAT)
            WRITE(NF) (ISMPER(I),I=1,NTOTAT)
            WRITE(NF) (ALMPER(I),I=1,NTOTAT)
            WRITE(NF) (IAPER(I),I=1,NTOTAT)
            WRITE(NF) (IACPER(I),I=1,NTOTAT)
            WRITE(NF) (CGPER(I),I=1,NTOTAT)
         END IF
      END IF
C
      if(polz)then
         if(.not.binary) then
            WRITE(NF,9128) (atpol(I), I = 1,NTOTAT)
            if(pertur) then
              write(NF,9128)(polper(i),i=1,ntotat)
            endif
         else
            WRITE(NF) (atpol(I), I = 1,NTOTAT)
            if(pertur) then
              write(NF)(polper(i),i=1,ntotat)
            endif
         endif
      endif
#ifdef CHARMM
c
c    ---write out 1-4 parameters at end of parm file:
c
      if (binary) then
         WRITE(NF) (CN114(I),   I = 1,NTTYP)
         WRITE(NF) (CN214(I),   I = 1,NTTYP)
      else
         WRITE(NF,9128) (CN114(I),   I = 1,NTTYP)
         WRITE(NF,9128) (CN214(I),   I = 1,NTTYP)
      end if
c
c    --- write out urey-bradley parameters:
c
      if (binary) then
        write(nf) (kub(i),i=1,mumang)
        write(nf) (rub(i),i=1,mumang)
      else
        write(nf,9128) (kub(i),i=1,mumang)
        write(nf,9128) (rub(i),i=1,mumang)
      end if
#endif
      RETURN
  300 WRITE(IOUT,9008) NBONH,NBONA,IDUM,JDUM
      GO TO 360
  320 CONTINUE
      WRITE(IOUT,9018) NTHETH,NTHETS,IDUM,JDUM
      GO TO 360
  340 CONTINUE
      WRITE(IOUT,9028) NPHIH,NPHIA,IDUM,JDUM
  360 CONTINUE
      NOGO = NOGO+1
      RETURN
c
 9048 FORMAT
     +(/5X,'NBONH=',I5,' NBONA =',I5,' NTHETH=',I5,' NTHETS=',I5,
     + /5X,'NPHIH=',I5,' NPHIA =',I5,' KBOND =',I5,' KTHET =',I5,
     + /5X,'KPHI =',I5,' MUMBND=',I5,' MUMANG=',I5,' MPTRA =',I5,
     + /5X,'NATYP=',I5,' NHB   =',I5,' NBPER =',I5,' NGPER =',I5,
     + /5X,'NDPER=',I5,' IFPERT=',I5,' IFBOX =',I5,' NMXRS =',I5,
     + /5X,'IFCAP=',I5,/)
 9108 FORMAT(20A4)
 9118 FORMAT(12I6)
 9128 FORMAT(5E16.8)
c
 9008 FORMAT(4X,'mdparm:  error in bond separation',4i6)
 9018 FORMAT(4X,'mdparm:  error in angle separation',4i6)
 9028 FORMAT(4X,'mdparm:  error in dihedral separation',4i6)
 9200 format(/,5x,'Scratch requirement =',i6,' exceeds ',a,' =',i6)
      END
