c-----------------------------------------------------------------------
      SUBROUTINE PARMR(NOGO,PERTUR,newfrc)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL PERTUR,newfrc
      character*4 header
C
#include "sizes.h"
#include "pertrb.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/FIXP/MBOND,MTHETA,MPHI,MUMBND,MUMANG,MPTRA,NPTRA
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),
     +             IAC(MAXATM),AMASS(MAXATM),atpol(MAXATM)
      COMMON/PARMS/RK(MAXBPT),REQ(MAXBPT),TK(MAXAPT),TEQ(MAXAPT),
     +             PK(MAXDPT),PN(MAXDPT),PHASE(MAXDPT),CN1(MAXLJP),
     +             CN2(MAXLJP),SOLTY(MAXTYP)
#ifdef CHARMM
      real kub
      common/p14/ cn114(MAXLJP),cn214(MAXLJP)
      common/ub/kub(MAXAPT),rub(MAXAPT)
#endif
      COMMON/HBPAR/ASOL(MAXHBP),BSOL(MAXHBP),AG(MAXHBP),BG(MAXHBP),
     +             HBCUT(MAXHBP)
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/TYPAT/NATYP,NTYPES,KNDSYM(MAXTYP),IREDEF(MAXTYP),
     +             JREDEF(MAXTYP),IATUSE(MAXTYP),WTB(MAXTYP),
     +             atpb(MAXTYP)
      COMMON/PASHNB/NAMNB,NHB,IZ2,KHT1(MAXHBP),KHT2(MAXHBP),
     +              NHT1(MAXHBP),NHT2(MAXHBP)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/IOPARM/IN2,IN3,in4,IOUTC,IOUTD,IPARML,IOHB,IONB
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      DIMENSION JSOLTY(MAXTYP),ISOLTY(MAXTYP),MBT(4)
      DIMENSION IXCHG(MAXTYP),JXCHG(MAXTYP)
c
c     Rev A mod:  use double temps
      double precision atmwt,trk,treq,ttk,tteq,tpk,tphase,tpn,ttpn,a,b
      double precision tkub,trub
c     also use doubles for arithmetic on parameters
      double precision conv
C
      DATA IBLANK /2H     /
      DATA IATX /2HX  /
c
c     --- get PI / 180. ---
      CONV = 4.0d0*ATAN(1.0d0)/180.0d0
c
      if (MAXTYP .lt. 20) then
           write(iout,'(/2x,a)') 'Parameter MAXTYP must be .gt. 20'
           call mexit(iout, 1)
      endif
C
C     ----- READ THE PARAMETER FILE -----
C
      READ(IN2,10) ITITL1
      WRITE(IOUT,11) ITITL1
C
C     ----- READ IN ATOM TYPES AND MASSES
C           END INPUT WITH A BLANK CARD -----
C
      I = 0
      if(newfrc) then
c
c       --- first read in the modified masses:
c
        read (in4,10,end=52) ititl1
        write(6,*)
        write(6,13) 
   13   format(1x,
     .      ' Modified parameters are taken from the file headed:')
        write(6,11) ititl1
        write(6,14) 
   14   format(1x, 
     .      ' (Parameters from this file are marked with "****"',/,
     .      '  at the beginning of the line.)')
        write(6,*)
   52   read(in4,'(a4)',end=550)  header
        if (header.ne.'MASS' .and. header.ne.'mass') go to 52
   51   CONTINUE
        READ(IN4,180) IATSYM,ATMWT,atmpol
        IF(IATSYM.EQ.IBLANK) GO TO 550
        CALL ATMCHK(NTOTAT,IATSYM,ISYMBL,ISKIP)
        IF (PERTUR.AND.ISKIP.EQ.1) 
     .      CALL ATMCHK(NTOTAT,IATSYM,ISMPER,ISKIP)
        IF(ISKIP.EQ.1) GO TO 51
        I = I+1
        if (i .gt. MAXTYP) then
           write(iout,2000) 'Atom Types', i, 'MAXTYP', MAXTYP
           call mexit(iout, 1)
        endif
        if (i.eq.1) write(6,'(/ /a16/)') 'Modified masses:'
        write(6,'(a4,3x,a2,2x,2f8.2)') '****',iatsym,atmwt,atmpol
        KNDSYM(I) = IATSYM
        WTB(I) = ATMWT
        atpb(i) = atmpol
        GO TO 51
  550   rewind (in4)
      endif
c
c  --- now read the masses from the standard file:
c
  561 continue
      READ(IN2,180) IATSYM,ATMWT,atmpol
      IF(IATSYM.EQ.IBLANK) GO TO 560
      CALL ATMCHK(NTOTAT,IATSYM,ISYMBL,ISKIP)
      IF(PERTUR.AND.ISKIP.EQ.1) CALL ATMCHK(NTOTAT,IATSYM,ISMPER,ISKIP)
      IF(ISKIP.EQ.1) GO TO 561
      do 562 j=1,i
        if (iatsym.eq.kndsym(j)) go to 561
  562 continue
      I = I+1
      if (i .gt. MAXTYP) then
           write(iout,2000) 'Atom Types', i, 'MAXTYP', MAXTYP
           call mexit(iout, 1)
      endif
      KNDSYM(I) = IATSYM
      WTB(I) = ATMWT
      atpb(i) = atmpol
      GO TO 561
C
  560 CONTINUE
      NATYP = I
C
C     ----- WRITE OUT THE ATOM SYMBOLS AND MASSES -----
C
      write(iout,'(10x,a,/)') 'Atom Types, Masses and Polarz.'
      write(iout,'(2(4x,i3,'': '',a2,2f10.3))') 
     +            (i,kndsym(i),wtb(i),atpb(i), i=1,natyp)
C
C     ----- READ ATOM TYPES THAT ARE HYDROPHILIC
C           NO REDEFINITION ARRAYS ARE USED,SO ALL HYDROPHILIC TYPES
C           MUST BE DECLARED -----
C
      DO 39 I = 1,NATYP
   39 ISOLTY(I) = 0
      DO 40 I = 1,10000
      READ(IN2,12) (JSOLTY(J),J = 1,20)
      DO 41 J = 1,20
      JS = JSOLTY(J)
      IF(JS.EQ.IBLANK) GO TO 44
      DO 42 K = 1,NATYP
      IF(JS.EQ.KNDSYM(K)) GO TO 43
   42 CONTINUE
*     WRITE(IOUT,45) JS (this is not used)
      GO TO 41
   43 ISOLTY(K) = 1
   41 CONTINUE
   40 CONTINUE

   44 CONTINUE
C          
C     ----- FIND WHICH ATOM SYMBOLS ARE USED -----
C                           
      CALL ATTYP(NTOTAT,ISYMBL,ISMPER,IAC,IACPER,PERTUR,nogo)
C
C      ----- ASSIGN INDIVIDUAL ATOM MASSES
C            THIS MUST BE DONE BEFORE IAC VALUES ARE CHANGED FOR UNIQUE
C            ATOM TYPES IN NBREDF -----
C
      DO 184 I = 1,NTOTAT
      J = IAC(I)
      AMASS(I) = WTB(J)
      atpol(i) = atpb(j)
  184 CONTINUE
C
C     ----- END ALL INPUT WITH A BLANK CARD -----
C
C           BOND PARAMETER INPUT
C
      IF(IPARML.ge.1) WRITE(IOUT,21)
      I = 0
c
c --- first, read in the "local modifications" to the standard
c     parameters.  (Note that for bonds, angles and dihedrals
c     the modifications are read in first, since the routines
c     pointb, pointt and pointp take the first parameters that
c     match.
c
      if(newfrc) then
   98 read(in4,'(a4)',end=1100) header
      if (header.ne.'BOND' .and. header.ne.'bond') go to 98
  100 CONTINUE
      READ(in4,15) MBT(1),MBT(2),TRK,TREQ
      IF(MBT(1).EQ.IBLANK) GO TO 1100
      DO 301 II = 1,2
      CALL CHKSYM(MBT(II),ISKIP)
      IF(ISKIP.EQ.1) GO TO 100
  301 CONTINUE
      I = I+1
      if (i .gt. MAXBPT) then
           write(iout,2000) 'Bond Param Types', i, 'MAXBPT', MAXBPT
           call mexit(iout, 1)
      endif
      IBT(I) = MBT(1)
      JBT(I) = MBT(2)
      RK(I) = TRK
      REQ(I) = TREQ
      IF(IPARML.ge.1)
     +WRITE(IOUT,922) I,IBT(I),JBT(I),RK(I),REQ(I)
      GO TO 100
c
c  --- now read in the standard bond parameters:
c
 1100 rewind (in4)
      endif
 2100 continue
      READ(IN2,15) MBT(1),MBT(2),TRK,TREQ
      IF(MBT(1).EQ.IBLANK) GO TO 101
      DO 1301 II = 1,2
      CALL CHKSYM(MBT(II),ISKIP)
      IF(ISKIP.EQ.1) GO TO 2100
 1301 CONTINUE
      I = I+1
      if (i .gt. MAXBPT) then
           write(iout,2000) 'Bond Param Types', i, 'MAXBPT', MAXBPT
           call mexit(iout, 1)
      endif
      IBT(I) = MBT(1)
      JBT(I) = MBT(2)
      RK(I) = TRK
      REQ(I) = TREQ
      IF(IPARML.EQ.2)
     +WRITE(IOUT,22) I,IBT(I),JBT(I),RK(I),REQ(I)
      GO TO 2100
  101 NUMBND = I
C
C     ----- BOND ANGLE PARAMETER INPUT -----
C
      IF(IPARML.ge.1) WRITE(IOUT,23)
      I = 0
c
c  --- first read in the modifications:
c
      if(newfrc) then
 1104 read(in4,'(a4)',end=2102) header
      if (header.ne.'ANGL' .and. header.ne.'angl') go to 1104
  102 CONTINUE
#ifdef CHARMM
      READ(in4,16) MBT(1),MBT(2),MBT(3),TTK,TTEQ,tkub,rkub
#else
      READ(in4,16) MBT(1),MBT(2),MBT(3),TTK,TTEQ
#endif
      IF(MBT(1).EQ.IBLANK) GO TO 2102
      DO 305 II = 1,3
      CALL CHKSYM(MBT(II),ISKIP)
      IF(ISKIP.EQ.1) GO TO 102
  305 CONTINUE
      I = I+1
      if (i .gt. MAXAPT) then
           write(iout,2000) 'Angle Param Types', i, 'MAXAPT', MAXAPT
           call mexit(iout, 1)
      endif
      ITT(I) = MBT(1)
      JTT(I) = MBT(2)
      KTT(I) = MBT(3)
      TK(I) = TTK
      TEQ(I) = TTEQ
#ifdef CHARMM
      kub(i) = tkub
      rub(i) = rkub
#endif
      IF(IPARML.ge.1)
#ifdef CHARMM
     +WRITE(IOUT,924) I,ITT(I),JTT(I),KTT(I),TK(I),TEQ(I),KUB(i),RUB(i)
#else
     +WRITE(IOUT,924) I,ITT(I),JTT(I),KTT(I),TK(I),TEQ(I)
#endif
      TEQ(I) = tteq * conv
      GO TO 102
c
c   ---now read the standard parameters:
c
 2102 rewind (in4)
      endif
 1102 continue
#ifdef CHARMM
      READ(in2,16) MBT(1),MBT(2),MBT(3),TTK,TTEQ,tkub,rkub
#else
      READ(in2,16) MBT(1),MBT(2),MBT(3),TTK,TTEQ
#endif
      IF(MBT(1).EQ.IBLANK) GO TO 103
      DO 1305 II = 1,3
      CALL CHKSYM(MBT(II),ISKIP)
      IF(ISKIP.EQ.1) GO TO 1102
 1305 CONTINUE
      I = I+1
      if (i .gt. MAXAPT) then
           write(iout,2000) 'Angle Param Types', i, 'MAXAPT', MAXAPT
           call mexit(iout, 1)
      endif
      ITT(I) = MBT(1)
      JTT(I) = MBT(2)
      KTT(I) = MBT(3)
      TK(I) = TTK
      TEQ(I) = TTEQ
#ifdef CHARMM
      kub(i) = tkub
      rub(i) = rkub
#endif
      IF(IPARML.EQ.2)
#ifdef CHARMM
     +WRITE(IOUT,24) I,ITT(I),JTT(I),KTT(I),TK(I),TEQ(I),KUB(i),RUB(i)
#else
     +WRITE(IOUT,24) I,ITT(I),JTT(I),KTT(I),TK(I),TEQ(I)
#endif
      TEQ(I) = tteq * conv
      GO TO 1102
  103 NUMANG = I
C
C    ----- DIHEDRAL ANGLE PARAMETER INPUT -----
C
C          PLACE ALL SPECIFIC DIHEDRAL ANGLES AT END OF LIST
C
      IF(IPARML.ge.1) WRITE(IOUT,25)
      IPNTR(1) = 1
      IC = 0
      I = 0
c
c  --- first, read in the modified regular dihedrals:
c
      if (newfrc) then
   99   read(in4,'(a4)',end=2107) header
        if (header.ne.'DIHE' .and. header.ne.'dihe') go to 99
  104   CONTINUE
        READ(in4,17) (MBT(II),II = 1,4),IDIVF,TPK,TPHASE,TPN
        IF(MBT(1).EQ.IBLANK) GO TO 2107
        ttpn = abs(tpn)
        if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
          write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
          write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
          call mexit(6,1)
        endif
        DO 310 II = 1,4
          CALL CHKSYM(MBT(II),ISKIP)
          IF(ISKIP.EQ.1) GO TO 313
  310   CONTINUE
        I = I+1
        IC = IC+1
        if (i .gt. MAXDPT) then
           write(iout,2000) 'Reg Dihed Param Types',i,'MAXDPT',MAXDPT
           call mexit(iout, 1)
        endif
        IPT(I) = MBT(1)
        JPT(I) = MBT(2)
        KPT(I) = MBT(3)
        LPT(I) = MBT(4)
        PK(IC) = TPK
        PHASE(IC) = TPHASE
        PN(IC) = TPN
        IF(IDIVF.EQ.0) IDIVF = 1
        IF(IPARML.ge.1)
     +    WRITE(IOUT,926) I,IPT(I),JPT(I),KPT(I),LPT(I),IDIVF,PK(IC),
     +           PHASE(IC),PN(IC)
        PK(IC) = tpk / dble(IDIVF)
        PHASE(IC) = tphase * conv
  106   IF(PN(IC).GT.-0.00001) GO TO 105
        IC = IC+1
        if (ic .gt. MAXDPT) then
           write(iout,2000) 'Reg Dihed Param Types',ic,'MAXDPT',MAXDPT
           call mexit(iout, 1)
        endif
C
C       ----- THESE TERMS ARE ALSO DIVIDED BY IDIVF -----
C
        READ(in4,18) PK(IC),PHASE(IC),PN(IC)
        IF(IPARML.ge.1) WRITE(IOUT,27) PK(IC),PHASE(IC),PN(IC)
        ttpn = abs(pn(ic))
        if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
          write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
          write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
          call mexit(6,1)
        endif
        PK(IC) = PK(IC)/FLOAT(IDIVF)
        PHASE(IC) = PHASE(IC)*CONV
        GO TO 106
  105   CONTINUE
        IPNTR(I+1) = IC+1
        GO TO 104
C
C       ----- READ PAST OTHER CARDS THAT ARE PART OF SAME DIHEDRAL -----
C
  313   IF(TPN.GT.-0.00001) GO TO 104
        READ(in4,18) TPK,TPHASE,TPN
        GO TO 313
 2107   rewind (in4)
      endif
c
c     -- now read the standard, regular dihedrals
c
 1107 continue
      READ(in2,17) (MBT(II),II = 1,4),IDIVF,TPK,TPHASE,TPN
      IF(MBT(1).EQ.IBLANK) GO TO 107
      ttpn = abs(tpn)
      if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      DO 1310 II = 1,4
        CALL CHKSYM(MBT(II),ISKIP)
        IF(ISKIP.EQ.1) GO TO 1313
 1310 CONTINUE
      I = I+1
      IC = IC+1
      if (i .gt. MAXDPT) then
           write(iout,2000) 'Reg Dihed Param Types',i,'MAXDPT',MAXDPT
           call mexit(iout, 1)
      endif
      IPT(I) = MBT(1)
      JPT(I) = MBT(2)
      KPT(I) = MBT(3)
      LPT(I) = MBT(4)
      PK(IC) = TPK
      PHASE(IC) = TPHASE
      PN(IC) = TPN
      IF(IDIVF.EQ.0) IDIVF = 1
      IF(IPARML.EQ.2)
     +  WRITE(IOUT,26) I,IPT(I),JPT(I),KPT(I),LPT(I),IDIVF,PK(IC),
     +           PHASE(IC),PN(IC)
      PK(IC) = tpk / dble(IDIVF)
      PHASE(IC) = tphase * conv
 1106 IF(PN(IC).GT.-0.00001) GO TO 1105
      IC = IC+1
      if (ic .gt. MAXDPT) then
           write(iout,2000) 'Reg Dihed Param Types',ic,'MAXDPT',MAXDPT
           call mexit(iout, 1)
      endif
C
C     ----- THESE TERMS ARE ALSO DIVIDED BY IDIVF -----
C
      READ(in2,18) PK(IC),PHASE(IC),PN(IC)
      IF(IPARML.EQ.2) WRITE(IOUT,27) PK(IC),PHASE(IC),PN(IC)
        ttpn = abs(pn(ic))
        if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      PK(IC) = PK(IC)/FLOAT(IDIVF)
      PHASE(IC) = PHASE(IC)*CONV
      GO TO 1106
 1105 CONTINUE
      IPNTR(I+1) = IC+1
      GO TO 1107
C
C     ----- READ PAST OTHER CARDS THAT ARE PART OF SAME DIHEDRAL -----
C
 1313 IF(TPN.GT.-0.00001) GO TO 1107
      READ(in2,18) TPK,TPHASE,TPN
      GO TO 1313
  107 CONTINUE
      if (iparml .ge. 1) write(iout,'(/12x,a,/)') 'Improper Dihedrals:'
      NUMPHI = I
      NPTRA = IPNTR(I+1)-1
      I = 0
c
c  --- read the modified improper dihedrals
c
      if(newfrc) then 
 1108 read(in4,'(a4)',end=2207) header
      if (header.ne.'IMPR' .and. header.ne.'impr') go to 1108
  204 CONTINUE
      READ(in4,117) (MBT(II),II = 1,4),TPK,TPHASE,TPN
      IF(MBT(1).EQ.IBLANK) GO TO 2207
      ttpn = abs(tpn)
      if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      DO 350 JJ = 1,4
        CALL CHKSYM(MBT(JJ),ISKIP)
        IF(ISKIP.EQ.1) GO TO 351
  350 CONTINUE
      IC = IC+1
      I = I+1
      if (i .gt. MAXIPT) then
           write(iout,2000) 'Imp Dihed Param Types',i,'MAXIPT',MAXIPT
           call mexit(iout, 1)
      endif
      if (ic .gt. MAXDPT) then
           write(iout,2000) 'Dihed Param Pointers',ic,'MAXDPT',MAXDPT
           call mexit(iout, 1)
      endif
      IIPT(I) = MBT(1)
      JJPT(I) = MBT(2)
      KKPT(I) = MBT(3)
      LLPT(I) = MBT(4)
      PK(IC) = TPK
      PHASE(IC) = TPHASE
      PN(IC) = TPN
      IACT = NUMPHI+I
      IF(IPARML.ge.1)
     +WRITE(IOUT,9126) IACT,IIPT(I),JJPT(I),KKPT(I),LLPT(I),
     +                  PK(IC),PHASE(IC),PN(IC)
      PHASE(IC) = tphase * conv
  206 IF(PN(IC).GT.-0.00001) GO TO 205
      IC = IC+1
      READ(in4,218) PK(IC),PHASE(IC),PN(IC)
      IF(IPARML.ge.1) WRITE(IOUT,227) PK(IC),PHASE(IC),PN(IC)
      ttpn = abs(pn(ic))
      if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      PHASE(IC) = PHASE(IC)*CONV
      GO TO 206
  205 CONTINUE
      IPNTR(IACT+1) = IC+1
      GO TO 204
C
C     ----- READ PAST OTHER CARDS THAT ARE PART OF SAME DIHEDRAL -----
C
  351 IF(TPN.GT.-0.00001) GO TO 204
      READ(in4,18) TPK,TPHASE,TPN
      GO TO 351
c
c  --- now read the standard improper angles
c
 2207 rewind (in4)
      endif
 1207 continue
      READ(in2,117) (MBT(II),II = 1,4),TPK,TPHASE,TPN
      IF(MBT(1).EQ.IBLANK) GO TO 207
      ttpn = abs(tpn)
      if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      DO 1350 JJ = 1,4
        CALL CHKSYM(MBT(JJ),ISKIP)
        IF(ISKIP.EQ.1) GO TO 1351
 1350 CONTINUE
      IC = IC+1
      I = I+1
      if (i .gt. MAXIPT) then
           write(iout,2000) 'Imp Dihed Param Types',i,'MAXIPT',MAXIPT
           call mexit(iout, 1)
      endif
      if (ic .gt. MAXDPT) then
           write(iout,2000) 'Dihed Param Pointers',ic,'MAXDPT',MAXDPT
           call mexit(iout, 1)
      endif
      IIPT(I) = MBT(1)
      JJPT(I) = MBT(2)
      KKPT(I) = MBT(3)
      LLPT(I) = MBT(4)
      PK(IC) = TPK
      PHASE(IC) = TPHASE
      PN(IC) = TPN
      IACT = NUMPHI+I
      IF(IPARML.EQ.2)
     +WRITE(IOUT,126) IACT,IIPT(I),JJPT(I),KKPT(I),LLPT(I),
     +                  PK(IC),PHASE(IC),PN(IC)
      PHASE(IC) = tphase * conv
 1206 IF(PN(IC).GT.-0.00001) GO TO 1205
      IC = IC+1
      READ(IN2,218) PK(IC),PHASE(IC),PN(IC)
      IF(IPARML.EQ.2) WRITE(IOUT,227) PK(IC),PHASE(IC),PN(IC)
      ttpn = abs(pn(ic))
      if (ttpn.ne.1d0 .and. ttpn.ne.2d0 .and. ttpn.ne.3d0 .and. 
     .     ttpn.ne.4d0 .and. ttpn.ne.6d0) then
        write(6, *) ' Dihedral PN term must be 1,2,3,4, or 6:'
        write(6, '(4x, a4, a4, a4, a4)') (MBT(II),II = 1,4)
        call mexit(6,1)
      endif
      PHASE(IC) = PHASE(IC)*CONV
      GO TO 1206
 1205 CONTINUE
      IPNTR(IACT+1) = IC+1
      GO TO 1207
C
C     ----- READ PAST OTHER CARDS THAT ARE PART OF SAME DIHEDRAL -----
C
 1351 IF(TPN.GT.-0.00001) GO TO 1207
      READ(IN2,18) TPK,TPHASE,TPN
      GO TO 1351
  207 NUMPHN = I
      IF(NUMPHN.GT.0) NPTRA = IPNTR(IACT+1)-1
*     WRITE(IOUT,97) NUMBND,NUMANG !this is dumb.
*     WRITE(IOUT,98) NUMPHI,NUMPHN,NPTRA
C
C     ----- HYDROGEN BOND INPUT -----
C
      DO 119 I = 1, MAXHBP
      KHT1(I) = IBLANK
  119 CONTINUE
      if (iohb .eq. 1) then
           write(iout,'(/5x,a,/ /,5x,a,/5x,a)')
     +           'Hydrogen Bond Parameters:',
     +           ' Types       A           B',
     +           '------------------------------'
      endif
      NHB = 0
      IC = 0
c
c --- here we read the "standard" parameters first, then the
c     modifications, since the code setting up the "no" array
c     (below) uses the last correct values.
c
      DO 120 I = 1,10000
      READ(IN2,320) KT1,KT2,A,B,ASOLN,BSOLN,HCUT
      IF(KT1.EQ.IBLANK) GO TO 2119
      CALL CHKSYM(KT1,ISKIP)
      IF(ISKIP.EQ.1) GO TO 120
      CALL CHKSYM(KT2,ISKIP)
      IF(ISKIP.EQ.1) GO TO 120
C
      IC = IC+1
      if (ic .gt. MAXHBP) then
           write(iout,2000) 'HB Pair Params',ic,'MAXHBP',MAXHBP
           call mexit(iout, 1)
      endif
      KHT1(IC) = KT1
      KHT2(IC) = KT2
      ASOL(IC) = ASOLN
      BSOL(IC) = BSOLN
      AG(IC) = A
      BG(IC) = B
      HBCUT(IC) = HCUT*HCUT
*     IF(IOHB.EQ.1) WRITE(IOUT,340) KT1,KT2,A,B,ASOLN,BSOLN,HCUT,IC
      IF(IOHB.EQ.1) WRITE(IOUT,340) KT1,KT2,A,B
  120 CONTINUE
c
c --- now read the modifications
c
 2119 continue
      if(newfrc) then 
 1119 read(in4,'(a4)',end=2221) header
      if (header.ne.'HBON' .and. header.ne.'hbon') go to 1119
      DO 1120 I = 1,10000
      READ(in4,320) KT1,KT2,A,B,ASOLN,BSOLN,HCUT
      IF(KT1.EQ.IBLANK) GO TO 2221
      CALL CHKSYM(KT1,ISKIP)
      IF(ISKIP.EQ.1) GO TO 1120
      CALL CHKSYM(KT2,ISKIP)
      IF(ISKIP.EQ.1) GO TO 1120
C
      IC = IC+1
      if (ic .gt. MAXHBP) then
           write(iout,2000) 'HB Pair Params',ic,'MAXHBP',MAXHBP
           call mexit(iout, 1)
      endif
      KHT1(IC) = KT1
      KHT2(IC) = KT2
      ASOL(IC) = ASOLN
      BSOL(IC) = BSOLN
      AG(IC) = A
      BG(IC) = B
      HBCUT(IC) = HCUT*HCUT
*     IF(IOHB.EQ.1) WRITE(IOUT,340) KT1,KT2,A,B,ASOLN,BSOLN,HCUT,IC
      IF(IOHB.EQ.1) WRITE(IOUT,9340) KT1,KT2,A,B
 1120 CONTINUE
 2221 rewind (in4)
      endif
      NHB = IC
C
C     ----- READ IN REDEFINITIONS FOR NONBONDED INTERACTIONS -----
C
      DO 30 I = 1,NATYP
   30 IREDEF(I) = 0
      WRITE(IOUT,420)
C
C     ----- 1ST ATOM = TYPE OTHER ATOM TYPES ON CARD WILL BE SET
C                      EQUAL TO
C
      CALL SETEQV(NATYP,NHB,NXCHG,KNDSYM,IREDEF,IXCHG,JXCHG,KHT1,KHT2)
C
      CALL NBREDF(NTOTAT,IAC,IACPER,PERTUR)
C
      if (ntypes .gt. MAXNBT) then
           write(iout,2000) 'NB Atom Types',ntypes,'MAXNBT',MAXNBT
           call mexit(iout, 1)
      endif
C
*     WRITE(IOUT,420)
      WRITE(IOUT,421) NTYPES
      K = 0
      DO 220 I = 1,NTYPES
      DO 221 J = 1,I
      K = K+1
      NO(I,J) = K
      NO(J,I) = K
  221 CONTINUE
  220 CONTINUE
      DO 70 I = 1,NTYPES
   70 SOLTY(I) = 0.5
      ILOVE = 0
      IHATE = 0
      DO 71 I = 1,NATYP
      IJ = JREDEF(I)
      IF(IJ.EQ.0) GO TO 71
      IF(ISOLTY(I).EQ.0) GO TO 72
      SOLTY(IJ) = 0.
      ILOVE = ILOVE+1
      JSOLTY(ILOVE) = KNDSYM(I)
      GO TO 71
   72 IHATE = IHATE+1
      ISOLTY(IHATE) = KNDSYM(I)
   71 CONTINUE
*     IF(ILOVE.GT.0) WRITE(IOUT,74)
*     IF(ILOVE.GT.0) WRITE(IOUT,75) (JSOLTY(I),I = 1,ILOVE)
*     WRITE(IOUT,420)
*     IF(IHATE.GT.0) WRITE(IOUT,77)
*     IF(IHATE.GT.0) WRITE(IOUT,75) (ISOLTY(I),I = 1,IHATE)
      WRITE(IOUT,420)
C
C     ----- LOAD THE NONBONDED INPUT -----
C
      CALL NBINPT(NAMNB,NXCHG,IXCHG,JXCHG,NO,CN1,CN2,newfrc)
#ifdef CHARMM
c
c    ---- load a second set of parameters for 1-4 interactions
c
c         first, set default: 1-4 parms same as regular:
c
      do 78 i=1,MAXLJP
        cn114(i) = cn1(i)
        cn214(i) = cn2(i)
   78 continue
c
c   --- then, read in a new set of parameters, if available
c       NOTE!!!! the new set must be complete, and given in
c       the *same order* as the regular set, read in above.
c
      CALL NBINPT(NAMNB,NXCHG,IXCHG,JXCHG,NO,CN114,CN214,newfrc)
#endif
C
C     ----- STORE HB TYPES IN NO ARRAY WITH A NEGATIVE VALUE -----
C
      IF(NHB.EQ.0) GO TO 409
      DO 400 I = 1,NHB
      I1 = NHT1(I)
      IF(I1.EQ.0) GO TO 400
      J1 = NHT2(I)
      I1 = JREDEF(I1)
      J1 = JREDEF(J1)
      IF(I1.EQ.0.OR.J1.EQ.0) GO TO 400
      NO(I1,J1) = -I
      NO(J1,I1) = -I
*     WRITE(IOUT,401) I,KHT1(I),KHT2(I),I1,J1
  400 CONTINUE
  409 CONTINUE
      RETURN
c
c -----regular format statements
c
   10 FORMAT(20A4)
*  11 FORMAT(1H1,15X,20A4,/)
   11 FORMAT(20A4,/)
   12 FORMAT(20(A2,2X))
*  13 FORMAT(1H ,20X,'ATOMIC SYMBOLS',/)
*  14 FORMAT(10(4X,I3,1X,A2))
*  14 FORMAT(7(4X,I3,1X,A2))
   15 FORMAT(A2,1X,A2,2F10.2)
   16 FORMAT(A2,1X,A2,1X,A2,2X,4F10.2)
   17 FORMAT(A2,1X,A2,1X,A2,1X,A2,I4,3F15.2)
   18 FORMAT(15X,3F15.2)
   21 FORMAT(/ /,14X,'BOND PARAMETERS',/ /,12x,'Types    K       Req',/,
     +       12x,'---------------------')
*  22 FORMAT(4X,I5,3X,A2,'-',A2,5X,2F15.2)
   22 FORMAT(4X,I5,3X,A2,'-',A2,f7.1,F8.3)
  922 FORMAT('****',I5,3X,A2,'-',A2,f7.1,F8.3)
#ifdef CHARMM
   23 FORMAT(/ /,14X,'ANGLE PARAMETERS',/ /,12x,'Atom type   K     Teq',
     +       '        Kub       Rub',
     +       /,12x,'------------------------------------------------')
#else
   23 FORMAT(/ /,14X,'ANGLE PARAMETERS',/ /,12x,'Atom type   K     Teq',
     +       /,12x,'----------------------')
#endif
   24 FORMAT(4X,I5,3X,A2,'-',A2,'-',A2,f8.1,F8.2,2f10.3)
  924 FORMAT('****',I5,3X,A2,'-',A2,'-',A2,f8.1,F8.2,2f10.3)
   25 FORMAT(/ /,18X,'DIHEDRAL PARAMETERS',/ /,12x,
     +       'Atom type  IDIVF  PK    PHASE    PN',/,
     +       12x,'-----------------------------------')
*  26 FORMAT(4X,I5,3X,A2,'-',A2,'-',A2,'-',A2,I5,3F15.2)
   26 FORMAT(4X,I5,3X,3(A2,'-'),A2,I3,F8.2,f7.1,f6.0)
  926 FORMAT('****',I5,3X,3(A2,'-'),A2,I3,F8.2,f7.1,f6.0)
*  27 FORMAT(1H ,29X,3F15.2)
   27 FORMAT(26X,F8.2,f7.1,f6.0)
*  31 FORMAT(20(A2,2X))
*  38 FORMAT(1H ,2X,'ATOM TYPE',2X,A2,2X,'IS EQUIVALENT TO',2X,19(A2,
*    +       2X),/)
*  74 FORMAT(4X,'THE FOLLOWING ATOMS ARE HYDROPHILIC',/)
*  75 FORMAT(1H ,10X,20(A2,3X),/)
*  77 FORMAT(4X,'THE FOLLOWING ATOMS ARE HYDROPHOBIC',/)
*  97 FORMAT(/5X,'NUMBER OF BONDS =',I5,/5X,'NUMBER OF ANGLES =',
*    +    I5,/)
*  98 FORMAT(4X,'REGULAR DIHEDRALS  = ',I4,3X,
*    +          'IMPROPER DIHEDRALS  = ',I4,3X,'POINTERS  = ',I5,/)
  117 FORMAT(A2,1X,A2,1X,A2,1X,A2,4X,3F15.2)
* 126 FORMAT(4X,I5,3X,3(A2,'-'),A2,5X,3F10.2)
  126 FORMAT(4X,I5,3X,3(A2,'-'),A2,3X,F8.2,f7.1,f6.0)
 9126 FORMAT('****',I5,3X,3(A2,'-'),A2,3X,F8.2,f7.1,f6.0)
  180 FORMAT(A2,2F10.3)
* 181 FORMAT(21x,'MASSES',/)
* 182 FORMAT(5(3X,I3,'.',F8.3))
  218 FORMAT(20X,3F10.2)
* 227 FORMAT(1H ,37X,3F10.2)
  227 FORMAT(26X,F8.2,f7.1,f6.0)
  320 FORMAT(2X,A2,2X,A2,2X,5F10.2,I2)
* 340 FORMAT(2X,A2,2X,A2,2X,2(F10.1,2X,F11.2,2X),4X,'CUTOFF  = ',
*    +       F10.3,4X,'IC  = ',I3)
  340 FORMAT(5X,A2,2X,A2,2F12.1)
 9340 FORMAT('**** ',A2,2X,A2,2F12.1)
* 420 FORMAT(1H ,/)
  420 FORMAT()
  421 FORMAT(/,4x,'NUMBER OF NONBONDED TYPES  = ',I5,/)
* 401 FORMAT(4x,'HB ',I3,2X,A2,2X,A2,2X,'IS STORED IN NO(',I2,
*    +          ',',I2,')',/)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
