c-----------------------------------------------------------------------
      SUBROUTINE BONDFM
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- FORMS ALL POSSIBLE BONDS FROM JOIN ARRAY,EXCLUDING DUMMY
C           ATOMS USE BOND ANGLE ARRAY AS INTERMEDIATE STORAGE FOR
C           UNSORTED BOND ARRAY -----
C
c     RevA mod 28-feb-88 Reorder test for out of range index into ISYMBL()
c                        to avoid bound violation - G. Seibel
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/INFOP/NEXT,NUMEX(2500),NATEX(7500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DO 10 I = 1,NATOM
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 10
      J = NC(I)
      IF(J.LT.1) GO TO 10
      IF(ISYMBL(J).EQ.ISYMDU) GO TO 10
*     IF(J.LT.1) GO TO 10
      NBOND = NBOND+1
      IT(NBOND) = J
      JT(NBOND) = I
   10 CONTINUE
      IF(CUT.GT.0.0001) CALL LOOPC(CUT,ISYMDU)
      IF(NBOND.EQ.0) RETURN
C
      DO 60 I = 1,NBOND
      IPB(I) = I
   60 CONTINUE
      CALL SORTS(IT,JT,IPB,NBOND)
      DO 61 I = 1,NBOND
      NI = IPB(I)
      IB(I) = IT(NI)
      JB(I) = JT(NI)
   61 CONTINUE
      WRITE(IOUT,101)
      DO 5 I = 1,NBOND
      WRITE(IOUT,102) I,IB(I),JB(I)
    5 CONTINUE
      RETURN
  101 FORMAT(1H ,/ /,10X,'BONDS ',/)
  102 FORMAT(1H ,5X,3I6)
      END
