c-----------------------------------------------------------------------
      SUBROUTINE BONPAR
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE ANGL LIST -----
C
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/PARLIS/NTYPES,NBPAR,NGPAR,NDPAR,ISMPAR(2,1000),
     +              IBPAR(2,1000),JBPAR(2,1000),ITPAR(2,1000),
     +              JTPAR(2,1000), KTPAR(2,1000),IDPAR(2,1000),
     +       JDPAR(2,1000),KDPAR(2,1000),LDPAR(2,1000),ISMAT(2,1000)
C
      NBPAR = 0
      DO 200 I = 1,NBOND
      IAT = IB(I)
      JAT = JB(I)
      IF(IAT.LE.0 .OR. JAT.LE.0) GO TO 200
      IATY = ISMAT(1,IAT)
      JATY = ISMAT(1,JAT)
      IF(IATY.EQ.0 .AND. JATY.EQ.0) GO TO 200
      IATY = MIN0(ISMAT(2,IAT),ISMAT(2,JAT))
      JATY = MAX0(ISMAT(2,JAT),ISMAT(2,IAT))
      NBPAR = NBPAR+1
      IBPAR(1,NBPAR) = ISMPAR(1,IATY)
      JBPAR(1,NBPAR) = ISMPAR(1,JATY)
      IBPAR(2,NBPAR) = IAT
      JBPAR(2,NBPAR) = JAT
  200 CONTINUE
      MBPAR = 0
      DO 220 I = 1,NBPAR
      LABA = IBPAR(1,I)
      LABB = JBPAR(1,I)
      IF(LABA.EQ.0) GO TO 220
      DO 240 J = I+1,NBPAR
      IF(IBPAR(1,J).NE.LABA .OR. JBPAR(1,J).NE.LABB) GO TO 240
      IBPAR(1,J) = 0
      JBPAR(1,J) = 0
  240 CONTINUE
  220 CONTINUE
      DO 260 I = 1,NBPAR
      IF(IBPAR(1,I).EQ.0) GO TO 260
      MBPAR = MBPAR+1
      IBPAR(1,MBPAR) = IBPAR(1,I)
      JBPAR(1,MBPAR) = JBPAR(1,I)
      IBPAR(2,MBPAR) = IBPAR(2,I)
      JBPAR(2,MBPAR) = JBPAR(2,I)
  260 CONTINUE
      NBPAR = MBPAR
      RETURN
      END
