c-----------------------------------------------------------------------
      SUBROUTINE DIHEDI(NATOM,NPHI,IGRAPH,IP,JP,KP,LP)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO READ IMPROPER TORSION ANGLES -----
C
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      DIMENSION IGRAPH(*),IP(*),JP(*),KP(*),LP(*)
      DIMENSION IFLD(80),IHOL(10),IVAR(10),FVAR(10)
      DIMENSION MNA(2),MNB(2),MNC(2),MND(2)
C
      DATA IFLD/4*1, 76*0/
      DATA IBLNK/4H     /
C
C     ----- CLEAN UP THE DUMMY ARRAYS -----
C
      DO 100 I = 1,2
        MNA(I) = IBLNK
        MNB(I) = IBLNK
        MNC(I) = IBLNK
        MND(I) = IBLNK
  100 CONTINUE
C
      NI = 0
      I = 0
      WRITE(IOUT,9018)
  120 CONTINUE
        I = I+1
        CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
        MNA(1) = IHOL(1)
        MNB(1) = IHOL(2)
        MNC(1) = IHOL(3)
        MND(1) = IHOL(4)
        IF(IFDATP.GT.0) WRITE(IOUTC,9908) MNA(1),MNB(1),MNC(1),MND(1)
        IF(MNA(1).EQ.IBLNK) GO TO 140
        DO 160 J = 1,2
          IF(MNA(J).EQ.IBLNK) GO TO 180
          CALL FINDN(NATOM,MNA(J),INUM1,IGRAPH)
          CALL FINDN(NATOM,MNB(J),INUM2,IGRAPH)
          CALL FINDN(NATOM,MNC(J),INUM3,IGRAPH)
          CALL FINDN(NATOM,MND(J),INUM4,IGRAPH)
          if (INUM4.eq.-1) then
            write(iout, '(1x,a,a)') 
     +          ' Error: -M cannot be used in 4th position',
     +          ' for impropers'
            call mexit(iout, 1)
          endif
          IF(INUM1.EQ.-99.OR.INUM2.EQ.-99.OR.INUM3.EQ.-99.OR.
     +         INUM4.EQ.-99) then
            WRITE(IOUT,9108) MNA(J),MNB(J),MNC(J),MND(J)
          else
            NI = NI+1
            IP(NI) = INUM1
            JP(NI) = INUM2
            KP(NI) = INUM3
            LP(NI) = INUM4
            WRITE(IOUT,9118) NI,MNA(J),MNB(J),MNC(J),MND(J),
     +                   INUM1,INUM2,INUM3,INUM4
          endif
  160   CONTINUE
  180   CONTINUE
      GO TO 120
C
  140 NPHI = NI
      RETURN
 9018 FORMAT(/ /,5X,'IMPROPER TORSION ANGLES ',/)
 9118 FORMAT(5X,I5,'. ',4(A4,2X),2X,4I5)
 9908 FORMAT(10(1X,A4))
c
 9108 FORMAT(t2,'PREP-WARNING: No match could be found for '
     +      ,4(A4,2X),/ /)
      END
