c-----------------------------------------------------------------------
      SUBROUTINE DRAWL(NAT,ISYMDU,ISYMBL,ITREE)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO DRAW LINES BETWEEN SORTED BONDS -----
C
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/DRAWP/IC,ICODE(2,2000)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      DIMENSION ISYMBL(*),ITREE(*),ISTACK(60),JSTACK(60)
C
      DATA MAIN /1HM/
C
      IGO = 0
      NMAX = 60
      IS = NMAX
      LB = 1
      IC = 2
      IF(NBOND.GT.0) GO TO 1000
      IPLUS = NAT+1
      DO 1003 I = 1,IPLUS
      IF(ISYMBL(I).NE.ISYMDU) GO TO 1004
 1003 CONTINUE
      GO TO 1200
C
 1004 CONTINUE
      ICODE(1,1) = 0
      ICODE(2,1) = I
      ICODE(1,2) = 2
      ICODE(2,2) = 0
      GO TO 1001
 1000 CONTINUE
      JPRE = JB(1)
      ICODE(1,1) = 0
      ICODE(2,1) = IB(1)
      ICODE(1,2) = 1
      ICODE(2,2) = JPRE
    1 LB = LB+1
      IF(LB.GT.NBOND) GO TO 20
      IPRES = IB(LB)
      JPREV = JB(LB)
      IF(IPRES.GT.JPRE) GO TO 20
C
C     ----- THIS TEST SHOULD ONLY BE SATISFIED IF LOOP CLOSING BOND
C           WAS JUST DRAWN -----
C
      IPRE = ICODE(2,IC-1)
      IF(IPRES.LT.JPRE.AND.IPRES.NE.IPRE) GO TO 20
C
      IF(IPRES.LT.JPRE) GO TO 10
C
C     ----- FINISH STACK BEFORE DO MAIN-MAIN BOND -----
C
      IF(ITREE(IPRES).EQ.MAIN.AND.ITREE(JPREV).EQ.MAIN) GO TO 26
C
C     ----- DRAW BOND WITH PEN DOWN -----
C
    3 IC = IC+1
      ICODE(1,IC) = 1
      ICODE(2,IC) = JPREV
      JPRE = JPREV
      GO TO 1
   26 IGO = 1
      GO TO 20
   27 IGO = 0
C
C     ----- CHECK IF IB(LB+1) = IPRES,IF SO ,IT MUST BE A LOOP
C           CLOSING BOND -----
C
      IF((LB+1).GT.NBOND) GO TO 6
      IF(IB(LB+1).NE.IPRES) GO TO 6
      LB = LB+1
      IC = IC+1
      IPRE = JPRE
      JPRE = JB(LB)
      IF(IPRES.EQ.IPRE) GO TO 5
      ICODE(1,IC) = 0
      ICODE(2,IC) = JPRE
      IC = IC+1
      JPRE = IPRES
    5 ICODE(1,IC) = 1
      ICODE(2,IC) = JPRE
C
C     ----- RESTORE POINTER TO IPRES -----
C
    6 IF(IPRES.EQ.JPRE) GO TO 3
      IC = IC+1
      ICODE(1,IC) = 0
      ICODE(2,IC) = IPRES
      GO TO 3
C
C     ----- LOAD STACK FROM BOTTOM UP,PUTTING ALL BONDS WITH SAME
C           INITIAL ATOM IN ORDER FROM TOP - DOWN -----
C
   10 LBORIG = LB
   11 IF(IPRES.NE.IB(LB)) GO TO 12
      LB = LB+1
      IF(LB.GT.NBOND) GO TO 12
      GO TO 11
   12 LB = LB-1
      IS = IS-LB+LBORIG-1
      IF(IS.LT.0) GO TO 99
      IST = IS
      DO 14 J = LBORIG,LB
      IS = IS+1
      ISTACK(IS) = IB(J)
      JSTACK(IS) = JB(J)
   14 CONTINUE
C
C     ----- POINTER IN STACK IS 1 BEFORE TOP ELEMENT -----
C
      IS = IST
      GO TO 1
C
C     ----- MOVE WITH PEN UP TO FIRST ELEMENT IN STACK AND DRAW BOND
C
   20 IS = IS+1
      IF(IS.GT.NMAX) GO TO 100
      JST = JSTACK(IS)
      IST = ISTACK(IS)
      IF(IST.EQ.JPRE) GO TO 21
      IF(JST.EQ.JPRE) GO TO 22
      IC = IC+1
      ICODE(1,IC) = 0
      ICODE(2,IC) = IST
   21 IC = IC+1
      JPRE = JST
   23 ICODE(1,IC) = 1
      ICODE(2,IC) = JPRE
      IF(IGO.EQ.1) GO TO 26
      LB = LB-1
      GO TO 1
C
C     ----- THIS CASE ONLY OCCURS FOR LOOP CLOSING BONDS -----
C
   22 IC = IC+1
      JPRE = IST
      GO TO 23
   99 WRITE(IOUT,101)
      GO TO 1200
C
  100 IS = IS-1
      IF(IGO.EQ.1) GO TO 27
      IC = IC+1
      ICODE(1,IC) = 2
      ICODE(2,IC) = 0
 1001 CONTINUE
      IM = IC-1
      WRITE(IOUT,130)
      DO 50 I = 1,IM
      IF(ICODE(1,I).EQ.0) WRITE(IOUT,301) I,ICODE(2,I)
      IF(ICODE(1,I).EQ.1) WRITE(IOUT,302) I,ICODE(2,I)
   50 CONTINUE
      IF(LB.LE.NBOND) GO TO 200
      RETURN
  200 WRITE(IOUT,103) LB
 1200 CONTINUE
      call mexit(iout, 1)
  130 FORMAT(t2,'INSTRUCTIONS FOR PLOT',/)
  301 FORMAT(t2,I5,2X,'MOVE TO ATOM ',I5)
  302 FORMAT(t2,I5,2X,'DRAW TO ATOM ',I5)
c
  103 FORMAT(t2,'PREP-F-PLOTERR, Bottom of stack reached with'
     +,' LB  = ',I5,/)
  101 FORMAT(t2,'PREP-F-PLOTERR, number of elements in stack exceeded'
     +       ,/)
      END
