c-----------------------------------------------------------------------
      SUBROUTINE EDITDU(IOPT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C      ----- EDITS OUT ALL ATOMS WITH SYMBOL = ISYMDU IN POSITIONS
C            SPECIFIED BY IPOS -----
C            IOPT = 1 ONLY EXCHANGES ATOM LABELS AND COORDINATES
C                 = 0 EXCHANGES EVERYTHING
C
c     RevA mod: fixed format 9018 to be unambiguous ANSI., added blank line.
c               removed common/const/
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/ZMAT/R(1000),THETA(1000),PHI(1000)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DIMENSION C1(1000),C2(1000),C3(1000)
      EQUIVALENCE (X(1,1),C1(1)),(X(1,2),C2(1)),(X(1,3),C3(1))
C
      DATA KBEG /3HBEG/
      DATA KFIN /3HEND/
      DATA KALL /3HALL/
C
      ISTART = 1
      IOMITD = 0
      IF(IPOS.EQ.KFIN) GO TO 2
      IF(IPOS.EQ.KALL) IOMITD = 1
      I = 0
   10 I = I+1
C
C     ----- IF ALL ARE DUMMY STOP -----
C
      IF(I.GT.NATOM) GO TO 300
C
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 10
      ISTART = I
      IF(IPOS.EQ.KBEG.AND.ISTART.EQ.1) GO TO 280
    2 DO 20 J = ISTART,NATOM
   20 IF(ISYMBL(J).NE.ISYMDU) ILR = J
      WRITE(IOUT,9018) ISTART,ILR,NATOM
      IF(IPOS.NE.KBEG) NATOM = ILR
      IF(IPOS.EQ.KFIN) GO TO 280
C
      IP = 0
      L = ISTART-1
      DO 30 I = ISTART,NATOM
      IF(ISYMBL(I).EQ.ISYMDU.AND.IOMITD.EQ.1) GO TO 30
      IP = IP+1
      IGRAPH(IP) = IGRAPH(I)
      ISYMBL(IP) = ISYMBL(I)
      ITREE(IP) = ITREE(I)
      C1(IP) = C1(I)
      C2(IP) = C2(I)
      C3(IP) = C3(I)
      CHG(IP) = CHG(I)
      IF(IOPT.EQ.1) GO TO 30
      NA(IP) = NA(I)-L
      NB(IP) = NB(I)-L
      NC(IP) = NC(I)-L
      R(IP) = R(I)
      THETA(IP) = THETA(I)
      PHI(IP) = PHI(I)
      IROTAT(IP) = IROTAT(I)-L
   30 CONTINUE
      NATOM = IP
  280 CONTINUE
      RETURN
  300 CONTINUE
        WRITE(IOUT,9008)
      call mexit(iout, 1)
 9008 FORMAT(t2,'PREP-F-DUMMY, All atoms are DUMMY atoms ',/)
 9018 FORMAT(/,t2,'FIRST REAL ATOM =',I5,', LAST REAL ATOM =',I5,
     +       ', TOTAL ATOMS =',I5)
      END
