c-----------------------------------------------------------------------
      SUBROUTINE GETCHG(NAT,ISDU,ISB,CHG)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO GET THE CHARGES -----
C
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      DIMENSION ISB(*),CHG(*)
      DIMENSION BR(10),IFLD(80),IHOL(10),IVAR(10)
C
      DATA IFLD/5*3, 75*0/
C
C     ----- SET THE CHARGES FOR DUMMY ATOMS TO ZERO -----
C
      DO 100 I = 1,NAT
      IF(ISDU.NE.ISB(I)) GO TO 100
      CHG(I) = 0.0E0
  100 CONTINUE
C
C     ----- NOW READ THE CHARGES AND ALLOT THEM -----
C
      IP = 0
  120 CONTINUE
      CALL RFREE(IFLD,IHOL,IVAR,BR,IN,IOUT)
      DO 140 I = 1,5
  160 CONTINUE
      IP = IP+1
      IF(ISDU.NE.ISB(IP)) GO TO 180
      GO TO 160
  180 CONTINUE
      CHG(IP) = BR(I)
      IF(IP.GE.NAT) GO TO 200
  140 CONTINUE
      GO TO 120
  200 CONTINUE
      IF(IFDATP.GT.0) WRITE(IOUTC,9908) (CHG(I),I=1,NAT)
      RETURN
 9908 FORMAT(5F10.5)
      END
