c-----------------------------------------------------------------------
      SUBROUTINE GETDAT(SKIP,NAMF)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL SKIP,DBPUN
      CHARACTER*80 NAMF
C
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      COMMON/RUNHED/ITITL(20),ITLR(20)
C
      DIMENSION IFLD(80),IVAR(10),IHOL(10),FVAR(10)
C
      DATA KSTOP,KXYZ,KINT,KOMIT/4HSTOP,4HXYZ ,4HINT ,4HOMIT/
C
C     ----- READ THE CONTROL DATA -----
C
      DBPUN = IFDATP.GT.0
      READ(IN,9008) ITITL
      IF(DBPUN) WRITE(IOUTC,9008) ITITL
      IF(ITITL(1).EQ.KSTOP) SKIP = .TRUE.
      IF(SKIP) GO TO 100
C
C     ----- READ THE NAME OF THE OUTPUT FILE -----
C
      READ(IN,9028) NAMF
      IF(DBPUN) WRITE(IOUTC,9028) NAMF
C
      IFLD(1) = 1
      IFLD(2) = 1
      IFLD(3) = 2
      IFLD(4) = 0
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      NAMRES = IHOL(1)
      INTX = IHOL(2)
      KFORM = IVAR(1)
      IF(DBPUN) WRITE(IOUTC,9908) NAMRES,INTX,KFORM
C
      IFLD(3) = 1
      IFLD(4) = 1
      IFLD(5) = 0
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      IFIXC = IHOL(1)
      IOMIT = IHOL(2)
      ISYMDU = IHOL(3)
      IPOS = IHOL(4)
      IF(DBPUN) WRITE(IOUTC,9918) IFIXC,IOMIT,ISYMDU,IPOS
C
      IFLD(1) = 3
      IFLD(2) = 0
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      CUT = FVAR(1)
      IF(DBPUN) WRITE(IOUTC,9928) CUT
C
C     ----- PRINT OUT THE INFORMATION -----
C
      WRITE(IOUT,9018) ITITL
      WRITE(IOUT,9038) NAMRES
      IF(INTX.EQ.KXYZ) WRITE(IOUT,9048)
      IF(INTX.EQ.KINT) WRITE(IOUT,9058)
      IF(KFORM.NE.0) WRITE(IOUT,9088)
C
      WRITE(IOUT,9078) NAMF
C
      IF(CUT.GT.0.0001) WRITE(IOUT,9138) CUT
      IF(IOMIT.EQ.KOMIT) WRITE(IOUT,9148) IPOS,ISYMDU
      IF(IOMIT.NE.KOMIT) WRITE(IOUT,9158) ISYMDU
  100 CONTINUE
      RETURN
 9008 FORMAT(20A4)
 9018 FORMAT(/ /10X,20A4,/ /)
 9028 FORMAT(A80)
 9038 FORMAT(t2,'NAME OF MOLECULE  = ',3X,A4,/)
 9048 FORMAT(t2,'CARTESIAN COORDINATES WILL BE SAVED',/)
 9058 FORMAT(t2,'INTERNAL COORDINATES WILL BE SAVED',/)
 9078 FORMAT(t2,'OUTPUT FILE  = ',A80,/)
 9088 FORMAT(t2,'PREP OUTPUT WILL BE IN BINARY FORM',/)
 9138 FORMAT(t2,'LOOP CLOSING BOND DISTANCE  = ',F10.4,/)
 9148 FORMAT(t2,A4,1X,'DUMMY ATOMS WITH SYMBOL  =  ',A4,2X,
     +       'WILL BE DELETED',/)
 9158 FORMAT(t2, 'NO ATOMS ARE OMITTED, DUMMY ATOMS HAVE SYMBOL  = ',
     +       A4,/)
 9908 FORMAT(2(1X,A4),I5)
 9918 FORMAT(10(1X,A4))
 9928 FORMAT(F10.5)
      END
