c-----------------------------------------------------------------------
      SUBROUTINE LOOPI(NATOM,NBOND,IGRAPH,IT,JT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO READ THE LOOP CLOSING BONDS -----
C
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      DIMENSION IGRAPH(*),IT(*),JT(*)
      DIMENSION MNA(2),MNB(2),IFLD(80),IHOL(10),IVAR(10),FVAR(10)
C
      DATA IFLD/2*1, 78*0/
      DATA IBLNK/2H    /
C
      NI = 0
      WRITE(IOUT,9118)
C
C     ----- CLEAR THE DUMMY ARRAYS -----
C
      DO 200 I = 1,2
      MNA(I) = IBLNK
      MNB(I) = IBLNK
  200 CONTINUE
      I = 0
  100 CONTINUE
      I = I+1
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      MNA(1) = IHOL(1)
      MNB(1) = IHOL(2)
      IF(IFDATP.GT.0) WRITE(IOUTC,9908) MNA(1),MNB(1)
      IF(MNA(1).EQ.IBLNK) GO TO 180
      DO 120 J = 1,2
      IF(MNA(J).EQ.IBLNK) GO TO 140
      CALL FINDN(NATOM,MNA(J),INUM1,IGRAPH)
      CALL FINDN(NATOM,MNB(J),INUM2,IGRAPH)
      IF(INUM1.EQ.-99.OR.INUM2.EQ.-99) WRITE(IOUT,9108) MNA(J),MNB(J)
      IF(INUM1.EQ.-99.OR.INUM2.EQ.-99) GO TO 120
      IF(INUM1.LT.INUM2) GO TO 220
      ITEMP = INUM1
      INUM1 = INUM2
      INUM2 = ITEMP
  220 CONTINUE
      NI = NI+1
      IT(NI) = INUM1
      JT(NI) = INUM2
      WRITE(IOUT,9128) I,IGRAPH(INUM1),IGRAPH(INUM2),INUM1,INUM2
  120 CONTINUE
  140 CONTINUE
      GO TO 100
C
  180 NBOND = NI
      RETURN
c
 9118 FORMAT(/ /,t2,'LOOP CLOSING BONDS READ',/)
 9128 FORMAT(1H ,5X,I5,'. ',A4,2X,A4,2X,2I5)
 9908 FORMAT(10(1X,A4))
c
 9108 FORMAT(t2,'PREP-WARNING: Loop Atoms ',A4,2X,A4,' not found.',/)
      END
