c-----------------------------------------------------------------------
      SUBROUTINE ZMATX(NAT,X,Y,Z,R,THET,PHI,NC,NB,NA)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO GENERATE THE ZMATRIX -----
C
      DIMENSION X(*),Y(*),Z(*),R(*),THET(*),PHI(*)
      DIMENSION NC(*),NB(*),NA(*)
C
      DO 100 I = 1,NAT
      J = NC(I)
      K = NB(I)
      L = NA(I)
      IF(J.LT.1) GO TO 120
      CALL DIST(I,J,X,Y,Z,VAL)
      R(I) = VAL
      IF(K.LT.1) GO TO 120
      CALL BANGLE(I,J,K,X,Y,Z,VAL,1)
      THET(I) = VAL
      IF(L.LT.1) GO TO 120
      CALL TORS(I,J,K,L,X,Y,Z,VAL)
      PHI(I) = VAL
  120 CONTINUE
  100 CONTINUE
      RETURN
      END
